/**
 * @note Copyright (c) 2006  Sagem Communication All rights reserved
 *
 * @file irq_generic.c
 * @version 1.0
 * @date 25/11/2006
 * @author Sagem Communication
 * @brief 
**/
#include <linux/sbi_k.h>
#include <adi6843.h>

typedef struct {
	unsigned long	ipc_id;		/* Interrupt controller ID */
	unsigned long	pad1[0x3f];	/* Reserved */
	unsigned long	cpe_prio[8];	/* CPE Interrupt Priority Registers */
	unsigned long	ap_prio;	/* AP Interrupt Priority Register */
	unsigned long	pad2;		/* Reserved */
	int_stat_t	cpe_stat[11];	/* CPE Interrupt Status Registers*/
	int_stat_t	emac_stat[3];	/* EMAC AP Interrupt Status Registers */
	int_stat_t	bmu_stat;	/* BMU AP Interrupt Status Registers */
	int_stat_t	spa_stat;	/* SPA AP Interrupt Register */
	int_stat_t	pci_stat;	/* PCI Interrupt Registers */
	unsigned long	pad3[0x54];	/* Reserved */
	unsigned long	cpe_per;	/* CPE Peripheral Interrupt */
} ipc_t_200;

typedef struct {
        unsigned long   ipc_id;         /* Interrupt controller ID */
        unsigned long   pad1[0x3f];     /* Reserved */
        unsigned long   cpe_prio[10];   /* CPE Interrupt Priority Registers */
        int_stat_t      cpe_stat[10];   /* CPE Interrupt Status Registers*/
        int_stat_t      emac_stat[3];   /* EMAC AP Interrupt Status Registers */
        int_stat_t      bmu_stat;       /* BMU AP Interrupt Status Registers */
        int_stat_t      peri_stat;      /* Peripheral AP Interrupt Register */
        int_stat_t      pci_stat;       /* PCI Interrupt Registers */
        unsigned long   pad3[0x54];     /* Reserved */
        unsigned long   cpe_per;        /* CPE Peripheral Interrupt */
} ipc_t_160;


/*
 *
 * on duplique les fonctions et variables
 * qui sont suffixes par _160 ou _200
 *
 * pas beau, mais tres peu intrusif pour le code Ikanos :-)
 * 
 */

/* ----------------------- BEGIN COMMON SECTION ----------------------- */
#ifdef CONFIG_FUSIV_VX160
#undef CONFIG_FUSIV_VX160
#endif /*CONFIG_FUSIV_VX160*/

#ifdef CONFIG_FUSIV_VX200
#undef CONFIG_FUSIV_VX200
#endif /*CONFIG_FUSIV_VX200*/



#define IRQ_COMMON
#include "irq.c"

#undef IRQ_COMMON


#ifdef CONFIG_FUSIV_VX160
#undef CONFIG_FUSIV_VX160
#endif /*CONFIG_FUSIV_VX160*/

#ifdef CONFIG_FUSIV_VX200
#undef CONFIG_FUSIV_VX200
#endif /*CONFIG_FUSIV_VX200*/
/* ----------------------- END COMMON SECTION ----------------------- */






/* ----------------------- BEGIN VX160 SECTION ----------------------- */

#define CONFIG_FUSIV_VX160 1 

#define adi6843_prio 	adi6843_prio_160
#define ipc_t 		ipc_t_160
#define ipc 		ipc_160
#define startup_irq     startup_irq_160
#define shutdown_irq    shutdown_irq_160
#define end_irq         end_irq_160
#define mask_and_ack_irq	mask_and_ack_irq_160
#define local_enable_irq	local_enable_irq_160
#define local_disable_irq	local_disable_irq_160
#define adi_6843		adi_6843_160
#define fusiv_init_IRQ	        fusiv_init_IRQ_160 	
#define _adi_6843_dispatch_irq	_adi_6843_dispatch_irq_160 

#include "irq.c"

#undef adi6843_prio 	
#undef ipc_t 		
#undef ipc 		
#undef startup_irq     
#undef shutdown_irq    
#undef end_irq         
#undef mask_and_ack_irq
#undef local_enable_irq
#undef local_disable_irq
#undef adi_6843	
#undef fusiv_init_IRQ 
#undef _adi_6843_dispatch_irq


#ifdef CONFIG_FUSIV_VX160
#undef CONFIG_FUSIV_VX160
#endif /*CONFIG_FUSIV_VX160*/

#ifdef CONFIG_FUSIV_VX200
#undef CONFIG_FUSIV_VX200
#endif /*CONFIG_FUSIV_VX200*/
/* ----------------------- END VX160 SECTION ----------------------- */








/* ----------------------- START VX200 SECTION ----------------------- */

#define CONFIG_FUSIV_VX200 1 

#define adi6843_prio 	adi6843_prio_200
#define ipc_t 		ipc_t_200
#define ipc 		ipc_200
#define startup_irq     startup_irq_200
#define shutdown_irq    shutdown_irq_200
#define end_irq         end_irq_200
#define mask_and_ack_irq	mask_and_ack_irq_200
#define local_enable_irq	local_enable_irq_200
#define local_disable_irq	local_disable_irq_200
#define adi_6843		adi_6843_200
#define fusiv_init_IRQ	        fusiv_init_IRQ_200 	
#define _adi_6843_dispatch_irq	_adi_6843_dispatch_irq_200 



#include "irq.c"


#undef adi6843_prio 	
#undef ipc_t 		
#undef ipc 		
#undef startup_irq     
#undef shutdown_irq    
#undef end_irq         
#undef mask_and_ack_irq
#undef local_enable_irq
#undef local_disable_irq
#undef adi_6843	
#undef fusiv_init_IRQ 
#undef _adi_6843_dispatch_irq



#ifdef CONFIG_FUSIV_VX160
#undef CONFIG_FUSIV_VX160
#endif /*CONFIG_FUSIV_VX160*/

#ifdef CONFIG_FUSIV_VX200
#undef CONFIG_FUSIV_VX200
#endif /*CONFIG_FUSIV_VX200*/
/* ----------------------- END VX200 SECTION ----------------------- */











/* ----------------------- START WRAPPER SECTION ----------------------- */

void adi_6843_dispatch_irq(int prio, struct pt_regs *regs)
{
	switch(CPU_ID) {
	case 0x6836: 	
		_adi_6843_dispatch_irq_160(prio, regs); 
		break;
	case 0x6833 ... 0x6834: 	
		_adi_6843_dispatch_irq_200(prio, regs); 
		break;
	default:BUG();
	}
}	

/* ----------------------- END WRAPPER SECTION ----------------------- */

