#ifndef GPIO_LAYOUT_H
#define GPIO_LAYOUT_H

/* Last element of the tab must be {0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,""} */
struct gpio_access_struct_t {
	unsigned short * set_addr;    /* Address to use to swich on (or to read the status) */
	unsigned short * reset_addr;  /* Address to use to switch off */
	unsigned long dev_bitmask;    /* A mask containing a single 1 for the line number for the device */
	unsigned long dev_offset;     /*  contain 16 (for GPIO2) or 0 (GPIO1) */
	unsigned long dev_direction;  /* 1 is output, 0 is input. (buttons are inputs) */
//#if defined CONFIG_SAGEM_BOXER || defined CONFIG_SAGEM_FAST34XX
#ifdef CONFIG_SAGEM_GENERIC_CARD_SUPPORT
	unsigned long polarity;       /* 1 active low , 0 active high    */
	unsigned long interruption;
#else // CONFIG_SAGEM_GENERIC_CARD_SUPPORT
	#if ( defined(CONFIG_SAGEM_BOXER) && ! defined(CONFIG_SAGEM_GPIO_ULT_FOR_BOXER_FW) ) || ( defined(CONFIG_SAGEM_LBV2ULT) && defined(CONFIG_SAGEM_GPIO_BOXER_FOR_ULT_FW) ) || defined (CONFIG_SAGEM_FAST34XX)
	unsigned long polarity;       /* 1 active low , 0 active high    */
	#endif
//#ifdef CONFIG_SAGEM_BOXER
	#if ( defined(CONFIG_SAGEM_BOXER) && ! defined(CONFIG_SAGEM_GPIO_ULT_FOR_BOXER_FW) ) || ( defined(CONFIG_SAGEM_LBV2ULT) && defined(CONFIG_SAGEM_GPIO_BOXER_FOR_ULT_FW) )
	unsigned long interruption;
	#endif /* CONFIG_SAGEM_BOARD_BOXER_P1 */
#endif // CONFIG_SAGEM_GENERIC_CARD_SUPPORT
	unsigned long dev_exclude;    /* 1 mean this line is externally driven, do not touch the config */
	char          name[128];
};

/* This constant structure array maps the peripherals onto the GPIO line.
   It is used by the functions to determine the addresses to use and the
   direction of the line when configuring, reading the state or toggling a led.
   It *HAS* to be kept in sync whith the enum above.
   The last one must have 0 values everywhere, as a end of array marker.
*/

extern struct gpio_access_struct_t gpio_access[];

#endif
