/**
 * @note Copyright (c) 2006  Sagem Communication All rights reserved
 *
 * @file sbi_defs.h
 * @version 1.0
 * @date 25/11/2006
 * @author Sagem Communication
 * @brief 
**/
#ifndef _SBI_DEFS_H
#define _SBI_DEFS_H

#include <linux/sbi_k.h>


#define ADI_CPU_TYPE  (*((volatile unsigned long *)0xb900003c)) 
#define CPU_ID              ADI_CPU_TYPE
#define IS_CPU_VOX160 (CPU_ID==0x6836)
#define IS_CPU_VOX200 (CPU_ID==0x6834)
#define IS_CPU_VOX150 (CPU_ID==0x6833)


#define ADI_6843_MAX_INTS	 ( (sbi && sbi->int_nums) ? sbi->int_nums->adi_6843_max_ints:  32 )
#define AP_DMA_INT       	 ( (sbi && sbi->int_nums) ? sbi->int_nums->ap_dma_int	    :  -1 )
#define ARB2_INT         	 ( (sbi && sbi->int_nums) ? sbi->int_nums->arb2_int	    :  12 )
#define ARB3_INT         	 ( (sbi && sbi->int_nums) ? sbi->int_nums->arb3_int	    :  27 )
#define ARB_INT          	 ( (sbi && sbi->int_nums) ? sbi->int_nums->arb_int	    :	1 )
#define BMU_INT          	 ( (sbi && sbi->int_nums) ? sbi->int_nums->bmu_int	    :  31 )
#define DMA_INT          	 ( (sbi && sbi->int_nums) ? sbi->int_nums->dma_int	    :	0 )
#define DSP0_FL0_INT     	 ( (sbi && sbi->int_nums) ? sbi->int_nums->dsp0_fl0_int     :  17 )
#define DSP0_FL1_INT     	 ( (sbi && sbi->int_nums) ? sbi->int_nums->dsp0_fl1_int     :  18 )
#define DSP0_PF0_INT     	 ( (sbi && sbi->int_nums) ? sbi->int_nums->dsp0_pf0_int     :  19 )
#define DSP0_PF1_INT     	 ( (sbi && sbi->int_nums) ? sbi->int_nums->dsp0_pf1_int     :  20 )
#define DSP1_FL0_INT     	 ( (sbi && sbi->int_nums) ? sbi->int_nums->dsp1_fl0_int     :  21 )
#define DSP1_FL1_INT     	 ( (sbi && sbi->int_nums) ? sbi->int_nums->dsp1_fl1_int     :  22 )
#define DSP1_PF0_INT     	 ( (sbi && sbi->int_nums) ? sbi->int_nums->dsp1_pf0_int     :  23 )
#define DSP1_PF1_INT     	 ( (sbi && sbi->int_nums) ? sbi->int_nums->dsp1_pf1_int     :  24 )
#define EMAC1_INT        	 ( (sbi && sbi->int_nums) ? sbi->int_nums->emac1_int	    :  14 )
#define EMAC2_INT        	 ( (sbi && sbi->int_nums) ? sbi->int_nums->emac2_int	    :  13 )
#define EMAC3_INT        	 ( (sbi && sbi->int_nums) ? sbi->int_nums->emac3_int	    :  26 )
#define GPIO2_INT        	 ( (sbi && sbi->int_nums) ? sbi->int_nums->gpio2_int	    :  -1 )
#define GPIO_INT         	 ( (sbi && sbi->int_nums) ? sbi->int_nums->gpio_int	    :	8 )
#define GPT1_INT         	 ( (sbi && sbi->int_nums) ? sbi->int_nums->gpt1_int	    :	9 )
#define GPT2_INT         	 ( (sbi && sbi->int_nums) ? sbi->int_nums->gpt2_int	    :  10 )
#define GPT3_INT         	 ( (sbi && sbi->int_nums) ? sbi->int_nums->gpt3_int	    :  11 )
#define IDMA1_INT        	 ( (sbi && sbi->int_nums) ? sbi->int_nums->idma1_int	    :  16 )
#define IDMA2_INT        	 ( (sbi && sbi->int_nums) ? sbi->int_nums->idma2_int	    :  15 )
#define IDMA3_INT        	 ( (sbi && sbi->int_nums) ? sbi->int_nums->idma3_int	    :  -1 )
#define PCI_INT          	 ( (sbi && sbi->int_nums) ? sbi->int_nums->pci_int	    :  25 )
#define PER_INT          	 ( (sbi && sbi->int_nums) ? sbi->int_nums->per_int	    :  -1 )
#define SCU_INT          	 ( (sbi && sbi->int_nums) ? sbi->int_nums->scu_int	    :	2 )
#define SPA_INT          	 ( (sbi && sbi->int_nums) ? sbi->int_nums->spa_int	    :  30 )
#define SPHY_INT         	 ( (sbi && sbi->int_nums) ? sbi->int_nums->sphy_int	    :  -1 )
#define SPI_INT          	 ( (sbi && sbi->int_nums) ? sbi->int_nums->spi_int	    :	7 )
#define SPORT2_RX_INT    	 ( (sbi && sbi->int_nums) ? sbi->int_nums->sport2_rx_int    :  -1 )
#define SPORT2_TX_INT    	 ( (sbi && sbi->int_nums) ? sbi->int_nums->sport2_tx_int    :  -1 )
#define UART1_INT        	 ( (sbi && sbi->int_nums) ? sbi->int_nums->uart1_int	    :	6 )
//#define UART2            	 ( (sbi && sbi->int_nums) ? sbi->int_nums->uart2	    :  -1 )
#define UART2_INT        	 ( (sbi && sbi->int_nums) ? sbi->int_nums->uart2_int	    :  29 )
#define USBH_INT         	 ( (sbi && sbi->int_nums) ? sbi->int_nums->usbh_int	    :  -1 )
#define USB_INT          	 ( (sbi && sbi->int_nums) ? sbi->int_nums->usb_int	    :	3 )
#define WIU1_INT         	 ( (sbi && sbi->int_nums) ? sbi->int_nums->wiu1_int	    :	5 )
#define WIU2_INT         	 ( (sbi && sbi->int_nums) ? sbi->int_nums->wiu2_int	    :	4 )



#define RAM_SIZE         	(sbi ? sbi->sdram_size : 16)
#define FLASH_SIZE         	(sbi ? sbi->flash_size : 8)

//#define CPU_ID         		ADI_CPU_TYPE
#define BOARD_NAME         	(sbi ? sbi->board_name : "NONE")

//#define bmap_tasklet        (sbi->sbi_bmap_tasklet) // OPN & FR 20070928 BUG 6869 DL WAN REBOOT

//#define bmap_tasklet 		(sbi ? sbi->sbi_bmap_tasklet : bmap_tasklet_200)

/* #define gpio_access		(sbi ? sbi->gpios : NULL) */

#define ADSL_GPIO_RESET		(sbi ? sbi->adsl_gpio_reset_bit : 14)

#define NUM_EMAC_PORTS		2 /* Modif FR (sbi ? sbi->num_emac_ports : 2) */


#define MTD_PARTITION_JFFS2_OFFSET  (sbi ? sbi->mtd_partition_jffs2_offset : 0x00380000)
#define MTD_PARTITION_JFFS2_SIZE    (sbi ? sbi->mtd_partition_jffs2_size   : 0x00070000)

#define FIRST_PCI_PIN		(sbi ? sbi->first_pci_pin : 21)

#endif /*_SBI_DEFS_H*/
