/* ============================================================================
 *
 * Copyright (C) 2001 Analog Devices Inc. All rights reserved
 *
 * The information and source code contained herein is the exclusive property
 * of Analog Devices and may not be disclosed, examined or reproduced in whole
 * or in part without the explicit written authorization from Analog Devices.
 *
 * ============================================================================
 */

#include <oswrapper.h>
#if TONE_GEN
#include "../dsplib/ToneGenCons.h"
#include "../dsplib/ToneProto.h"
#endif
#if FXO_MODULE
#include "../dsplib/CidRxCon.h"
#endif
#if KRTP
#include "../krtp/rtpgdef.h"
#endif

/*For V.21 detection  */
Word16 gV21DetDone[MAX_VOICE_CHANNELS];
Word16 gV21DetFlag[MAX_VOICE_CHANNELS];
Word16 gV21IntrCntr[MAX_VOICE_CHANNELS];
Word16 gV21DetCntr[MAX_VOICE_CHANNELS];

#if FXS_ToneDtmf_ACTIVE
#include "../slic/silabs/include/si3216_tone.h"
#endif

#include "voiceSysCtl.h"
#if DRV_DEBUG_STAT
extern VoiceDebugStat_t VoiceDebugStat[];
#endif

BOOL gSINreceived[MAX_VOICE_CHANNELS];

#if T38
BOOL gbT38Negotiated[MAX_VOICE_CHANNELS];
UINT32 gSINcntr[MAX_VOICE_CHANNELS];
VoiceCirQ_t gT38RxQ[MAX_VOICE_CHANNELS];
VoiceCirQ_t gT38TxQ[MAX_VOICE_CHANNELS];
t38Pkt_t gT38RxDataBuffer[MAX_VOICE_CHANNELS][MAX_T38_Q_LEN];
t38Pkt_t gT38TxDataBuffer[MAX_VOICE_CHANNELS][MAX_T38_Q_LEN];
#endif

extern UINT16 InterfaceFlag;
UCHAR dspDataMode[MAX_VOICE_CHANNELS];
/* Command Queue */
CommandBuffer gaComandQ[MAX_VOICE_CHANNELS];
UINT16 dsp2HostDataHeader[MAX_VOICE_CHANNELS];
UINT16 dsp2HostData[MAX_PAYLOAD_SIZE_IN_WORDS];
CommandQ       DtmfrxCmdList[MAX_VOICE_CHANNELS];

UINT16 spPacketLen[9] = {80, 80, 20, 30, 40, 50, 10, 20, 24 };
UINT16 spPacketLen_5ms[9] = {40, 40, 20, 30, 40, 50, 10, 20, 24 };
UCHAR ucG7115msIntrFlag[MAX_VOICE_CHANNELS]= {0};
UINT16 vadPacketLen[9] = {1, 1, 1, 1, 1, 1, 2, 4, 4 };
CommandQ        chCmdList[MAX_VOICE_CHANNELS][MAX_CMD_LIST];
INT32             chCmdListIndex[MAX_VOICE_CHANNELS];
INT16           g723count[MAX_VOICE_CHANNELS];
UCHAR gDataModeEnable = 0;
UINT16 pktCount[MAX_VOICE_CHANNELS];
UINT32 ulTimeStampCntA[MAX_VOICE_CHANNELS];
UCHAR setIntrFlag[MAX_VOICE_CHANNELS];
extern JitBuffType_  SMMJitBuff[MAX_VOICE_CHANNELS];
extern WtRtpPktType_ WtRTPPkt;
UINT16 dsp_bank_select_counter = 0;
DspStateInfo_t gaDspStateInfo[MAX_VOICE_CHANNELS];
DspipcAddr   dspipcAddress[MAX_DSP_NUM];
extern UINT32 dummy_value, *dummy_read_addr;

DSPTimerInfo_t gaDSPTimerInfo[MAX_VOICE_CHANNELS];
#if TONE_GEN
INT32 ToneLen;
Word16 speech[80];
extern Word16 SMM_ToneGenEna[MAX_VOICE_CHANNELS];
extern Word16 SMM_ToneType[MAX_VOICE_CHANNELS];
extern Word16 SMM_bUseGeneric[];
extern Word16 SMM_CadCntr[];
extern Word16 SMM_CadCnt[];
extern void ToneInit(Word16 CurChanNum);
extern void initCad(Word16 CurChan);
extern void ToneInitGeneral(Word16, Word16);
extern Word16 SMM_ToneInit_flag[];
extern FOURCADENCE_TONE_TYPE ToneParams[];
extern Word16 SMM_continuousToneFlg[];
#endif

#if FXO_MODULE
extern Word16 FlagDetectBusyTone[];
extern Word16 FlagDetectDialTone[];
VoiceCirQ_t gaFxo2HostQ;
CmdDigitInfo_t gaFxo2HostCmdBuf[MAX_DSP2HOST_CMDQ_BUFFS];
UCHAR aucToneGenOnFxoFlag[MAX_VOICE_CHANNELS];
#endif
extern Word16 SMM_CadPlayStopFlag[];
extern Word16 SMM_ToneDurationCntr[];
#if CALLER_IDTx
 extern CidTxType_  SMM_CidTx[MAX_VOICE_CHANNELS];
 extern UCHAR ucCallerIdIntrHandler[];
 VoiceQ_t cidPkt;
// LCe OpenRG Hollande
 extern void dtmfCidGenerationFlag(Word16 ucPortNo);
 extern dtmfCidType_ dtmfCidGen[MAX_VOICE_CHANNELS];
// LCe OpenRG Hollande
#endif

VoiceCirQ_t gVoiceTxQ[MAX_VOICE_CHANNELS];
VoiceCirQ_t gaDsp2HostQ;

VoiceQ_t *gVoiceBuf[MAX_VOICE_CHANNELS];
INT16 getEncDecType(UINT16 uiEncDecType);
VoiceQ_t gVoiceTxQBuffer[MAX_VOICE_CHANNELS][MAX_TX_VOICE_Q];
CmdDigitInfo_t gaDsp2HostCmdBuf[MAX_DSP2HOST_CMDQ_BUFFS];
static DspipcRegFunct  dspRegFunctions;
UINT16 d2h_cmd_addr[MAX_DSP_NUM];
UINT16 d2h_data_addr[MAX_DSP_NUM];
UINT16 h2d_cmd_addr[MAX_DSP_NUM];
UINT16 h2d_data_addr[MAX_DSP_NUM];
#if  DTMFRX
UINT16 DtmfrxMemAdd[MAX_DSP_NUM];
extern Word16 HDtmfrx_reset_on[MAX_VOICE_CHANNELS];
extern uWord16  SMMDtmfrxDSP2HostBuff[MAX_VOICE_CHANNELS][DTMFRX_DSP2HOST_BUFF_LEN];
UINT16 cw1;
#endif
#if VOX_DRIVERS_CONTROL
static UCHAR dspipcDriverControl = 0;
#endif


#if G711_PLC
UINT16 first_goodpacket[MAX_VOICE_CHANNELS]={0,0};
UINT16 PrevSidEnable_VAD[MAX_VOICE_CHANNELS]={1,1};
#endif

/** Base statistics. */
extern struct dsp_voiceSysCtl_str dsp_voiceSysCtl;
#if KERNEL_RTP_INTERFACE
extern dsp_regNetwork_t *pNWCallBack;
#endif

#if DECT_MODULE
extern int dectPassThrEnabled(int port);
extern int dectReadVoicePkt(int port);
#endif


/**********************************************************************************
 *  Function Name  : dspipcGetCmdBuf.                                             *
 *  Description    : Function to provide free buffer DSP command.                 *
 *  Input          : Port Number.                                                 *
 *  Output         : None.                                                        *
 *  Return Value   : CommandQ.                                                    *
 *********************************************************************************/
static CommandQ* dspipcGetCmdBuf(INT32 portNum)
{
  INT32 index = ( (gaComandQ[portNum].writePtr +1)
                                % MAX_COMMANDQ_BUF);
  return &(gaComandQ[portNum].commands[index]);
}
/**********************************************************************************
 *  Function Name  : dspipcEnqCommand.                                            *
 *  Description    : Function to enqueue DSP command.                             *
 *  Input          : Port Number.                                                 *
 *  Output         : None.                                                        *
 *  Return Value   : None.                                                        *
 *********************************************************************************/
static void dspipcEnqCommand(INT32 portNum)
{
  gaComandQ[portNum].writePtr = ( (gaComandQ[portNum].writePtr +1)
				% MAX_COMMANDQ_BUF);
  /* For circular Q we have same condition for empty and
     full. I assume, the command queue will never be full
     and if it is full, some thing wrong with the system,
     better to assume it empty. */
}
/**********************************************************************************
 *  Function Name  : dspipcResetAllPorts.                                         *
 *  Description    : Function to reset DSP Ports at power on time.                *
 *  Input          : None.                                                        *
 *  Output         : None.                                                        *
 *  Return Value   : None.                                                        *
 *********************************************************************************/
void dspipcResetAllPorts(void)
{
  INT32 i;
  CommandQ  *commandBuf = dspipcGetCmdBuf(0);
  /* Enqueue Reset Command */
  commandBuf->command[0] = H2D_RESET_ALL_CH_CMD;
  commandBuf->command[1] = 0;
  dspipcEnqCommand(0);
  gDataModeEnable = 0;
  for( i = 0; i< MAX_VOICE_CHANNELS; i++)
  {
    g723count[i] = 0;
    dspipcResetStateInfo(i,0);
    dspipcClearQs(i);
    dspDataMode[i] = DSP_DATA_INACTIVE ;
  }
#if KERNEL_RTP_INTERFACE /* { */
/* EBd BUG 3121 */
  if ( (pNWCallBack != (dsp_regNetwork_t *)0) && (pNWCallBack->evtFromDsp != (dsp_network_evtFromDsp_f)0) ) {
#ifdef VOICE_SYSCTL_STATS
    /* Stats */
    dsp_voiceSysCtl.stats.network.sndResetAllPorts++;
#endif
    pNWCallBack->evtFromDsp(DSP_NETWORK_Evt_fromDsp_reset_all_port, -1, (void *)0);
  }
/* end BUG 3121 */
#endif /* } */
}
/**********************************************************************************
 *  Function Name  : dspipcInitPort.                                              *
 *  Description    : Function to Initialize dsp port.                             *
 *  Input          : Port Number and Voice Options.                               *
 *  Output         : None.                                                        *
 *  Return Value   : None.                                                        *
 *********************************************************************************/
void dspipcInitPort(UINT16 portNum, VoiceOptions *vo)
{
  UINT16  tempWord;
  CommandQ  *commandBuf = dspipcGetCmdBuf(portNum);
  gaDspStateInfo[portNum].uiEncoder = getEncDecType(vo->encoder_opt[0]);
  gaDspStateInfo[portNum].uiDecoder = getEncDecType(vo->decoder_opt[0]);
  printk("%s force config PCMU\n",__FUNCTION__);
  if (gaDspStateInfo[portNum].uiEncoder == DSP_G722) {
  	gaDspStateInfo[portNum].uiEncoder = DSP_PCMU;
  }
  if (gaDspStateInfo[portNum].uiDecoder == DSP_G722) {
  	gaDspStateInfo[portNum].uiDecoder = DSP_PCMU;
  }
#if DYNAMIC_CODEC_DOWNLOAD
  dspipcChangeDSPImage(portNum, gaDspStateInfo[portNum].uiDecoder);
#endif
  /* initialize port is basically connect port */
  commandBuf->command[0] = H2D_CONNECT_CH_CMD;
  tempWord = portNum % MAX_CHANNELS_ISR;
  tempWord = (tempWord << 8) | 0x5; /* 5 command words for connect */
  commandBuf->command[1] = tempWord;
  commandBuf->command[2] = vo->encoder_opt[0];
  commandBuf->command[3] = vo->encoder_opt[1];
  /*  FAX Tone Detector */
  commandBuf->command[3] |= 0x1;

  if(setIntrFlag[portNum] == 1)
  {
    commandBuf->command[3] |= 0x10;
  }
  commandBuf->command[4] = vo->encoder_opt[2];
  commandBuf->command[5] = vo->decoder_opt[0];
  commandBuf->command[6] = vo->decoder_opt[1];
  /* enque the command */
  confSetMaxFrames(portNum,vo->maxFrames);
  dspipcEnqCommand(portNum);
  dspipcResetStateInfo(portNum,1);
  dspipcClearQs(portNum);
}
#if  DECT_MODULE
/*======================================================================
 * Function Name        : dspipcStopDectTransCode
 * Description          : Stop DSP transcoding logic for the given port
 *======================================================================
*/
void dspipcStopDectTransCode(unsigned portNum)
{
  UINT16 tempWord;
  CommandQ  *commandBuf = dspipcGetCmdBuf(portNum);
  commandBuf->command[0] = H2D_DECT_TRANSCODING_STOP;

  tempWord = (portNum << 8) | 0x1;
  commandBuf->command[1] = tempWord;

  commandBuf->command[2] = 0;
  /* enque the command */
  dspipcEnqCommand(portNum);

}
/**********************************************************************************
 *  Function Name  : dspipcStartDectTransCode.                                    *
 *  Description    : ranscodes the Mu_law/A_law to Negotiated Codec(G729) to      *
 *                        send on N/W.                                            *
 *  Input          : Port Number,dect_codec_type (1--Mu-law,0-A_law)              *
 *  Output         : None.                                                        *
 *  Return Value   : None.                                                        *
 *********************************************************************************/
void dspipcStartDectTransCode(UINT16 portNum, UCHAR ucDectCodecType)
{
  UINT16 tempWord;
  CommandQ  *commandBuf = dspipcGetCmdBuf(portNum);
  commandBuf->command[0] = H2D_DECT_TRANSCODING_START;
  tempWord = (portNum << 8) | 0x1;
  commandBuf->command[1] = tempWord;
  commandBuf->command[2] = 1;  // to enable transcoding
  commandBuf->command[3] = ucDectCodecType;
  dspipcEnqCommand(portNum);
}
void dspipcStopDectFXO(unsigned portNum) /*DECTFXO JAN 19, 2009*/
{
  UINT16 tempWord;
  CommandQ  *commandBuf = dspipcGetCmdBuf(portNum);
  commandBuf->command[0] = H2D_DECT_FXO_STOP;

  tempWord = (portNum << 8) | 0x1;
  commandBuf->command[1] = tempWord;

  commandBuf->command[2] = 0;
  /* enque the command */
  dspipcEnqCommand(portNum);

}
/**********************************************************************************
 *  Function Name  : dspipcStartDect2FXO.                                    *
 *  Description    : transcodes the Mu_law/A_law to Negotiated Codec(G729) to      *
 *                        send on N/W.                                            *
 *  Input          : Port Number,dect_codec_type (1--Mu-law,0-A_law)              *
 *  Output         : None.                                                        *
 *  Return Value   : None.                                                        *
 *********************************************************************************/
void dspipcStartDectFXO(UINT16 portNum, UCHAR ucDectCodecType)/*DECTFXO JAN 19, 2009*/
{
  UINT16 tempWord;
  CommandQ  *commandBuf = dspipcGetCmdBuf(portNum);
  commandBuf->command[0] = H2D_DECT_FXO_START;
  tempWord = (portNum << 8) | 0x1;
  commandBuf->command[1] = tempWord;
  commandBuf->command[2] = 1;  // to enable transcoding
  commandBuf->command[3] = ucDectCodecType;

  /* enque the command */
  dspipcEnqCommand(portNum);
}
#endif
/**********************************************************************************
 *  Function Name  : dspipcModifyPortCodec.                                       *
 *  Description    : Function to Modify codec.                                    *
 *  Input          : Port Number and VoiceOption.                                 *
 *  Output         : None.                                                        *
 *  Return Value   : None.                                                        *
 *********************************************************************************/
void dspipcModifyPortCodec(UINT16 portNum, VoiceOptions *vo)
{
  UINT16  tempWord;
  UCHAR dspNum =  dspipcMapDSPNum(portNum);
  CommandQ  *commandBuf = dspipcGetCmdBuf(portNum);
  /* BUG ID: 4451*/
  INT16 codec = getEncDecType(vo->decoder_opt[0]);

#if THREEWAY_CONFERENCE
  if ((codec== DSP_G729) && (confGetConference(dspNum) == 1))
    codec = DSP_3WAY;
#endif
  if(codec == DSP_PCMA)
    codec = DSP_PCMU; /* For PCMU and PCMA , NO CHANGE */
  /* BUG ID: 4451*/
  if(codec != confGetDSPDownloadOpt(dspNum))
  {
    tempWord = dspReadDataMem(dspNum,0x3fb1);
    /* Mask 1st bit */
    tempWord =  tempWord & 0xFFFE;
    /* Set 2nd bit */
    tempWord = tempWord | 0x0002;
    dspWriteIntoDataMem(dspNum,0x3fb1,tempWord);
  }
  gaDspStateInfo[portNum].uiEncoder = getEncDecType(vo->encoder_opt[0]);
  gaDspStateInfo[portNum].uiDecoder = getEncDecType(vo->decoder_opt[0]);
#if DYNAMIC_CODEC_DOWNLOAD
  dspipcChangeDSPImage(portNum, gaDspStateInfo[portNum].uiDecoder);
#endif
  /* initialize port is basically connect port */
  commandBuf->command[0] = H2D_MODIFY_CH_CMD;
  tempWord = portNum % MAX_CHANNELS_ISR;
  tempWord = (tempWord << 8) | 0x5; /* 5 command words for connect */
  commandBuf->command[1] = tempWord;
  commandBuf->command[2] = vo->encoder_opt[0];
  commandBuf->command[3] = vo->encoder_opt[1];
   /*  FAX Tone Detector */
  commandBuf->command[3] |= 0x1;

  if(setIntrFlag[portNum] == 1)
  {
    commandBuf->command[3] |= 0x10;
  }
  commandBuf->command[4] = vo->encoder_opt[2];
  commandBuf->command[5] = vo->decoder_opt[0];
  commandBuf->command[6] = vo->decoder_opt[1];
  /* enque the command */
  confSetMaxFrames(portNum,vo->maxFrames);
  dspipcEnqCommand(portNum);
  dspipcResetStateInfo(portNum,2);
  dspipcClearQs(portNum);
}
/**********************************************************************************
 *  Function Name  : dspipcClosePort.                                             *
 *  Description    : Function to Close dsp port     .                             *
 *  Input          : Port Number.                                                 *
 *  Output         : None.                                                        *
 *  Return Value   : None.                                                        *
 *********************************************************************************/
void dspipcClosePort(UINT16 portNum)
{
  UINT16 tempWord;
  CommandQ  *commandBuf =dspipcGetCmdBuf(portNum);
  /* close is basically disconnect the port */
  commandBuf->command[0] = H2D_DISCONNECT_CH_CMD;
  tempWord = portNum % MAX_CHANNELS_ISR;
  //tempWord = (tempWord << 8) | 0x5; /* 4 ??? */
  commandBuf->command[1] = tempWord;
  commandBuf->command[2] = 0;
  commandBuf->command[3] = 0;
  commandBuf->command[4] = 0;
  commandBuf->command[5] = 0;
  commandBuf->command[6] = 0x0;
  /* enque the command */
  dspipcEnqCommand(portNum);
  gaDspStateInfo[portNum].toneState =  CA_NOTONE;
  dspipcResetStateInfo(portNum,0);
#if FXO_MODULE
  confSetToneDetect(portNum,0);
#endif
  AJBReset(portNum);
}
/**********************************************************************************
 *  Function Name  : dspipcGainCntrl.                                             *
 *  Description    : Controls the Attenuation in Tx and Rx side.                  *
 *  Input          : Gain Controls.                                               *
 *  Output         : None.                                                        *
 *  Return Value   : None.                                                        *
 *********************************************************************************/
void dspipcGainCntrl(UINT16 portNum,
                     UINT16 ucGainCntrl,
                     UINT16 ucBlkGainCtrl)
{
  UINT16 tempWord;
  CommandQ  *commandBuf = dspipcGetCmdBuf(portNum);
  commandBuf->command[0] = H2D_VAR_GAIN_ADJUST_CMD;
  tempWord = portNum % MAX_CHANNELS_ISR;
  tempWord = (portNum << 8) | 0x2;
  commandBuf->command[1] = tempWord;
  commandBuf->command[2] = ucGainCntrl;
  commandBuf->command[3] = ucBlkGainCtrl;
  /* enque the command */
  dspipcEnqCommand(portNum);
}
/**********************************************************************************
 *  Function Name  : dspipcGenTone.                                               *
 *  Description    : Function to generate dial tone type for the given port.      *
 *  Input          : Port Number, ToneType, Timeout.                              *
 *  Output         : None.                                                        *
 *  Return Value   : None.                                                        *
 *********************************************************************************/
#if !FXS_ToneDtmf_ACTIVE
void dspipcGenTone(UINT16 portNum, UINT16 ToneType,INT32 uiTimeOut)
{
  UINT16 uiInterval;
#if !TONE_GEN
  UINT16 tempWord;
  CommandQ  *commandBuf;
#endif

  gaDspStateInfo[portNum].ucToneType =  ToneType;
  /* Calculate this value based on  whehter interrupt is running at 5ms or 10ms */
  /* ulTimeOut value is in seconds */
  if(uiTimeOut == 0)
  {
     uiTimeOut = 60;
  }
  if(uiTimeOut)
  {
    uiInterval = 10;
    gaDspStateInfo[portNum].ulToneTimeOut = (uiTimeOut * 1000)/uiInterval;
  }

  if(ToneType == CALL_WAITING_TONE1)
  {

    gaDspStateInfo[portNum].uiWaitCntr = 0;
    gaDspStateInfo[portNum].toneState = CA_CALL_WAIT;
    // Bip de 300ms separ de 10s
    gaDspStateInfo[portNum].ulToneTimeOut = (300)/uiInterval;
  }
  else if((ToneType >= DIG_0_TONE)&&(ToneType <= DIG_HASH_TONE))
  {
    gaDspStateInfo[portNum].toneState = CA_DIGIT_TONE;
  }
  else if (ToneType != RING_BACK_TONE)
  {
    gaDspStateInfo[portNum].toneState = CA_TONE_ON;
  }
  gaDspStateInfo[portNum].ulToneExpCntr = 0;
#if TONE_GEN
  ToneGenSetCountry();
  SMM_ToneType[portNum] = ToneType;
  ToneInit(portNum);
  if(ToneType != CPE_ALERTING_TONE)
  {
    dspipcReportIndication(portNum,DSPIPC_GEN_TONE_DONE);
  }
  SMM_ToneGenEna[portNum] = TONE_GEN_ACTIVE;
#else
  commandBuf = dspipcGetCmdBuf(portNum);
  commandBuf->command[0] = H2D_TONE_GENERATE_CMD;
  tempWord = portNum % MAX_CHANNELS_ISR;
  tempWord = (tempWord << 8) | 0x1; /* */
  commandBuf->command[1] = tempWord;
  commandBuf->command[2] = ToneType;
  /* enque the command */
  dspipcEnqCommand(portNum);
#endif
}
#else // FXS_ToneDtmf_ACTIVE
void fxsGenTone (unsigned char portNum,unsigned char ToneType)
{
	unsigned char ucSilabsToneType=0;

	switch (ToneType)
	{
		case DIAL_TONE:					ucSilabsToneType = 1;break;
		case CALL_IN_PROGRESS_TONE:			ucSilabsToneType = 2;break;
		case RING_BACK_TONE:				ucSilabsToneType = 3;si3216StartMute(portNum);break;
		case BUSY1_TONE:					ucSilabsToneType = 4;break;
		case ERROR_TONE:					ucSilabsToneType = 4;break;
		case OFFHOOK_WARNING_TONE:			ucSilabsToneType = 4;break;
		case MESG_WAITING_INDICATOR_TONE:		ucSilabsToneType = 5;break;
		case CALL_WAITING_TONE1:				ucSilabsToneType = 6;break;
		case CPE_ALERTING_TONE:				ucSilabsToneType = 7;break;

		case VOIP_DIAL_TONE:				ucSilabsToneType = 8;break;
		case VOIP_MESG_WAITING_INDICATOR_TONE:	ucSilabsToneType = 9;break;

		case DIG_0_TONE:					ucSilabsToneType = 10;break;
		case DIG_1_TONE:					ucSilabsToneType = 11;break;
		case DIG_2_TONE:					ucSilabsToneType = 12;break;
		case DIG_3_TONE:					ucSilabsToneType = 13;break;
		case DIG_4_TONE:					ucSilabsToneType = 14;break;
		case DIG_5_TONE:					ucSilabsToneType = 15;break;
		case DIG_6_TONE:					ucSilabsToneType = 16;break;
		case DIG_7_TONE:					ucSilabsToneType = 17;break;
		case DIG_8_TONE:					ucSilabsToneType = 18;break;
		case DIG_9_TONE:					ucSilabsToneType = 19;break;
		case DIG_A_TONE:					ucSilabsToneType = 20;break;
		case DIG_B_TONE:					ucSilabsToneType = 21;break;
		case DIG_C_TONE:					ucSilabsToneType = 22;break;
		case DIG_D_TONE:					ucSilabsToneType = 23;break;
		case DIG_STAR_TONE:					ucSilabsToneType = 24;break;
		case DIG_HASH_TONE:					ucSilabsToneType = 25;break;
		default:
			printk("fxsGenTone() : UNKNOWN TONES type \r\n");
		break;
	}
	si3216StartTone(portNum, ucSilabsToneType);
}

void dspipcGenTone(UINT16 portNum, UINT16 ToneType,INT32 uiTimeOut)
{
	UINT16 uiInterval;
	unsigned short uiCountry;
	
	confGetCountryOpts(&uiCountry);

	switch (uiCountry)
	{
		case FRANCE:
		case NETHERLANDS:
		case POLAND:
		case SPAIN:
		case BELGIUM:
			switch (ToneType)
			{
				case DIAL_TONE:
				case CALL_IN_PROGRESS_TONE:
				case RING_BACK_TONE:
				case BUSY1_TONE:
				case ERROR_TONE:
				case OFFHOOK_WARNING_TONE:
				case MESG_WAITING_INDICATOR_TONE:
				case CALL_WAITING_TONE1:
				case CPE_ALERTING_TONE:
				case VOIP_DIAL_TONE:
				case VOIP_MESG_WAITING_INDICATOR_TONE:
				case DIG_0_TONE:
				case DIG_1_TONE:
				case DIG_2_TONE:
				case DIG_3_TONE:
				case DIG_4_TONE:
				case DIG_5_TONE:
				case DIG_6_TONE:
				case DIG_7_TONE:
				case DIG_8_TONE:
				case DIG_9_TONE:
				case DIG_A_TONE:
				case DIG_B_TONE:
				case DIG_C_TONE:
				case DIG_D_TONE:
				case DIG_STAR_TONE:
				case DIG_HASH_TONE:
				break;
				default :
      				printk("dspipcGenTone() : UNKNOWN TONES type \r\n");
					return;
				break;
			}
		break;
		default :
      		printk("dspipcGenTone() : UNKNOWN CountryType for TONES \r\n");
			return;
		break;
	}
   printk("Gentone %d on port %d  with flag FXo : %d\n\r",ToneType,portNum,aucToneGenOnFxoFlag[portNum]);
  gaDspStateInfo[portNum].ucToneType =  ToneType;
  /* Calculate this value based on  whehter interrupt is running at 5ms or 10ms */
  /* ulTimeOut value is in seconds */
  if(uiTimeOut == 0)
  {
     uiTimeOut = 60;
  }
  if(uiTimeOut)
  {
    uiInterval = 10;
    gaDspStateInfo[portNum].ulToneTimeOut = (uiTimeOut * 1000)/uiInterval;
  }

  if((ToneType >= DIG_0_TONE)&&(ToneType <= DIG_HASH_TONE))
  {
    gaDspStateInfo[portNum].toneState = CA_DIGIT_TONE;
  }
  else if ((ToneType != RING_BACK_TONE) && (ToneType != CALL_WAITING_TONE1))
  {
    gaDspStateInfo[portNum].toneState = CA_TONE_ON;
  }
  else
  {
    gaDspStateInfo[portNum].toneState = CA_NOTONE;
  }

  gaDspStateInfo[portNum].ulToneExpCntr = 0;

#if !FXO_MODULE
    fxsGenTone (portNum,ToneType);
    if(ToneType != CPE_ALERTING_TONE)
    {
      dspipcReportIndication(portNum,DSPIPC_GEN_TONE_DONE);
    }
    SMM_ToneGenEna[portNum] = TONE_GEN_INACTIVE;
#else // FXO_MODULE
   
  // tonalites par DSP : uniquement pour generer la numerotation DTMF vers le FXO
  if(aucToneGenOnFxoFlag[portNum] == 1)
  {
	if((ToneType >= DIG_0_TONE)&&(ToneType <= DIG_HASH_TONE))
  	{
		ToneGenSetCountry();
		SMM_ToneType[portNum] = ToneType;
		ToneInit(portNum);
		dspipcReportIndication(portNum,DSPIPC_GEN_TONE_DONE);
		SMM_ToneGenEna[portNum] = TONE_GEN_ACTIVE;
	}
  }
  else // tonalites par FXS
  {
    fxsGenTone (portNum,ToneType);
    if(ToneType != CPE_ALERTING_TONE)
    {
      dspipcReportIndication(portNum,DSPIPC_GEN_TONE_DONE);
    }
    SMM_ToneGenEna[portNum] = TONE_GEN_INACTIVE;
  }
#endif // end FXO_MODULE
}
#endif // end FXS_ToneDtmf_ACTIVE

#if DTMFRX
/**********************************************************************************
 *  Function Name  : dspipcSetDtmfRej.                                            *
 *  Description    : Function to set DTMF .                                       *
 *  Input          : Port Number.                                                 *
 *  Output         : None.                                                        *
 *  Return Value   : None.                                                        *
 *********************************************************************************/
void dspipcSetDtmfRej(UINT16 portNum)
{
  UINT16 tempWord;
  CommandQ  *commandBuf = dspipcGetCmdBuf(portNum);
  commandBuf->command[0] = H2D_SET_DTMF_REJ_CMD;
  tempWord = (portNum << 8) | 0x1;
  commandBuf->command[1] = tempWord;
  commandBuf->command[2] = DTMF_REJ_HANG_CNTR;
  /* enque the command */
  dspipcEnqCommand(portNum);
}
/*======================================================================
 * Function Name        : dspipcResetDtmfRejHangOver
 * Description          : To reSet The dtmf Rejection Hangover
 *======================================================================
*/
void dspipcResetDtmfRejHangOver(unsigned portNum)
{
  UINT16 tempWord;
  CommandQ  *commandBuf = dspipcGetCmdBuf(portNum);
  commandBuf->command[0] = H2D_SET_DTMF_REJ_HANGOVER_CMD;

  tempWord = (portNum << 8) | 0x1;
  commandBuf->command[1] = tempWord;

  commandBuf->command[2] = 0;
  /* enque the command */
  dspipcEnqCommand(portNum);

}

////////////////////////////////////////////////////////////////////////
/*======================================================================
 * Function Name        :dspipcSetDtmfRejHangOver
 * Description          : To Set The dtmf Rejection Hangover
 *======================================================================
*/
void dspipcSetDtmfRejHangOver(unsigned portNum)
{
  UINT16 tempWord;
  CommandQ  *commandBuf = dspipcGetCmdBuf(portNum);
  commandBuf->command[0] = H2D_SET_DTMF_REJ_HANGOVER_CMD;

  tempWord = (portNum << 8) | 0x1;
  commandBuf->command[1] = tempWord;

  commandBuf->command[2] = DTMF_REJ_HANG_CNTR;
  /* enque the command */
  dspipcEnqCommand(portNum);
}
/**********************************************************************************
 *  Function Name  : dspipcQuitDtmfRej.                                           *
 *  Description    : Function to quit DTMF .                                      *
 *  Input          : Port Number.                                                 *
 *  Output         : None.                                                        *
 *  Return Value   : None.                                                        *
 *********************************************************************************/
void dspipcQuitDtmfRej(UINT16 portNum)
{
  UINT16 tempWord;
  CommandQ  *commandBuf = dspipcGetCmdBuf(portNum);
  commandBuf->command[0] = H2D_SET_DTMF_REJ_CMD;
  tempWord = (portNum << 8) | 0x1;
  commandBuf->command[1] = tempWord;
  commandBuf->command[2] = 0;
  /* enque the command */
  dspipcEnqCommand(portNum);
}
#endif
/**********************************************************************************
 *  Function Name  : dspipcEchoCntrl.                                             *
 *  Description    : Function to control the Echo Canceller Params.               *
 *  Input          : Port Number and EC Parameters.                               *
 *  Output         : None.                                                        *
 *  Return Value   : None.                                                        *
 *********************************************************************************/
void dspipcEchoCntrl(UINT16 portNum,UINT16 uiECparams)
{
  UINT16 tempWord;
  CommandQ  *commandBuf = dspipcGetCmdBuf(portNum);
  commandBuf->command[0] = H2D_ECHO_PARAMS_CMD;
  tempWord = portNum % MAX_CHANNELS_ISR;
  tempWord = (portNum << 8) | 0x1;
  commandBuf->command[1] = tempWord;
  commandBuf->command[2] = uiECparams;
  /* enque the command */
  dspipcEnqCommand(portNum);
}
/**********************************************************************************
 *  Function Name  : dspipcFaxSG3ToG3Fb.                                          *
 *  Description    : Function to control the Fax SG3 to G3 fall back              *
 *  Input          : Port Number and Value(0 or 1)                                *
 *  Output         : None.                                                        *
 *  Return Value   : None.                                                        *
 *********************************************************************************/
void dspipcFaxSG3ToG3Fb(UINT16 portNum,UINT16 setvalue)
{
  UINT16 tempWord;
  CommandQ  *commandBuf = dspipcGetCmdBuf(portNum);
  if(setvalue  > 1){
      return;
  }
//  printk("\r\ndspipcFaxSG3ToG3Fb:%d\n",setvalue);
  commandBuf->command[0] = H2D_FAX_SG3TOG3_FALLBACK_CMD;
  tempWord = portNum % MAX_CHANNELS_ISR;
  tempWord = (portNum << 8) | 0x2;
  commandBuf->command[1] = tempWord;
  commandBuf->command[2] = setvalue;
  /* enque the command */
  dspipcEnqCommand(portNum);
}
/**********************************************************************************
 *  Function Name  : dspipcQuitTone.                                              *
 *  Description    : Function to quit tone.                                       *
 *  Input          : Port Number and Tone Type.                                   *
 *  Output         : None.                                                        *
 *  Return Value   : None.                                                        *
 *********************************************************************************/
#if !FXS_ToneDtmf_ACTIVE
void dspipcQuitTone(UINT16 portNum, UINT16 ToneType)
{
#if !TONE_GEN
  UINT16 tempWord;
  CommandQ  *commandBuf = NULL;
#endif
  DspStateInfo_t *dspInfo;
  dspInfo = &gaDspStateInfo[portNum];
#if TONE_GEN
  osLockTasklet(portNum);
  SMM_ToneGenEna[portNum] = TONE_GEN_INACTIVE;
  ToneResetVars(portNum);
// Sagem ICC 01/12/2006
  if (dspInfo->toneState == CA_LOCAL_QUIT_TONE)

  {
    // Pas prevenir si QUIt tone correspondant  un DTMF
  }
  else
  dspipcReportIndication(portNum,DSPIPC_QUIT_TONE_DONE);
// Fin SAgem ICC

// Arreter la relance automatique de la tonalite CallWaitingTone
  if(dspInfo->ucCallWtState == CA_CIDCW_END)
  {
    dspInfo->ucCallWtState = CA_READY;
    dspInfo->uiWaitCwCntr = 0;
  }

  SMM_bUseGeneric[portNum]=0;
  SMM_CadCntr[portNum]=0;
  SMM_CadCnt[portNum]=0;
  SMM_ToneInit_flag[portNum]=0;
  SMM_CadPlayStopFlag[portNum]=0;
  SMM_ToneDurationCntr[portNum]=0;
#else
  commandBuf = dspipcGetCmdBuf(portNum);
  commandBuf->command[0] = H2D_QUIT_TONE_CMD ;
  tempWord = portNum % MAX_VOICE_CHANNELS_ISR;
  tempWord = portNum % MAX_CHANNELS_ISR;
  tempWord = (tempWord << 8) | 0x1; /* 4 ??? */
  commandBuf->command[1] = tempWord;
  commandBuf->command[2] = ToneType;
  /* enque the command */
  dspipcEnqCommand(portNum);
#endif
  gaDspStateInfo[portNum].toneState =  CA_NOTONE;
  gaDspStateInfo[portNum].uiWaitCntr = 0;
  gaDspStateInfo[portNum].ulToneExpCntr = 0;
  gaDspStateInfo[portNum].ulToneTimeOut = 0;
  osUnlockTasklet(portNum);
  dspipcStopFarEndTone(portNum);
}
#else // FXS_ToneDtmf_ACTIVE
void fxsQuitTone (unsigned char portNum,unsigned char ToneType)
{
	si3216StopMute(portNum);
	si3216StopTone(portNum);
}

void dspipcQuitTone(UINT16 portNum, UINT16 ToneType)
{
  DspStateInfo_t *dspInfo;
  unsigned short uiCountry;

  confGetCountryOpts(&uiCountry);

  switch (uiCountry)
  {
	case FRANCE:
	case NETHERLANDS:
	case POLAND:
	case SPAIN:
	case BELGIUM:
		switch (ToneType)
		{
			case DIAL_TONE:
			case CALL_IN_PROGRESS_TONE:
			case RING_BACK_TONE:
			case BUSY1_TONE:
			case ERROR_TONE:
			case OFFHOOK_WARNING_TONE:
			case MESG_WAITING_INDICATOR_TONE:
			case CALL_WAITING_TONE1:
			case CPE_ALERTING_TONE:
			case VOIP_DIAL_TONE:
			case VOIP_MESG_WAITING_INDICATOR_TONE:
			case DIG_0_TONE:
			case DIG_1_TONE:
			case DIG_2_TONE:
			case DIG_3_TONE:
			case DIG_4_TONE:
			case DIG_5_TONE:
			case DIG_6_TONE:
			case DIG_7_TONE:
			case DIG_8_TONE:
			case DIG_9_TONE:
			case DIG_A_TONE:
			case DIG_B_TONE:
			case DIG_C_TONE:
			case DIG_D_TONE:
			case DIG_STAR_TONE:
			case DIG_HASH_TONE:
			break;
			default :
      			printk("dspipcQuitTone() : UNKNOWN TONES type \r\n");
				return;
			break;
		}
	break;
	default :
      	printk("dspipcQuitTone() : UNKNOWN CountryType for TONES \r\n");
		return;
	break;
  }

  if(aucToneGenOnFxoFlag[portNum] == 0)
  {
    fxsQuitTone (portNum,ToneType);
  }

  dspInfo = &gaDspStateInfo[portNum];

  osLockTasklet(portNum);
  SMM_ToneGenEna[portNum] = TONE_GEN_INACTIVE;
  ToneResetVars(portNum);
// Sagem ICC 01/12/2006
  if (dspInfo->toneState == CA_LOCAL_QUIT_TONE)

  {
    // Pas prevenir si QUIt tone correspondant  un DTMF
  }
  else
  {
    dspipcReportIndication(portNum,DSPIPC_QUIT_TONE_DONE);
  }
// Fin SAgem ICC

// Arreter la relance automatique de la tonalite CallWaitingTone
  if(dspInfo->ucCallWtState == CA_CIDCW_END)
  {
    dspInfo->ucCallWtState = CA_READY;
    dspInfo->uiWaitCwCntr = 0;
  }

  SMM_bUseGeneric[portNum]=0;
  SMM_CadCntr[portNum]=0;
  SMM_CadCnt[portNum]=0;
  SMM_ToneInit_flag[portNum]=0;
  SMM_CadPlayStopFlag[portNum]=0;
  SMM_ToneDurationCntr[portNum]=0;

  gaDspStateInfo[portNum].toneState =  CA_NOTONE;
  gaDspStateInfo[portNum].uiWaitCntr = 0;
  gaDspStateInfo[portNum].ulToneExpCntr = 0;
  gaDspStateInfo[portNum].ulToneTimeOut = 0;
  osUnlockTasklet(portNum);
  dspipcStopFarEndTone(portNum);
}
#endif // end FXS_ToneDtmf_ACTIVE

#if THREEWAY_CONFERENCE
/**********************************************************************************
 *  Function Name  : dspipcStartConference.                                       *
 *  Description    : Function to  start the conference.                           *
 *  Input          : Port Number.                                                 *
 *  Output         : None.                                                        *
 *  Return Value   : None.                                                        *
 *********************************************************************************/
void dspipcStartConference(UINT16 portNum, VoiceOptions *vo)
{
  UINT16  tempWord;
  CommandQ  *commandBuf = dspipcGetCmdBuf(portNum);
  gaDspStateInfo[portNum + MAX_SLIC_CHANNELS].uiEncoder =
                                      getEncDecType(vo->encoder_opt[0]);
  gaDspStateInfo[portNum + MAX_SLIC_CHANNELS].uiDecoder =
                                      getEncDecType(vo->decoder_opt[0]);
#if DYNAMIC_CODEC_DOWNLOAD
  dspipcChangeDSPImage(portNum, DSP_3WAY);
#endif

  commandBuf->command[0] = H2D_START_CONFERENCE_CMD;
  tempWord = portNum % MAX_CHANNELS_ISR;
  tempWord = (tempWord << 8) | 0x5; /* 5 command words for connect */
  commandBuf->command[1] = tempWord;
  //commandBuf->command[2] = VirtualPort;
  commandBuf->command[2] = vo->encoder_opt[0];
  commandBuf->command[3] = vo->encoder_opt[1];

  if(setIntrFlag[portNum] == 1)
  {
    commandBuf->command[3] |= 0x10;
  }
  commandBuf->command[4] = vo->encoder_opt[2];
  commandBuf->command[5] = vo->decoder_opt[0];
  commandBuf->command[6] = vo->decoder_opt[1];

  /* enque the command */
  confSetMaxFrames(portNum + MAX_SLIC_CHANNELS, vo->maxFrames);
  dspipcEnqCommand(portNum);
  dspipcResetStateInfo(portNum + MAX_SLIC_CHANNELS,1);
  dspipcClearQs(portNum);
}
/**********************************************************************************
 *  Function Name  : dspipcQuitConference                                         *
 *  Description    : Function to quit the conference.                             *
 *  Input          : Port Numbers                               .                 *
 *  Output         : None.                                                        *
 *  Return Value   : None.                                                        *
 *********************************************************************************/
void dspipcQuitConference(UINT16 port1, UINT16 port2)
{
  UINT16 tempWord;
  CommandQ  *commandBuf = dspipcGetCmdBuf(port1);
  commandBuf->command[0] = H2D_STOP_CONFERENCE_CMD;
  tempWord = port1 % MAX_CHANNELS_ISR;
  tempWord = (tempWord << 8) | 0x1; /* 4 ??? */

  commandBuf->command[1] = tempWord;
  tempWord = port1 % MAX_CHANNELS_ISR;
  tempWord = (tempWord << 8) | port2; /* 4 ??? */

  commandBuf->command[2] = 2;
  commandBuf->command[3] = tempWord;

  /* enque the command */
  dspipcEnqCommand(port1);
}
#endif

/**********************************************************************************
 *  Function Name  : dspipcAcknowledgeDigit.                                      *
 *  Description    : Function to acknowledges the digit received.                 *
 *  Input          : Port Number,error type,received sequence,expected sequence.  *
 *  Output         : None.                                                        *
 *  Return Value   : None.                                                        *
 *********************************************************************************/
void dspipcAcknowledgeDigit( UINT16 portNum,
                             UINT16 errorType,
                             UINT16 ReceivedSequence,
                             UINT16 ExpectedSequence)
{
  UINT16 tempWord;
  CommandQ  *commandBuf = dspipcGetCmdBuf(portNum);
  commandBuf->command[0] = H2D_DTMF_DIGIT_RCVD_CMD;
  tempWord = portNum % MAX_CHANNELS_ISR;
  tempWord = (tempWord << 8) | 0x3; /* 4 ??? */
  commandBuf->command[1] = tempWord;
  commandBuf->command[2] = errorType;
  commandBuf->command[3] = ReceivedSequence;
  commandBuf->command[4] = ExpectedSequence ;
  /* enque the command */
  dspipcEnqCommand(portNum);
}
/**********************************************************************************
 *  Function Name  : dspipcAckV21Detection.                                      *
 *  Description    : Function to acknowledges the V21 Detection Command received *
 *  Input          : Port Number                                                 *
 *  Output         : None.                                                       *
 *  Return Value   : None.                                                       *
 *********************************************************************************/
void dspipcAckV21Detection( UINT16 portNum)
{
  UINT16 tempWord;
  CommandQ  *commandBuf = dspipcGetCmdBuf(portNum);
  commandBuf->command[0] = H2D_V21_DETECTION_RCVD_CMD;
  tempWord = portNum % MAX_CHANNELS_ISR;
  commandBuf->command[1] = tempWord;
  /* enque the command */
  dspipcEnqCommand(portNum);
}
/**********************************************************************************
 *  Function Name  : dspipcGetDSPBankAddress.                                     *
 *  Description    : Function to get address for DSP banks.                       *
 *  Input          : DSP Number.                                                  *
 *  Output         : None.                                                        *
 *  Return Value   : None.                                                        *
 *********************************************************************************/
void dspipcGetDSPBankAddress(INT32 dspnumber)
{
#if !DELAY_OPT
  /* This is to be read from the dsp memory */
  dsp_bank_select_counter =
       dspReadDataMem(dspnumber,dspipcAddress[dspnumber].dspBankSelectCntr);
  /* find the bank to be selected by the LSB bit of the counter */
  if(dsp_bank_select_counter & 0x1)
  {
    /* BANK 1 - Host reads
     * BANK 0 - Host writes
     * BANK 1 - Dsp reads
     * BANK 0 - Dsp writes
     */
    d2h_cmd_addr[dspnumber]= dspipcAddress[dspnumber].cmdDsp2hostBank0;
    d2h_data_addr[dspnumber]= dspipcAddress[dspnumber].dataDsp2hostBank0;
    h2d_cmd_addr[dspnumber]= dspipcAddress[dspnumber].cmdHost2dspBank1;
    h2d_data_addr[dspnumber]= dspipcAddress[dspnumber].dataHost2dspBank1;
#if DTMFRX
    DtmfrxMemAdd[dspnumber] = dspipcAddress[dspnumber].DtmfrxDsp2hostBank0;
#endif
  }
  else
  {
    /* BANK 0 - Host reads
     * BANk 1 - Host writes
     * BANK 0 - Dsp reads
     * BANK 1 - Dsp writes
     */
     d2h_cmd_addr[dspnumber] = dspipcAddress[dspnumber].cmdDsp2hostBank1;
     d2h_data_addr[dspnumber] = dspipcAddress[dspnumber].dataDsp2hostBank1;
     h2d_cmd_addr[dspnumber] = dspipcAddress[dspnumber].cmdHost2dspBank0;
     h2d_data_addr[dspnumber] = dspipcAddress[dspnumber].dataHost2dspBank0;
#if DTMFRX
     DtmfrxMemAdd[dspnumber]  = dspipcAddress[dspnumber].DtmfrxDsp2hostBank1;
#endif
  }
#else
  d2h_cmd_addr[dspnumber] = dspipcAddress[dspnumber].cmdDsp2hostBank0;
  d2h_data_addr[dspnumber] = dspipcAddress[dspnumber].dataDsp2hostBank0;
  h2d_cmd_addr[dspnumber] = dspipcAddress[dspnumber].cmdHost2dspBank0;
  h2d_data_addr[dspnumber] = dspipcAddress[dspnumber].dataHost2dspBank0;
#if DTMFRX
  DtmfrxMemAdd[dspnumber]  = dspipcAddress[dspnumber].DtmfrxDsp2hostBank0;
#endif
#endif

}

/**********************************************************************************
 *  Function Name  : dspipcCmdIntrpret.                                           *
 *  Description    : Function to interoret the DSP Acks.                          *
 *  Input          : Command Ack and Port Number.                                 *
 *  Output         : None.                                                        *
 *  Return Value   : None.                                                        *
 *********************************************************************************/
void dspipcCmdIntrpret(CommandQ *cmdAcks, UINT16 portNum)
{
  CmdDigitInfo_t *temp;
  switch(cmdAcks->command[0])
  {
    case D2H_RESET_ALL_CH_DONE:
        dspipcReportIndication(portNum,DSPIPC_RESET_ALL_PORTS_DONE);
        break;
    case D2H_CONNECT_CH_DONE:
#if KERNEL_RTP_INTERFACE /* { */
  	  if ( (pNWCallBack != (dsp_regNetwork_t *)0) && (pNWCallBack->evtFromDsp != (dsp_network_evtFromDsp_f)0) ) {
#ifdef VOICE_SYSCTL_STATS
          /* Stats */
          dsp_voiceSysCtl.ports[portNum].stats.network.rtp.snd.initPortDone++;
#endif
/* EBd BUG 3121 */
		pNWCallBack->evtFromDsp(DSP_NETWORK_Evt_fromDsp_init_port_done, portNum, (void *)0);
/* end BUG 3121 */
		}
#endif /* } */
        dspipcReportIndication(portNum,DSPIPC_INIT_PORT_DONE);
        break;
    case D2H_MODIFY_CH_DONE :
        dspipcReportIndication(portNum,DSPIPC_MODIFY_PORT_CODEC_DONE);
        break;
    case D2H_DISCONNECT_CH_DONE:
        dspipcReportIndication(portNum,DSPIPC_CLOSE_PORT_DONE);
        break;
    case D2H_TONE_GENERATE_DONE:
        dspipcReportIndication(portNum,DSPIPC_GEN_TONE_DONE);
        break;
    case D2H_QUIT_TONE_DONE:
        dspipcReportIndication(portNum,DSPIPC_QUIT_TONE_DONE);
        break;
    case D2H_DTMF_DIGIT_REPORT:

        if(gaDspStateInfo[portNum].ucExpSeqNo == cmdAcks->command[2])
        {
          dspipcAcknowledgeDigit(portNum, 0, cmdAcks->command[2],
                                                cmdAcks->command[2] + 1);
          if(gaDspStateInfo[portNum].ucCallWtState == CA_CIDCW)
          {
            if((cmdAcks->command[3] == 15)  || (cmdAcks->command[3] == 3)) //13  A
            {
              gaDspStateInfo[portNum].ucCallWtState = CA_CIDCW_ACK;
              gaDspStateInfo[portNum].uiWaitCwCntr = 0;
            }
          }
          else
          {
            gaDsp2HostQ.writeIdx = (gaDsp2HostQ.writeIdx + 1) %  MAX_DSP2HOST_CMDQ_BUFFS;
            temp = &gaDsp2HostCmdBuf[gaDsp2HostQ.writeIdx];
            temp->ucChannelNo = portNum;
            temp->ConfirmCode = DSPIPC_DIGIT_RECEIVED;
            temp->ucSeqNo = cmdAcks->command[2];
            temp->dialledDigit = cmdAcks->command[3];
            temp->uiPowerLvl = cmdAcks->command[4];
            temp->ulDigDuration = cmdAcks->command[5];
            temp->ulTimeStamp = ulTimeStampCntA[portNum];

#if TONE_GEN
            dspRegFunctions.regCmdDigit();
#endif
            gaDspStateInfo[portNum].ucState = CA_DIGIT_RCVD;
          }
          gaDspStateInfo[portNum].ucExpSeqNo++;
          gaDspStateInfo[portNum].uiIntDigTimer=0;
        }
        else
        {
          dspipcAcknowledgeDigit(portNum, 0,cmdAcks->command[2],
                                 gaDspStateInfo[portNum].ucExpSeqNo);
        }
        break;
      case D2H_FAX_MODEM_TONE_DETECTED:
        gV21DetDone[portNum] = TRUE;

        if(gV21DetDone[portNum] == FALSE)
         break;
         
        switchJitterBuffToFjb(portNum); //for passthrough
        confSetPLC(portNum,0);
        
        if(cmdAcks->command[2] == 1) /*SIN Side TOne Detection*/
        {
          gSINreceived[portNum] = TRUE;
          printk("cmdAcks->command[3] %i\n",cmdAcks->command[3]);
          if(cmdAcks->command[3] == 1)
          {
            DEBUG(PRINT("D2H_SIN_FAXTONE_DETECTED on port %d \r\n",portNum), DEBUG_INFO);
          }
          else if(cmdAcks->command[3] == 2)
          {
            gV21DetDone[portNum] = FALSE;
		  dspipcReportIndication(portNum, DSPIPC_SIN_MODEMTONE_DETECTED);
            DEBUG(PRINT("D2H_SIN_ANSam_FAXTONE_DETECTED on port %d \r\n",portNum), DEBUG_INFO);
          }
          else if(cmdAcks->command[3] == 3)
          {
            gV21DetDone[portNum] = FALSE;
            dspipcReportIndication(portNum, DSPIPC_SIN_MODEMTONE_DETECTED);
            DEBUG(PRINT("D2H_SIN_MODEMTONE_DETECTED on port %d \r\n",portNum), DEBUG_INFO);
          }
          else if(cmdAcks->command[3] == 4)
          {
            gV21DetDone[portNum] = FALSE;
            dspipcReportIndication(portNum, DSPIPC_SIN_MODEMTONE_DETECTED);
            DEBUG(PRINT("D2H_SIN_ANSam_Modem_DETECTED on port %d \r\n",portNum), DEBUG_INFO);
          }
          else
            DEBUG(PRINT("Invalid SIN TONE DETECTED on port %d \r\n",portNum), DEBUG_INFO);
        }
        else if(cmdAcks->command[2] == 2) /*RIN Side TOne Detection*/
        {
         printk("cmdAcks->command[3] %i\n",cmdAcks->command[3]);
         if(cmdAcks->command[3] == 1)
          {
            dspipcReportIndication(portNum,DSPIPC_RIN_FAXTONE_DETECTED);
            DEBUG(PRINT("D2H_RIN_FAXTONE_DETECTED on port %d \r\n", portNum), DEBUG_INFO);
          }
          else if(cmdAcks->command[3] == 2)
          {
            dspipcReportIndication(portNum,DSPIPC_RIN_FAXTONE_DETECTED);
            DEBUG(PRINT("D2H_RIN_ANSam_FAXTONE_DETECTED on port %d \r\n", portNum), DEBUG_INFO);
          }
          else if(cmdAcks->command[3] == 3)
          {
            dspipcReportIndication(portNum,DSPIPC_RIN_FAXTONE_DETECTED);
            DEBUG(PRINT("D2H_RIN_MODEMTONE_DETECTED on port %d \r\n", portNum), DEBUG_INFO);
          }
          else if(cmdAcks->command[3] == 4)
          {
            dspipcReportIndication(portNum,DSPIPC_RIN_FAXTONE_DETECTED);
            DEBUG(PRINT("D2H_RIN_ANSam_MODEM_DETECTED on port %d \r\n",portNum), DEBUG_INFO);
          }
          else
            DEBUG(PRINT("Invalid RIN TONE DETECTED on port %d \r\n",portNum), DEBUG_INFO);
        }
        else
            DEBUG(PRINT("Invalid TONE DETECTED on port %d \r\n",portNum), DEBUG_INFO);

        break;

    case D2H_V21_PREAMBLE_DETECT:
           switchJitterBuffToFjb(portNum); //for passthrough
           confSetPLC(portNum,0);
           gV21DetFlag[portNum] = TRUE;
         break;


#if 0
    case D2H_SIN_FAXTONE_DETECTED:
        dspipcReportIndication(portNum,DSPIPC_SIN_FAXTONE_DETECTED);
        DEBUG(PRINT("D2H_SIN_FAXTONE_DETECTED on port %d \r\n",portNum), DEBUG_INFO); 
        break;
    case D2H_RIN_FAXTONE_DETECTED:
        dspipcReportIndication(portNum,DSPIPC_RIN_FAXTONE_DETECTED);
        DEBUG(PRINT("D2H_RIN_FAXTONE_DETECTED on port %d \r\n", portNum), DEBUG_INFO);  
        break;
#endif
    case D2H_CNG_TONE_REPORT:
        dspipcReportIndication(portNum,DSPIPC_CNG_TONE_REPORT);
        break;
   case D2H_mMODEMREADY:
       dspipcReportIndication(portNum, DSPIPC_mMODEMREADY);
       DEBUG(PRINT("DSPIPC_mMODEMREADY on port %d \r\n",portNum), DEBUG_INFO);
        break;
#if 0
   case D2H_SIN_MODEMTONE_DETECTED:
        dspipcReportIndication(portNum,DSPIPC_SIN_MODEMTONE_DETECTED);
        DEBUG(PRINT("D2H_SIN_MODEMTONE_DETECTED on port %d \r\n",portNum), DEBUG_INFO); 
        switchJitterBuffToFjb(portNum); //for passthrough
        confSetPLC(portNum,0);
        break;
   case D2H_RIN_MODEMTONE_DETECTED:
        dspipcReportIndication(portNum,DSPIPC_RIN_MODEMTONE_DETECTED);
        DEBUG(PRINT("D2H_RIN_MODEMTONE_DETECTED on port %d \r\n", portNum), DEBUG_INFO);   //sneha
        switchJitterBuffToFjb(portNum); //for passthrough
        confSetPLC(portNum,0);
        break;
#endif
    case D2H_DTMF_DIGIT_TONE_START_REPORT:
        gaDsp2HostQ.writeIdx = (gaDsp2HostQ.writeIdx + 1) %  MAX_DSP2HOST_CMDQ_BUFFS;
        temp = &gaDsp2HostCmdBuf[gaDsp2HostQ.writeIdx];
        temp->ucChannelNo = portNum;
        temp->ConfirmCode = DSPIPC_DIGIT_TONE_START_REPORT;
        temp->ucSeqNo = cmdAcks->command[2];
        temp->dialledDigit = cmdAcks->command[3];
        temp->uiPowerLvl = cmdAcks->command[4];
        temp->ulTimeStamp = ulTimeStampCntA[portNum];
        dspRegFunctions.regCmdDigit();
        break;
    case D2H_DTMF_DIGIT_TONE_END_REPORT:
        gaDsp2HostQ.writeIdx = (gaDsp2HostQ.writeIdx + 1) %  MAX_DSP2HOST_CMDQ_BUFFS;
        temp = &gaDsp2HostCmdBuf[gaDsp2HostQ.writeIdx];
        temp->ucChannelNo = portNum;
        temp->ConfirmCode = DSPIPC_DIGIT_TONE_END_REPORT;
        temp->dialledDigit = cmdAcks->command[2];
        temp->ulDigDuration = cmdAcks->command[3];
        temp->ulTimeStamp = ulTimeStampCntA[portNum];
        dspRegFunctions.regCmdDigit();
        break;
    case D2H_DTMF_DIGIT_TONE_CONT_REPORT:
        gaDsp2HostQ.writeIdx = (gaDsp2HostQ.writeIdx + 1) %  MAX_DSP2HOST_CMDQ_BUFFS;
        temp = &gaDsp2HostCmdBuf[gaDsp2HostQ.writeIdx];
        temp->ucChannelNo = portNum;
        temp->ConfirmCode = DSPIPC_DIGIT_TONE_CONT_REPORT;
        temp->ucSeqNo = cmdAcks->command[2];
        temp->dialledDigit = cmdAcks->command[3];
        temp->uiPowerLvl = cmdAcks->command[4];
        temp->ulTimeStamp = ulTimeStampCntA[portNum];
        dspRegFunctions.regCmdDigit(); //to be enabled later
        break;
    case D2H_DEBUG_DATA_DONE:
    case D2H_ERROR_ON_BLK_SLT:
    default:
        break;
    }
}

INT16 dspipcCheckDecoderConsitency(UCHAR ucRTPPayLoad,UCHAR ucPortNo)
{
  UCHAR  ucDSPCodec;
  ucDSPCodec = gaDspStateInfo[ucPortNo].uiDecoder;
  switch(ucRTPPayLoad)
  {
    case PCMU:
     if(ucDSPCodec == 1)
       return SUCCESS;
     else
       break;
    case PCMA:
     if(ucDSPCodec == 0)
       return SUCCESS;
     else
       break;
    case G729:
    case G729A:
    case G729B:
      if(ucDSPCodec == 6)
        return SUCCESS;
      else
        break;
    case G723:
    case G723AH:
    case G723AL:
    case G723L:
    case G723H:
    if(ucDSPCodec == 7 || ucDSPCodec == 8)
          return SUCCESS;
       else
         break;
    case VAD_CNG:
      if(ucDSPCodec == 1 || ucDSPCodec == 0)
        return SUCCESS;
      break;
    default:
       return FAILURE;
  }
  return FAILURE;
}
/**********************************************************************************
 *  Function Name  : dspipcWriteVoicePkt.                                         *
 *  Description    : Function to be used for writing the data to DSP based on     *
 *                   Jitter Buffer Scheme,                                        *
 *  Input          : Voice Packet.                                                *
 *  Output         : None.                                                        *
 *  Return Value   : None.                                                        *
 *********************************************************************************/
void dspipcWriteVoicePkt(VoiceQ_t *pVoice)
{
  WtRtpPktType_ WtRTPPkt;
  UCHAR  PortNum;
  UINT16 FrameLen;
  UCHAR  CodecType;

  copy_from_user(&PortNum,&pVoice->ucChNum,sizeof(UCHAR));
  copy_from_user(&FrameLen,&pVoice->ucPktLen,sizeof(UINT16));
  copy_from_user(&CodecType,&pVoice->ucCodec,sizeof(UCHAR));


  /* Check on for Voice Speech Packet */
  if(FrameLen > 10)
  {
    if(dspipcCheckDecoderConsitency(CodecType,PortNum) == FAILURE)
    {
#if DRV_DEBUG_STAT
       VoiceDebugStat[PortNum].rtpPktErr++;
#endif
       return ;
    }
  }
  WtRTPPkt.FrameLen     = FrameLen;
  WtRTPPkt.CodecType    = CodecType;
  copy_from_user(&WtRTPPkt.SR_TIMESTAMP,&pVoice->ulTimeStamp,
                                sizeof(UINT32));
  WtRTPPkt.RR_TIMESTAMP = ulTimeStampCntA[PortNum];
  copy_from_user(&WtRTPPkt.SeqNum,&pVoice->uiSeqNo,sizeof(UINT16));;
  WtJitBuffer(&WtRTPPkt,PortNum,pVoice->aucPayload);
#if !KRTP
#if DRV_DEBUG_STAT
  VoiceDebugStat[PortNum].rtpPktRcv++;
#endif
#endif
}

/**********************************************************************************
 *  Function Name  : dspipcUpdateRings.                                           *
 *  Description    : Function to be update Ring timeouts.                         *
 *  Input          : Port Number.                                                 *
 *  Output         : None.                                                        *
 *  Return Value   : None.                                                        *
 *********************************************************************************/
void dspipcUpdateRings(UCHAR ucPort)
{
  UINT32 ulTimeOut;
  DspStateInfo_t *dspInfo;
  dspInfo = &gaDspStateInfo[ucPort];

#if T38
  if(gSINreceived[ucPort] == TRUE)
  {
    if(gV21DetDone[ucPort] == TRUE)
    {
      if(gSINcntr[ucPort] >= 40)
      {
        gSINreceived[ucPort] = FALSE;
        gSINcntr[ucPort] = 0;
        dspipcReportIndication(ucPort, DSPIPC_SIN_FAXTONE_DETECTED);
      }
      else
        gSINcntr[ucPort]++;
    }
  }
#endif

/* V21 Preamble Detection Indication check */
  gV21IntrCntr[ucPort]++;
  if(gV21DetDone[ucPort] == FALSE)
  {
  if(gV21DetFlag[ucPort] == TRUE)
  {
     	gV21DetFlag[ucPort] = FALSE;

	if((gV21IntrCntr[ucPort] < 10)||(gV21DetCntr[ucPort] == 0))
	   gV21DetCntr[ucPort]++;
	else
	   gV21DetCntr[ucPort] = 0;

	gV21IntrCntr[ucPort] = 0;

	if(gV21DetCntr[ucPort] >= 12)
	{
           DEBUG(PRINT("V.21 Preamble detected port %d \r\n",ucPort), DEBUG_INFO);
	   dspipcReportIndication(ucPort,DSPIPC_V21_PREAMBLE_DETECTED);
	   dspipcAckV21Detection(ucPort);
	   gV21DetCntr[ucPort] = 0;
   	   gV21DetDone[ucPort] = TRUE;
	}
	}
  }
/*end of  V21 Preamble Detection Indication check */

  if(dspInfo->toneState == CA_CALL_WAIT)
  {
    if(dspInfo->uiWaitCntr >= 1000)
    {
#if !TONE_GEN
      CommandQ  *commandBuf;
#endif
      gaDspStateInfo[ucPort].uiWaitCntr = 0;
#if TONE_GEN
      ToneGenSetCountry();
      SMM_ToneType[ucPort] = CALL_WAITING_TONE1;
      ToneInit(ucPort);
      SMM_ToneGenEna[ucPort] = TONE_GEN_ACTIVE;
#else
      commandBuf = dspipcGetCmdBuf(ucPort);
      commandBuf->command[0] = H2D_TONE_GENERATE_CMD;
      tempWord = ucPort % MAX_CHANNELS_ISR;
      tempWord = (tempWord << 8) | 0x1;
      commandBuf->command[1] = tempWord;
      commandBuf->command[2] = ToneType;
      /* enque the command */
      dspipcEnqCommand(portNum);
#endif
      dspInfo->uiWaitCntr = 0;
    }
    else
      dspInfo->uiWaitCntr++;
  }
  else if(dspInfo->ucState == CA_DIGIT_RCVD)
  {
    ulTimeOut = (gaDSPTimerInfo[ucPort].uiInterDigTimer*1000)/10;
    if(dspInfo->uiIntDigTimer >= ulTimeOut)
    {
      dspipcReportIndication(ucPort,DSPIPC_INTER_DIGIT_EXPIRED);
      dspInfo->uiIntDigTimer = 0;
      dspInfo->ucState = CA_READY;
    }
    else
      dspInfo->uiIntDigTimer++;

  }
  if(dspInfo->toneState == CA_DIGIT_TONE)
  {
    ulTimeOut = 7;		// for 80 mS SAGEM LCe 03-04-2006
    if(dspInfo->uiOutBandDigTimer >= ulTimeOut)
    {
      dspInfo->toneState = CA_LOCAL_QUIT_TONE;
      dspipcQuitTone(ucPort,dspInfo->ucToneType);
      dspInfo->uiOutBandDigTimer = 0;
      // dtrDTMF start correction bugzilla 5416
      // (bug FT DR1085 : Measure VoIP PESQ with 'cProbe Radcom' crashed between 20-40 calls.)
      //dspInfo->toneState = CA_DIGIT_OFF;
      if((aucToneGenOnFxoFlag[ucPort] == 1) || (dtmfCidGen[ucPort].ucDigState == 2))
     	dspInfo->toneState = CA_DIGIT_OFF;
      else dspInfo->toneState = CA_NOTONE;
      // dtrDTMF end correction bugzilla 5416
    }
    else
      dspInfo->uiOutBandDigTimer++;
  }
#if FXO_MODULE
  else if(dspInfo->toneState == CA_DIGIT_OFF)
  {
    ulTimeOut = 7;		// for 80 mS SAGEM LCe 03-04-2006
    if(dspInfo->uiOutBandDigTimer >= ulTimeOut)
    {
      dspInfo->uiOutBandDigTimer = 0;
      if(dspInfo->ucDigitCnt == dspInfo->ucDigitLen)
      {
        dspInfo->ucDigitCnt = dspInfo->ucDigitLen=0;
#if FXO_MODULE
        aucToneGenOnFxoFlag[ucPort] = 0;
#endif
        //dspipcQuitTone(ucPort,dspInfo->ucToneType);
// LCe OpenRG Hollande change function prototype
        dspipcReportFXOIndication(ucPort,FXO_DIGIT_GEN_TONE_DONE, 0);
// LCe OpenRG Hollande
        dspInfo->toneState = CA_NOTONE;

      }
      else
      {
        dspInfo->toneState = CA_DIGIT_TONE;
        dspInfo->ucDigitCnt += 1;
        dspipcGenTone(ucPort,dspInfo->aucDigitStr[dspInfo->ucDigitCnt],0);
// LCe OpenRG Hollande
        dspipcReportFXOIndication(ucPort,FXO_DIGIT_GEN_TONE_DONE, 0);
// LCe OpenRG Hollande
      }

// LCe OpenRG Hollande
    // next digit for DTMF Caller ID
    if (dtmfCidGen[ucPort].ucDigState == 2)
	dtmfCidGenerationFlag(ucPort);
// LCe OpenRG Hollande
    }
    else
      dspInfo->uiOutBandDigTimer++;
  }
#endif
  if((dspInfo->toneState != CA_NOTONE) &&
     ((dspInfo->ucToneType  < DIG_0_TONE)||(dspInfo->ucToneType  > DIG_HASH_TONE)) && (dspInfo->toneState != CA_CALL_WAIT))
  {
    dspInfo->ulToneExpCntr++;
    if(dspInfo->ulToneExpCntr >= dspInfo->ulToneTimeOut)
    {
      CmdDigitInfo_t *cmd;
      gaDsp2HostQ.writeIdx = (gaDsp2HostQ.writeIdx + 1) %  MAX_DSP2HOST_CMDQ_BUFFS;
      cmd = &gaDsp2HostCmdBuf[gaDsp2HostQ.writeIdx];
      cmd->ucSeqNo = dspInfo->ucToneType;
      cmd->ucChannelNo = ucPort;
      cmd->ConfirmCode = DSPIPC_TONE_EXPIRED;
      dspRegFunctions.regCmdDigit();
      dspInfo->toneState = CA_LOCAL_QUIT_TONE;
      dspipcQuitTone(ucPort,dspInfo->ucToneType);
    }
  }
#if CALLER_IDTx
  if(dspInfo->ucCallWtState == CA_CONNECTED)
  {
    if((dspInfo->uiWaitCwCntr++ == CIDCW_TCW_T1)&&(SMM_CidTx[ucPort].CidTxState == CID_TX_STATE1))
    {
      dspipcGenTone(ucPort,CPE_ALERTING_TONE, 8); // 80ms
      dspInfo->ucCallWtState = CA_CIDCW;
      dspInfo->uiWaitCwCntr = 0;
    }
  }
  else if(dspInfo->ucCallWtState == CA_CIDCW)
  {
      dspInfo->uiWaitCwCntr++;

      if(dspInfo->uiWaitCwCntr ==  CIDCW_TCAS_TOUT) //30
//------>300ms = TCAS(80ms)+Tout(160ms)+Tb(60ms)
      {

         // pour prevenir lib_utils
         dspipcCidTxPlayDone(ucPort);

//printk("ACK IS NOT RECVD IN CA_CIDCW STATE on [%d] \r\n",ucPort);
//-------------------------- -----> If ACK is not received , restore voice
         SMM_CidTx[ucPort].CidTxState = CID_TX_STATE0;

// pour relancer automatiquement la CallWaitingTone apres le offHookCallerId
//         dspInfo->ucCallWtState = CA_READY;
//         dspInfo->uiWaitCwCntr = 0;
         dspInfo->ucCallWtState = CA_CIDCW_END;
         dspInfo->uiWaitCwCntr = 0;
      }
  }
  else if(dspInfo->ucCallWtState == CA_CIDCW_ACK)
  {
      dspInfo->uiWaitCwCntr++;
      if(dspInfo->uiWaitCwCntr ==  CIDCW_TFSK) //15
//----> If ACK is received , Send FSK after 60ms 60<t<200
      {
//printk("SEND CIDCW_TFSK on [%d] \r\n",ucPort);

         SMM_CidTx[ucPort].CidTxState = CID_TX_STATE2;

// pour relancer automatiquement la CallWaitingTone apres le offHookCallerId
//         dspInfo->ucCallWtState = CA_READY;
//         dspInfo->uiWaitCwCntr = 0;
         dspInfo->ucCallWtState = CA_CIDCW_END;
         dspInfo->uiWaitCwCntr = 0;
      }
  }
  else if(dspInfo->ucCallWtState == CA_CIDCW_END)
  {
// pour relancer automatiquement la CallWaitingTone apres le offHookCallerId
      dspInfo->uiWaitCwCntr++;
	 if(dspInfo->uiWaitCwCntr == 300)
      {
         dspInfo->ucCallWtState = CA_READY;
         dspInfo->uiWaitCwCntr = 0;
         dspipcGenTone(ucPort,CALL_WAITING_TONE1, 30);
      }
  }
#endif
#if FXO_MODULE
  if(dspInfo->ucMsgWiState == CA_MWI_ON)
  {
    if(dspInfo->uiMsgWiCntr++ == 30)
    {
      dspInfo->uiMsgWiCntr = 0;
      dspInfo->ucMsgWiState = CA_MWI_DIS;
      slicRingOff(ucPort);
    }
  }
  else if(dspInfo->ucMsgWiState == CA_MWI_DIS)
  {
    if(dspInfo->uiMsgWiCntr++ == 60)
    {
      dspInfo->uiMsgWiCntr = 0;
      dspInfo->ucMsgWiState = CA_READY;
      SMM_CidTx[ucPort].CidTxState = CID_TX_STATE2;
    }
  }
#endif
}
void dspipcIsr(UINT16 dspnumber)
{
  /* Read the data from DSP */
  INT32 i,j;
  UINT16  temp_addr;
  INT32 port,len;
  UINT16 codec_type;
  UINT16 pktType;
  UCHAR *pDstData;
  UINT16 offset_port;
  UINT16 temp_data;
  UINT16 frameCnt = 0;
  UINT16 CallerID = 0;		// Mbe (mars/2009)

#if DECT_TESTING
  VoiceQ_t *voiceDect;
#endif

#if THREEWAY_CONFERENCE
  UINT16 max_channel_isr = MAX_CHANNELS_ISR;
#endif

  CommandQ       cmdAcks,*pCmd;
#if T38
  t38Pkt_t *pT38;
#endif

#if !DELAY_OPT
  /*  DSP Bank Addresses */
  dspipcGetDSPBankAddress(dspnumber);
#endif
  /* Offset for the DSP to select the port number */
  offset_port = dspnumber * MAX_CHANNELS_ISR;





  /* write the commands for each channel */
  /*###################################################################################*/
  for(i=0; i<MAX_CHANNELS_ISR; i++)
  {
    port = i+offset_port;
    /* if command exists , give it to dsp */
    if(gaComandQ[port].writePtr != gaComandQ[port].readPtr)
    {
      /* Dequeue the command */
      DEBUG_ISR(PRINT("dspipcIsr => Cmd-TO-DSP[%d]\n",port), DEBUGISR);
      gaComandQ[port].readPtr = ( (gaComandQ[port].readPtr + 1) % MAX_COMMANDQ_BUF);
      pCmd = &(gaComandQ[port].commands[gaComandQ[port].readPtr]);
      for(j=0,temp_data = h2d_cmd_addr[dspnumber] +
                                (i*MAX_COMMAND_WORDS_PER_CHANNEL);
                 j<MAX_COMMAND_WORDS_PER_CHANNEL;j++,temp_data++)
      {
        dspWriteIntoDataMem(dspnumber,temp_data, pCmd->command[j]);
      }
    }
  }

    /* Read The Commands for all the channels */
  temp_addr = d2h_cmd_addr[dspnumber];
  for(i=0; i<MAX_CHANNELS_ISR; i++)
  {
    port = i+offset_port;
    for(j=0; j<MAX_COMMAND_WORDS_PER_CHANNEL; j++, temp_addr++)
    {
      cmdAcks.command[j] = dspReadDataMem(dspnumber,temp_addr);
      /* clear the commands read already */
      if(j==0)
      {
        dspWriteIntoDataMem(dspnumber,temp_addr, 0);
      }
    }
    /*
     interpret the commands read and call the callagent
     */
    dspipcCmdIntrpret(&cmdAcks, port);
  }

  temp_addr = d2h_data_addr[dspnumber];

  /* ==================================================================
     Read the Data From DSP
     =================================================================*/
#if THREEWAY_CONFERENCE
  for(i=0; i<MAX_VOICE_CHANNELS; i += 2)
#else
  for(i=0; i<MAX_CHANNELS_ISR; i++,temp_addr++)
#endif
  {
#if THREEWAY_CONFERENCE
    temp_addr = 0; //rnaidu  13.12.2005
#endif
    port = i + offset_port;

#if DECT_MODULE
    /* Read the voice packet from DECT module, if required , this
     is mainly for the case where G-711 itself is negotiated.
     NO conversion is required. */

    //dtrDECT : init pour ne pas collecter les donnes du DSP lors de com VoIP DECT G711 et G722.
    dsp2HostDataHeader[port] = 0;

    if (dectReadVoicePkt(port) == SUCCESS) {
	continue;
    }
#endif

#if THREEWAY_CONFERENCE
    temp_addr =d2h_data_addr[dspnumber]+(i/2)*MAX_PAYLOAD_SIZE_IN_WORDS + (i/2);
#endif
    dsp2HostDataHeader[port] = dspReadDataMem(dspnumber,temp_addr);  //rnaidu 13.12.2005
    codec_type = gaDspStateInfo[port].uiEncoder;
    if (ucG7115msIntrFlag[port]==1)
      ulTimeStampCntA[port] += 40;
    else
      ulTimeStampCntA[port] += 80;
    if (codec_type > 6  )
    {
      dummy_value = 0xff00 | JIT_NO_PACKET;
      if (dsp2HostDataHeader[port] > dummy_value)
      {
        dspWriteIntoDataMem(dspnumber,temp_addr,0);
      }
    }
    else
    {
      /* clear the header you read */
      dspWriteIntoDataMem(dspnumber,temp_addr,0);
    }
    dummy_value = *dummy_read_addr;
    dummy_value = *dummy_read_addr;
  }
  /* test for packet present for each channel and
   * take the action accordingly.
   */
#if THREEWAY_CONFERENCE
  for(i=0; i<MAX_VOICE_CHANNELS; i += 2)
#else
  for(i=0; i< MAX_CHANNELS_ISR; i++)
#endif
  {
    port = i+ offset_port;
    codec_type =gaDspStateInfo[port].uiEncoder;
    pktType = dsp2HostDataHeader[port] & 0xff;
    if(dsp2HostDataHeader[port] == 0)
    {
      /* no packet for this port */
      continue;
    }

    /* Dont Send Any thing Out if the mode is not correct */
    if(gDataModeEnable == TRUE)
    {
      if(dspDataMode[port] == DSP_DATA_INACTIVE
            || dspDataMode[port] == DSP_DATA_RECV_ONLY
                        || gaDspStateInfo[port].bInitDone == FALSE)
      {
        DEBUG_ISR(PRINT("dspipcIsr => Pkt Drop, incorect mode or port is not opened[%d]\n",port),
                       DEBUGISR);

#ifdef VOICE_DEBUG_TEST
     if (gaDspStateInfo[port].bInitDone != FALSE) {
		static int initDone = 0;

		initDone++;

		if (initDone == 200) {
			printk(	"%s: In Test initDone Port(%d) DSP->RTP without DECT with way(%d)-> ",
					__FUNCTION__,
					port,
      				dspDataMode[port]);

      		if (dspDataMode[port] == DSP_DATA_INACTIVE) {
				printk("INACTIVE\n");
			}

      		if (dspDataMode[port] == DSP_DATA_RECV_ONLY) {
				printk("RECV_ONLY\n");
			}

      		if (dspDataMode[port] == DSP_DATA_SEND_ONLY) {
				printk("SEND_ONLY\n");
			}

      		if (dspDataMode[port] == DSP_DATA_SEND_RECV) {
				printk("SEND_RECV\n");
			}

			initDone = 0;
		}
	}
#endif

        continue;
      }
    }
    else
    {
      if(gaDspStateInfo[port].bInitDone == FALSE)
      {
        DEBUG_ISR(PRINT("dspipcIsr => Pkt Drop, port is not opened[%d]\n",port),DEBUGISR);
        continue;
      }
    }

#ifdef VOICE_DEBUG_TEST
	{
		static int initDone = 0;

		initDone++;

		if (initDone == 200) {
			printk(	"%s: After Test initDone Port(%d) DSP->RTP without DECT dataMode(%d) way(%d)-> ",
					__FUNCTION__,
					port,
    					gDataModeEnable,
      				dspDataMode[port]);

      		if (dspDataMode[port] == DSP_DATA_INACTIVE) {
				printk("INACTIVE\n");
			}

      		if (dspDataMode[port] == DSP_DATA_RECV_ONLY) {
				printk("RECV_ONLY\n");
			}

      		if (dspDataMode[port] == DSP_DATA_SEND_ONLY) {
				printk("SEND_ONLY\n");
			}

      		if (dspDataMode[port] == DSP_DATA_SEND_RECV) {
				printk("SEND_RECV\n");
			}

			initDone = 0;
		}
	}
#endif


#if T38
    if( (pktType == JIT_FAX_DP_PACKET) && (confGetFAXMode(port) == FAX_T38_METHOD))
    {
      pT38 = &gT38TxDataBuffer[port][(gT38TxQ[port].writeIdx + 1) % MAX_T38_Q_LEN];
      codec_type = 1;
      if (ucG7115msIntrFlag[port] == 1)
        len = spPacketLen_5ms[codec_type];
      else
        len = spPacketLen[codec_type];
      pT38->ucChNum = port;
      temp_addr = d2h_data_addr[dspnumber] +
                            (i * MAX_PAYLOAD_SIZE_IN_WORDS) + MAX_CHANNELS_ISR;
      pDstData = pT38->aucPayload;
      pT38->ucPktLen = T38_PAYLOAD_LEN;
      /* Write Data Payload */
      for (j = 0; j < len; temp_addr++, j += 2)
      {
        temp_data = dspReadDataMem(dspnumber, temp_addr);
        *(pDstData + j) = (UCHAR) temp_data & 0xff;
        *(pDstData + j + 1) = (UCHAR) ((temp_data >> 8) & 0xff);
        dummy_value = *dummy_read_addr;
        dummy_value = *dummy_read_addr;
      }
      gT38TxQ[port].writeIdx = (gT38TxQ[port].writeIdx + 1) % MAX_T38_Q_LEN;
      continue;
    }
#endif


#if DECT_TESTING
    /* Send the sample to the DECT simulator */
    if( (pktType == JIT_SPEECH_PACKET) && (port == 0))
    {
      voiceDect = dectHWRead();
      len  = spPacketLen[codec_type];
#if THREEWAY_CONFERENCE
      /* If three way conf is enabled, max_channel_isr = 2 else 1 */
      temp_addr = d2h_data_addr[dspnumber] + (i/2)*MAX_PAYLOAD_SIZE_IN_WORDS
                                         + max_channel_isr + (i/2);
#else
      temp_addr = d2h_data_addr[dspnumber] +
                 (i*MAX_PAYLOAD_SIZE_IN_WORDS) + MAX_CHANNELS_ISR;
#endif
      pDstData = voiceDect->aucPayload;
      /* Write Data Payload */
      for(j=0; j<len; temp_addr++,j+= 2)
      {
        temp_data = dspReadDataMem(dspnumber,temp_addr);
        *(pDstData+j) = (UCHAR)temp_data & 0xff;
        *(pDstData+j+1) = (UCHAR)((temp_data >> 8) & 0xff);
        dummy_value = *dummy_read_addr;
        dummy_value = *dummy_read_addr;
      }
      dectHWReadDone();
      continue;
    }
#endif

    if(pktType == JIT_SPEECH_PACKET)
    {
#if T38
      if(gbT38Negotiated[port] == TRUE)
      {
          continue;
      }
#endif
      /* Speech Packet */
      if(gVoiceBuf[port] == NULL ||
              gVoiceBuf[port]->cFrameCounter ==0 ||
                    gVoiceBuf[port]->cFrameCounter >= confGetMaxFrames(port))
      {
        /* Allocate one voice Packet */
        gVoiceTxQ[port].writeIdx =
                  (gVoiceTxQ[port].writeIdx + 1) % MAX_TX_VOICE_Q;
        gVoiceBuf[port] = &(gVoiceTxQBuffer[port][gVoiceTxQ[port].writeIdx]);
        gVoiceBuf[port]->ucPktLen = 0;
        gVoiceBuf[port]->cFrameCounter = 0;
        gVoiceBuf[port]->ucChNum = port;
      }
      if(ucG7115msIntrFlag[port] == 1)
        len  = spPacketLen_5ms[codec_type];
      else
        len  = spPacketLen[codec_type];
      frameCnt = gVoiceBuf[port]->cFrameCounter + 1;
      DEBUG_ISR(PRINT("dspipcIsr => SP-PKT-from-DSP[%d]\n",port),DEBUGISR);

#ifdef VOICE_SYSCTL_STATS
      /* Stats */
      {
        dsp_voiceSysCtl.ports[port].stats.network.dsp.rcvSpeech.pkts	++;
        dsp_voiceSysCtl.ports[port].stats.network.dsp.rcvSpeech.bytes	+= len;
      }
#endif
    }
    else
    {
       /* check if any speech packet is already available for transmission, if so release
          the packet to RTP */
      if(gVoiceBuf[port] != NULL)
        gVoiceBuf[port]->cFrameCounter = confGetMaxFrames(port);


      /* VAD PAcket */
      if(gVoiceBuf[port] == NULL ||
              gVoiceBuf[port]->cFrameCounter ==0 ||
                    gVoiceBuf[port]->cFrameCounter == confGetMaxFrames(port))
      {
        /* Allocate one voice Packet */
        gVoiceTxQ[port].writeIdx =
                  (gVoiceTxQ[port].writeIdx + 1) % MAX_TX_VOICE_Q;
        gVoiceBuf[port] = &(gVoiceTxQBuffer[port][gVoiceTxQ[port].writeIdx]);
        gVoiceBuf[port]->ucPktLen = 0;
        gVoiceBuf[port]->cFrameCounter = 0;
        gVoiceBuf[port]->ucChNum = port;
      }
      len = vadPacketLen[codec_type];
      /* VAD Packets, we need to send ASAP */
      frameCnt = confGetMaxFrames(port);
      DEBUG_ISR(PRINT("dspipcIsr => VAD-PKT-from-DSP[%d]\n",port),DEBUGISR);

#ifdef VOICE_SYSCTL_STATS
      /* Stats */
      {
        dsp_voiceSysCtl.ports[port].stats.network.dsp.rcvSpeech.pkts	++;
        dsp_voiceSysCtl.ports[port].stats.network.dsp.rcvSpeech.bytes	+= len;
      }
#endif
    }
    gVoiceBuf[port]->ucChNum = port;
    //PacketLenTable[i];   // Need to define A Table A Fixed Table
    gVoiceBuf[port]->ulTimeStamp = ulTimeStampCntA[port];
#if THREEWAY_CONFERENCE
    /* If three way conf is enabled, max_channel_isr = 2 else 1 */
    temp_addr = d2h_data_addr[dspnumber] + (i/2)*MAX_PAYLOAD_SIZE_IN_WORDS
                                            + max_channel_isr + (i/2);
#else
    temp_addr = d2h_data_addr[dspnumber] +
                   (i*MAX_PAYLOAD_SIZE_IN_WORDS) + MAX_CHANNELS_ISR;
#endif
    pDstData = &(gVoiceBuf[port]->aucPayload[12+gVoiceBuf[port]->ucPktLen]);
    gVoiceBuf[port]->ucPktLen +=len;
    /* Write Data Payload */
    for(j=0; j < len; temp_addr++,j += 2)
    {
      temp_data = dspReadDataMem(dspnumber,temp_addr);
      *(pDstData+j) = (UCHAR)temp_data & 0xff;
      *(pDstData+j+1) = (UCHAR)((temp_data >> 8) & 0xff);
      dummy_value = *dummy_read_addr;
      dummy_value = *dummy_read_addr;
    }
    gVoiceBuf[port]->cFrameCounter = frameCnt;
  }

  /*============================================================================*/
  /* Write the Voice data to DSP */
#if THREEWAY_CONFERENCE
  for(i=0; i<MAX_VOICE_CHANNELS; i += 2)
#else
  for(i=0; i< MAX_CHANNELS_ISR; i++)
#endif
  {
    port = i + offset_port;
#if DECT_MODULE
 //   if(dectPassThrEnabled(port) == FAILURE)
#endif
    if(gaDspStateInfo[port].bInitDone == FALSE)
      continue;

#ifdef VOICE_DEBUG_TEST
	{
		static int initDone = 0;

		initDone++;

		if (initDone == 200) {
			printk(	"%s: initDone Port(%d) RTP->DSP\n",
					__FUNCTION__,
					port);
			initDone = 0;
		}
	}
#endif

    codec_type =gaDspStateInfo[port].uiEncoder;

    SMMJitBuff[port].RxPktProp = JIT_NO_PACKET;

#if DRV_DEBUG_STAT
    VoiceDebugStat[port].ajbReadCnt++;
#endif
    AJBRead(port);
#if T38
   if(gbT38Negotiated[port] == TRUE)
     SMMJitBuff[port].RxPktProp = JIT_NO_PACKET;
    if( (gT38RxQ[port].writeIdx != gT38RxQ[port].readIdx)
	&& (confGetFAXMode(port) == FAX_T38_METHOD) )
    {
      gT38RxQ[port].readIdx = (gT38RxQ[port].readIdx + 1) % MAX_T38_Q_LEN;
      pT38 = &gT38RxDataBuffer[port][gT38RxQ[port].readIdx];
      dspWriteIntoDataMem(dspnumber,h2d_data_addr[dspnumber] + i,
                                           JIT_FAX_DP_PACKET);
      temp_addr = h2d_data_addr[dspnumber] +
                                 (i * MAX_PAYLOAD_SIZE_IN_WORDS) + MAX_CHANNELS_ISR;
      dummy_value = *dummy_read_addr;
      dummy_value = *dummy_read_addr;
      for (j = 0; j < T38_PAYLOAD_LEN; j = j + 2, temp_addr++)
      {
        temp_data = pT38->aucPayload[j] | (pT38-> aucPayload[j + 1] << 8);
        dummy_value = *dummy_read_addr;
        dspWriteIntoDataMem(dspnumber, temp_addr,temp_data);
        dummy_value = *dummy_read_addr;
        dummy_value = *dummy_read_addr;
      }
      continue;
    }
#endif
#if TONE_GEN
    if(SMM_ToneGenEna[port] == TONE_GEN_ACTIVE)
    {

#ifdef VOICE_DEBUG_TEST
	{
		static int toneDone = 0;

		toneDone++;

		if (toneDone == 200) {
			printk(	"%s: Tone Port(%d)\n",
					__FUNCTION__,
					port);

			toneDone = 0;
		}
	}
#endif

      DEBUG_ISR(PRINT("dspipcIsr => TINE-ACTIVE[%d]\n",port),DEBUGISR);
      if(ucG7115msIntrFlag[port] == 1)
      {
        ToneLen = 40;
      }
      else
        ToneLen = 80;
      ToneGen(port,ToneLen);
      mu_compress(speech, SMMJitBuff[port].RxBuff);

#ifdef VOICE_SYSCTL_STATS
     /* Stats */
     {
       dsp_voiceSysCtl.ports[port].stats.network.dsp.sndTone.pkts		++;
       dsp_voiceSysCtl.ports[port].stats.network.dsp.sndTone.bytes	+= ToneLen;
     }
#endif
/* SAGEM { */
#if DECT_MODULE
#if 0
      if(dectWriteTone(port,
                        SMMJitBuff[port].RxBuff,
                        SMMJitBuff[port].RxFrameLen) == SUCCESS)
	continue;
#endif
#endif
/* } */

#if THREEWAY_CONFERENCE
      /* host writes the voice_pkt_header for that channel*/
      temp_addr = h2d_data_addr[dspnumber] + (i/2)*MAX_PAYLOAD_SIZE_IN_WORDS + (i/2);
#else
      temp_addr = h2d_data_addr[dspnumber] + i;
#endif
#if FXO_MODULE
      if(aucToneGenOnFxoFlag[port] == 1)
         dspWriteIntoDataMem(dspnumber,temp_addr, 8);
      else
#endif
        dspWriteIntoDataMem(dspnumber,temp_addr, JIT_TONE_PACKET);
#if THREEWAY_CONFERENCE
      temp_addr = h2d_data_addr[dspnumber] + (i/2)*MAX_PAYLOAD_SIZE_IN_WORDS +
                  max_channel_isr + (i/2);
#else
      temp_addr = h2d_data_addr[dspnumber] + (i*MAX_PAYLOAD_SIZE_IN_WORDS) +
                     MAX_CHANNELS_ISR;
#endif
      dummy_value = *dummy_read_addr;
      /* write the payload  */
      for(j=0; j<ToneLen; j=j+2,temp_addr++)
      {
        temp_data = SMMJitBuff[port].RxBuff[j] ;
        temp_data = temp_data |  (SMMJitBuff[port].RxBuff[j+1] << 8);
        dummy_value = *dummy_read_addr;
        dspWriteIntoDataMem(dspnumber,temp_addr,temp_data);
        dummy_value = *dummy_read_addr;
        dummy_value = *dummy_read_addr;
      }
      continue;   /* Nothing to do when tone is active */
    }
#endif
#if CALLER_IDTx
    if(SMM_CidTx[port].CidTxState > CID_TX_STATE0 )
    {
      DEBUG_ISR(PRINT("dspipcIsr => CALLER-ID-PLAY State: %d  Port %d\n",
                                 SMM_CidTx[port].CidTxState,port),DEBUGISR);
      CidTxPlay1(port);
      CallerID =1;		// Mbe (mars/2009) bug 18628
    }
#endif

#if DECT_TESTING
    if(port == 0)
    {
      voiceDect = dectHWWrite();
      if(voiceDect != NULL)
      {
        temp_data = JIT_SPEECH_PACKET;
      }
      else
        temp_data = JIT_NO_PACKET;

    }
    else
#endif

    temp_data =  SMMJitBuff[port].RxPktProp & 0x00FF;
    if(temp_data != JIT_NO_PACKET )
    {

#ifdef VOICE_DEBUG_TEST
	{
		static int dataDone = 0;

		dataDone++;

		if (dataDone == 200) {
			printk(	"%s: Data Port(%d) RTP->DSP\n",
					__FUNCTION__,
					port);

			dataDone = 0;
		}
	}
#endif

      DEBUG_ISR(PRINT("dspipcIsr => AJB-SP-PKT Port %d\n",port),DEBUGISR);
#if !DECT_TESTING
#if G711_PLC
      //--> AJB SPEECH_PACKET Case
      if( temp_data == JIT_VAD_PACKET )  // vvenkat
        PrevSidEnable_VAD[port] = 0;
      else
        PrevSidEnable_VAD[port] = 1;
      if((temp_data == JIT_SPEECH_PACKET) && (confGetPLC(port) == TRUE))
      {
        if((codec_type == 0) ||(codec_type == 1)) /* G711 Mu law = 1 , G711 A law = 0 */
        {
          if(codec_type == 1)
            mu_expand(SMMJitBuff[port].RxBuff,speech);
          else if(codec_type == 0)
            a_expand(SMMJitBuff[port].RxBuff,speech);
          G711PLC((port),JIT_SPEECH_PACKET);

          if(codec_type == 1)
            mu_compress(speech,SMMJitBuff[port].RxBuff);
          else if(codec_type == 0)
            a_compress(speech,SMMJitBuff[port].RxBuff);

           //here to write in DSP
          SMMJitBuff[port].RxFrameLen=80;

        }
      }
#endif
#endif

#if DECT_MODULE
	  if (!CallerID)		// Mbe (mars/2009) bug 18628
      	if(dectWriteVoice(	port,
                        	SMMJitBuff[port].RxBuff,
                        	SMMJitBuff[port].RxFrameLen) == SUCCESS)
	continue;

#endif

#ifdef VOICE_SYSCTL_STATS
     /* Stats */
     {
       dsp_voiceSysCtl.ports[port].stats.network.dsp.sndSpeech.pkts	++;
       dsp_voiceSysCtl.ports[port].stats.network.dsp.sndSpeech.bytes	+= SMMJitBuff[port].RxFrameLen;
     }
#endif

#if THREEWAY_CONFERENCE
      temp_addr = h2d_data_addr[dspnumber] + (i/2)*MAX_PAYLOAD_SIZE_IN_WORDS + (i/2);
#else
      temp_addr = h2d_data_addr[dspnumber] + i;
#endif

      /* host writes the voice_pkt_header for that channel*/
#if DECT_TESTING
      if(port == 0)
        dspWriteIntoDataMem(dspnumber,temp_addr, temp_data);
      else
#endif
      dspWriteIntoDataMem(dspnumber,temp_addr, SMMJitBuff[port].RxPktProp);

#if THREEWAY_CONFERENCE
      temp_addr = h2d_data_addr[dspnumber] +
                (i/2)*MAX_PAYLOAD_SIZE_IN_WORDS +  max_channel_isr + (i/2);
#else
      temp_addr = h2d_data_addr[dspnumber] +
                (i*MAX_PAYLOAD_SIZE_IN_WORDS) +  MAX_CHANNELS_ISR;
#endif
      dummy_value = *dummy_read_addr;
      /* write the payload  */
#if DECT_TESTING
      if(port == 0)
         SMMJitBuff[port].RxFrameLen = 80;
#endif

      for(j=0; j < SMMJitBuff[port].RxFrameLen; j=j+2,temp_addr++)
      {
#if DECT_TESTING
        if(port == 0)
        {
          temp_data = voiceDect->aucPayload[j];
          temp_data = temp_data |  (voiceDect->aucPayload[j+1] << 8);
        }
        else
        {
#endif

        temp_data = SMMJitBuff[port].RxBuff[j] ;
        temp_data = temp_data |  (SMMJitBuff[port].RxBuff[j+1] << 8);

#if DECT_TESTING
        }
#endif

        dummy_value = *dummy_read_addr;
        dspWriteIntoDataMem(dspnumber,temp_addr, temp_data);
        dummy_value = *dummy_read_addr;
        dummy_value = *dummy_read_addr;
      }
#if DRV_DEBUG_STAT
      VoiceDebugStat[port].ajbSpeechPkt++;
#endif

    } //end of AJB SPEECH_PACKET case
    else
    {

#if DRV_DEBUG_STAT
      VoiceDebugStat[port].ajbNULLPkt++;
#endif
      /* added PrevSidEnable for CONTINUOUS SILENCE */
#if !DECT_TESTING
#if G711_PLC
      /* G711 Mu law = 1 , G711 A law = 0 */
      if((confGetPLC(port) == TRUE)&&(PrevSidEnable_VAD[port] == 1)&& (codec_type <= 1))
      {
        DEBUG_ISR(PRINT("dspipcIsr => PLC-SIL-PKT Port %d\n",port),DEBUGISR);
        G711PLC((port),JIT_NO_PACKET);
        if(codec_type == 1)
          mu_compress(speech,SMMJitBuff[port].RxBuff);
        else if(codec_type == 0)
          a_compress(speech,SMMJitBuff[port].RxBuff);

        //here i added  forcebly length
        SMMJitBuff[port].RxFrameLen=80;
#if THREEWAY_CONFERENCE
        temp_addr = h2d_data_addr[dspnumber] + (i/2)*MAX_PAYLOAD_SIZE_IN_WORDS + (i/2);
#else
        temp_addr = h2d_data_addr[dspnumber] + i;
#endif
        /* host writes the voice_pkt_header for that channel*/
        dspWriteIntoDataMem(dspnumber,temp_addr, JIT_SPEECH_PACKET);
#if THREEWAY_CONFERENCE
        temp_addr = h2d_data_addr[dspnumber] +
                 (i/2)*MAX_PAYLOAD_SIZE_IN_WORDS +  max_channel_isr + (i/2);
#else
        temp_addr = h2d_data_addr[dspnumber] +
                 (i*MAX_PAYLOAD_SIZE_IN_WORDS) + MAX_CHANNELS_ISR;
#endif
        dummy_value = *dummy_read_addr;
        /* write the payload  */
        //for(j=0; j<80; j=j+2,temp_addr++) //SMMJitBuff[port].RxFrameLen
        for(j=0; j<SMMJitBuff[port].RxFrameLen; j=j+2,temp_addr++)
        {
          temp_data = SMMJitBuff[port].RxBuff[j] ;
          temp_data = temp_data |  (SMMJitBuff[port].RxBuff[j+1] << 8);
          dummy_value = *dummy_read_addr;
          dspWriteIntoDataMem(dspnumber,temp_addr, temp_data);
          dummy_value = *dummy_read_addr;
          dummy_value = *dummy_read_addr;

        }
      }//--> end of PCMU/PCMA case
      else
#endif
#endif
      {
        DEBUG_ISR(PRINT("dspipcIsr => AJB-SIL-PKT Port %d\n",port),DEBUGISR);
        dummy_value = *dummy_read_addr;
        dummy_value = *dummy_read_addr;
#if THREEWAY_CONFERENCE
        temp_addr = h2d_data_addr[dspnumber] + (i/2)*MAX_PAYLOAD_SIZE_IN_WORDS + (i/2);  //rnaidu 13.12.2005
#else
        temp_addr = h2d_data_addr[dspnumber] + i;
#endif
#if DECT_TESTING
        if(port == 0)
          dspWriteIntoDataMem(dspnumber,temp_addr, temp_data);
        else
#endif
        dspWriteIntoDataMem(dspnumber,temp_addr, SMMJitBuff[port].RxPktProp);

        dummy_value = *dummy_read_addr;
        dummy_value = *dummy_read_addr;

      } //end of else part
    } //--> END OF AJB NO_PACKET CASE
  }
  /* For Ring Timouts */
  for(i=0;i< MAX_CHANNELS_ISR;i++)
  {
    dspipcUpdateRings(i+offset_port);
    if(ToneParams[i+offset_port].ulCadenceDuration>0)
    {
      if(SMM_CadPlayStopFlag[i+offset_port]==2)
      {
       dspipcQuitTone(i+offset_port, ToneParams[i+offset_port].ulToneId);
      }
    }
  }

#if DTMFRX
  for(i=0; i < MAX_CHANNELS_ISR; i++)
  {
    port  = i+offset_port;
    SMMDtmfrxDSP2HostBuff[port][0]= DTMFRX_NULL_PACKET;
    cw1  = DtmfrxMemAdd[dspnumber] + i * DSP2HOST_DTMFRX_CMD_LEN;
    //--------------------DSP2HOSTDTMFRX-----------------------------------
    if( HDtmfrx_reset_on[port]== 2 )
    {
      SMMDtmfrxDSP2HostBuff[port][0]=  dspReadDataMem(dspnumber,cw1 );
      temp_addr = cw1;
      cw1++; //DtmfrxMemAdd++;
      if( SMMDtmfrxDSP2HostBuff[port][0] == 0x1111 )
      {
        dspWriteIntoDataMem(dspnumber,temp_addr, 0x0);
        SMMDtmfrxDSP2HostBuff[port][0] = DTMFRX_PACKET;
        for( j= 1; j < DSP2HOST_DTMFRX_CMD_LEN; j++ )
        {
          SMMDtmfrxDSP2HostBuff[port][j]=  dspReadDataMem(dspnumber,cw1 );
          cw1++;  //DtmfrxMemAdd++;
        }//--> End of 8-Words Read done.
        //DtmfrxIpcRead(i);
      } //--> End of reset Flag Check.
    } //--> End of for Loop for Max Voice Channels
    HDtmfrxDet(port);
  } //--> End of for Loop for Max Voice Channels
#endif
#if FXO_MODULE
#if CID_RX_DET
  for(i=0; i < MAX_CHANNELS_ISR; i++)
  {
    port = (i+offset_port);
    if(confGetToneDetect(port) ||
                  (confGetFXOCallerIdDetectEnabled() && (dspnumber == 0)))
    {
      dummy_value = *dummy_read_addr;
      dummy_value = *dummy_read_addr;
      dummy_value = *dummy_read_addr;
      temp_addr = DSP_FXO_BUFFER_ADDR;
      for(j=0;j<80; j++)
      {
        dummy_value= dspReadDataMem(port, temp_addr);
        speech[j] = dummy_value;
        dummy_value = *dummy_read_addr;
        dummy_value = *dummy_read_addr;
        temp_addr++;
      }
      /* We detect caller ID only for DSP1 */
      /* get the samples from FXO buffer */
      if(confGetFXOCallerIdDetectEnabled() && (dspnumber == 0))
      {
        Pre_Process(speech,80,0);
        CidRxMain(speech,0);
      }
      if(confGetToneDetect(port))
      {
        ToneDetmain(port);
      }
    }
  }
#endif
#endif

// dtr bugzilla miniV2 7901 :
// la commande dspWriteIntoDataMem(dspNumber,0x3fb2, 1) est supprime des tasklets osDSP1Tasklet(),
// osDSP2Tasklet() et introduite  la fin de la routine d'interruption dspipcIsr()
// pour supprimer la perte d'interruptions 10 ms des DSP en presence de trafic WAN/LAN
// (notamment download ftp ADSL/WIFI > 16/17 Mbps et upstream udp de paquets IP de qq d'10 d'octets
// ETH/ADSL et WIFI/ADSL).
dspWriteIntoDataMem(dspnumber,0x3fb2, 1);
}

INT16 getEncDecType(UINT16 uiEncDecType)
{
  uiEncDecType &= 0x7FFF;
  uiEncDecType >>= 11;
  return uiEncDecType;
}


void dspipcSetCallWtState(UINT16 CurChanNum)
{
  gaDspStateInfo[CurChanNum].uiWaitCwCntr = 0;
  gaDspStateInfo[CurChanNum].ucCallWtState = CA_CONNECTED;
#if CALLER_IDTx
  SMM_CidTx[CurChanNum].CidTxState = CID_TX_STATE1;
  SMM_CidTx[CurChanNum].TimerCntr = 0;
#endif

}


/*======================================================================
 * Function Name        : dspipcRegVoiceFromDsp
 * Description          : store the function call for voice data pkt
 *======================================================================
 */
void dspipcRegVoiceFromDsp(void (*f)(void))
{
    dspRegFunctions.voicePkt = f;
}

void dspipcUnRegVoiceFromDsp(void)
{
    dspRegFunctions.voicePkt = NULL;
}

/*======================================================================
 * Function Name        : dspipcRegDigitFromDsp
 * Description          : store the function call for the digit reg. pkt
 *======================================================================
 */
void dspipcRegCmdDigitFromDsp(void (*f)(void))
{
    dspRegFunctions.regCmdDigit = f;
}



INT32 dspipcGetDSPCmdCount(void)
{
  if(gaDsp2HostQ.writeIdx == gaDsp2HostQ.readIdx)
    return 0;
  return 1;
}


INT32 dspipcGetVoicePktCnt(int context)
{
  int readIdx;
  int iIndex;
  for(iIndex=0; iIndex < MAX_VOICE_CHANNELS; iIndex++)
  {
    if(gVoiceTxQ[iIndex].readIdx != gVoiceTxQ[iIndex].writeIdx)
    {
      readIdx = (gVoiceTxQ[iIndex].readIdx + 1) %  MAX_TX_VOICE_Q;
      if(gVoiceTxQBuffer[iIndex][readIdx].cFrameCounter
                                     >= confGetMaxFrames(iIndex) )
      {
        if(context == 2)
        {
#if KERNEL_RTP_INTERFACE
  	     if ( (pNWCallBack != (dsp_regNetwork_t *)0) && (pNWCallBack->evtFromDsp != (dsp_network_evtFromDsp_f)0) ) {
#ifdef VOICE_SYSCTL_STATS
           /* Stats */
           dsp_voiceSysCtl.ports[iIndex].stats.network.rtp.snd.voiceReady++;
#endif

	      pNWCallBack->evtFromDsp(DSP_NETWORK_Evt_fromDsp_voice_ready, iIndex, (void *)0);
          }
#else
          if(dspRegFunctions.voicePkt != NULL) {
            dspRegFunctions.voicePkt();
          }
#endif
        }
        return iIndex;
      }
    }
  }
  return FAILURE;
}


void dspipcClearQs(UINT16 iIndex)
{
  osLockTasklet(iIndex);
  gVoiceTxQ[iIndex].readIdx = 0;
  gVoiceTxQ[iIndex].writeIdx = 0;
  gVoiceBuf[iIndex] = NULL;
  AJBSet(iIndex,AJB_READ_RATE_MS);
  osUnlockTasklet(iIndex);
}

#if T38
INT32 dspipcGetT38PktCnt(int context)
{
  UINT16 iIndex;
  for(iIndex =0; iIndex < MAX_VOICE_CHANNELS; iIndex++)
  {
    if(gT38TxQ[iIndex].readIdx != gT38TxQ[iIndex].writeIdx)
    {
      if(context == 2)
      {
        if(dspRegFunctions.t38Data != NULL)
          dspRegFunctions.t38Data();
      }
      return 1;
    }
  }
  return 0;
}
void dspipcResetT38Q(UINT16 iIndex)
{
  osLockTasklet(iIndex);
  gT38TxQ[iIndex].readIdx = 0;
  gT38TxQ[iIndex].writeIdx = 0;
  osUnlockTasklet(iIndex);
}
t38Pkt_t* dspipcGetT38Pkt(UINT16 portNum)
{
  if(gT38TxQ[portNum].readIdx != gT38TxQ[portNum].writeIdx)
  {
    gT38TxQ[portNum].readIdx = (gT38TxQ[portNum].readIdx + 1) % MAX_T38_Q_LEN;
    return &gT38TxDataBuffer[portNum][gT38TxQ[portNum].readIdx];
  }
  return NULL;
}
/**********************************************************************************
 *  Function Name  : dspipcWriteT38DataPkt.                                       *
 *  Description    : Function to be used for writing T.38 data to DSP.            *
 *  Input          : T.38 Buffer and Length of the Buffer.                        *
 *  Output         : None.                                                        *
 *  Return Value   : Number of bytes written  .                                   *
 *********************************************************************************/
int dspipcWriteT38DataPkt(UCHAR *pT38Data)
{
  UCHAR port;
  UCHAR ucWriteIndex;
  t38Pkt_t *pT38;
  /* Look for the port Number */
  copy_from_user((UCHAR*)&port,(UCHAR*)pT38Data,sizeof(UCHAR));
  if(port > MAX_VOICE_CHANNELS)
    return 0;
  ucWriteIndex = (gT38RxQ[port].writeIdx + 1) % MAX_T38_Q_LEN;
  pT38 = &gT38RxDataBuffer[port][ucWriteIndex];
  copy_from_user((UCHAR*)pT38,pT38Data,sizeof(t38Pkt_t));
  gT38RxQ[port].writeIdx = ucWriteIndex;
  return (sizeof(t38Pkt_t));
}
void dspipcSwitchToT38(UINT16 portNum)
{
  UINT16 tempWord;
  CommandQ  *commandBuf = dspipcGetCmdBuf(portNum);
  gbT38Negotiated[portNum] = TRUE;
  commandBuf->command[0] = H2D_CED_TONE_RCVD_CMD ;
  tempWord = portNum % MAX_CHANNELS_ISR;
  tempWord = (tempWord << 8) ;
  commandBuf->command[1] = tempWord;
  /* enque the command */
  dspipcEnqCommand(portNum);
}
/*======================================================================
 * Function Name        : dspipcRegT38PacketFromDsp
 * Description          : store the function callback for T.38
 *======================================================================
 */
void dspipcRegT38PacketFromDsp(void (*f)(void))
{
    dspRegFunctions.t38Data = f;
}
#endif

VoiceQ_t* dspipcGetVoicePkt(UINT16 portNum, UCHAR ucSessType)
{
  int index;
  switch(ucSessType)
  {
    case DSP_MEDIA_AUDIO:
      if(gVoiceTxQ[portNum].readIdx != gVoiceTxQ[portNum].writeIdx)
      {
        index = (gVoiceTxQ[portNum].readIdx + 1) %  MAX_TX_VOICE_Q;
        if(gVoiceTxQBuffer[portNum][index].cFrameCounter
                                       >= confGetMaxFrames(portNum) )
        {
          gVoiceTxQ[portNum].readIdx = index;
          return  &(gVoiceTxQBuffer[portNum][index]);
        }
      }
      return NULL;
      break;
    case DSP_MEDIA_DATA:
      printk("Fax is not present\r\n");
      break;
    default:
      printk("Default media type [%d] \r\n",ucSessType);
      break;
  }
  return NULL;
}

CmdDigitInfo_t* dspipcGetCmdPkt(void)
{
  gaDsp2HostQ.readIdx = (gaDsp2HostQ.readIdx + 1) % MAX_DSP2HOST_CMDQ_BUFFS;
  return &gaDsp2HostCmdBuf[gaDsp2HostQ.readIdx];
}

#if FXO_MODULE
void dspipcFXOCallerIdDetected(UCHAR port,UCHAR CidTxFlag,UCHAR *ucRemoteUserNum,
                   UCHAR *ucRemoteUserName,UCHAR *DateBuffStr, UCHAR CidType)
{
  CmdDigitInfo_t *pCmd;
  int index;
  CallerIdInfo_t *pCallerId;

  index = (gaFxo2HostQ.writeIdx + 1) %  MAX_DSP2HOST_CMDQ_BUFFS;
  pCmd = &gaFxo2HostCmdBuf[index];
  pCmd->ConfirmCode = FXO_CALLERID_DETECTED;
  pCallerId = &(pCmd->fxoCallerIdDet);
  memset(pCallerId,0,sizeof(*pCallerId));
  pCallerId->CidTxFlag = CidTxFlag;
  memcpy(pCallerId->aucRemoteUserNum,ucRemoteUserNum,
                    sizeof(pCallerId->aucRemoteUserNum));
  memcpy(pCallerId->aucRemoteUserName,ucRemoteUserName,
                    sizeof(pCallerId->aucRemoteUserName));
  memcpy(pCallerId->aucDateBuffStr,DateBuffStr,
                    sizeof(pCallerId->aucDateBuffStr));
  pCallerId->CidType = CidType;
  pCallerId->uiCurChanNum = port;
  gaFxo2HostQ.writeIdx = index;
  dspRegFunctions.fxoEventRcv();

}
void dspipcToneIndication(unsigned portNum,unsigned short Tonetype)
{
  CmdDigitInfo_t *cmd;
  int index;
  index = (gaFxo2HostQ.writeIdx + 1) %  MAX_DSP2HOST_CMDQ_BUFFS;
  cmd = &gaFxo2HostCmdBuf[index];
  cmd->ConfirmCode = FXO_TONE_DETECTED;
  cmd->ucSeqNo = Tonetype;
  cmd->ucChannelNo = portNum;
  gaFxo2HostQ.writeIdx = index;
  dspRegFunctions.fxoEventRcv();
}
/****************************************************************************
  Reset Digit Information Structure.
 ***************************************************************************/
void dspipcResetDigitState(UINT16 CurChanNum)
{
  gaDspStateInfo[CurChanNum].ucDigitCnt = 0;
  gaDspStateInfo[CurChanNum].ucDigitLen = 0;
  gaDspStateInfo[CurChanNum].uiOutBandDigTimer = 0;

}
/****************************************************************************
  Call back handler registeration for all FXO related events.
 ***************************************************************************/
void dspipcRegFXOStateChangeHandler(void (*f)(void))
{
  dspRegFunctions.fxoEventRcv = f;
}
/****************************************************************************
  Function to clear FXO circular Queue.
 ***************************************************************************/
void dspipcResetFXOQ(void)
{
  osLockInterrupts();
  gaFxo2HostQ.readIdx = 0;
  gaFxo2HostQ.writeIdx = 0;
  osUnlockInterrupts();
}
/****************************************************************************
  Function to check if there is any FXO events pending.
 ***************************************************************************/
INT32 dspipcGetFXOCmdCount(void)
{
  if(gaFxo2HostQ.writeIdx == gaFxo2HostQ.readIdx)
    return 0;
  return 1;
}
/****************************************************************************
  Function to read Pending FXO events.
 ***************************************************************************/
CmdDigitInfo_t* dspipcGetFXOCmdPkt(void)
{
  gaFxo2HostQ.readIdx = (gaFxo2HostQ.readIdx + 1) % MAX_DSP2HOST_CMDQ_BUFFS;
  return &gaFxo2HostCmdBuf[gaFxo2HostQ.readIdx];
}
/****************************************************************************
  Function to report FXO events to the waiting task.
 ***************************************************************************/
void dspipcReportFXOIndication(UINT16 portNum, int indication, UINT16 cptr)
{
  CmdDigitInfo_t *cmd;
  int index;
  index = (gaFxo2HostQ.writeIdx + 1) %  MAX_DSP2HOST_CMDQ_BUFFS;
  cmd = &gaFxo2HostCmdBuf[index];
  cmd->ucChannelNo = portNum;
  cmd->ConfirmCode = indication;
  cmd->cptr_FXO = cptr;
  gaFxo2HostQ.writeIdx = index;
  dspRegFunctions.fxoEventRcv();
}
/****************************************************************************
  Function to connect DSP for FXS to FXO .
 ***************************************************************************/
void dspipcDSPConnection(pstnDspCmdInfo_t *pstnDspInfoPtr)
{
  CommandQ  *commandBuf  = NULL;
  UCHAR ucPortNum = pstnDspInfoPtr->ucPortNo;
  switch(pstnDspInfoPtr->ConnectType)
  {
    case TIMESLOT:
      commandBuf = dspipcGetCmdBuf(ucPortNum);
      commandBuf->command[0] = H2D_CNCT_TONEDTMF_FXSFXO;
      commandBuf->command[2] = 1; // 1 for FXS <---> FXO loop back
      /* enque the command */
      dspipcEnqCommand(ucPortNum);
      aucToneGenOnFxoFlag[ucPortNum] = 0;
      break;
    case TS_FXO2FXS_LB:
      commandBuf = dspipcGetCmdBuf(ucPortNum);
      commandBuf->command[0] = H2D_CNCT_TONEDTMF_FXSFXO;
      commandBuf->command[1] = 0; //portNum
      commandBuf->command[2] = 2; //for FXO ---> FXS loop back
      dspipcEnqCommand(ucPortNum);
      break;
#if 0
    case TONE_DSP:
      pstnDspInfoPtr->uiCmdParams[0] = DIG_1_TONE;
      dspipcGenTone(ucPortNum,pstnDspInfoPtr->uiCmdParams[0],0);
      aucToneGenOnFxoFlag[ucPortNum] = 1;
      break;
#endif
    case DTMF_DSP:
      {
        UCHAR ucCnt,temp;
        if(aucToneGenOnFxoFlag[ucPortNum]==0)
        {
          for(ucCnt=0;ucCnt<pstnDspInfoPtr->uiLen;ucCnt++)
          {
            temp = pstnDspInfoPtr->uiCmdParams[ucCnt];
            gaDspStateInfo[ucPortNum].aucDigitStr[ucCnt] = temp;
          }
          temp = gaDspStateInfo[ucPortNum].aucDigitStr[0];
          aucToneGenOnFxoFlag[ucPortNum] = 1;  //doit arriver avant l'appel a dspipcGenTone
          dspipcGenTone(ucPortNum, temp, 0);
          dspipcResetDigitState(ucPortNum);
          gaDspStateInfo[ucPortNum].ucDigitLen = (pstnDspInfoPtr->uiLen - 1);
          //aucToneGenOnFxoFlag[ucPortNum] = 1;
        }
        else
        {
          for(ucCnt=0;ucCnt<pstnDspInfoPtr->uiLen;ucCnt++)
          {
            temp = pstnDspInfoPtr->uiCmdParams[ucCnt];
            gaDspStateInfo[ucPortNum].ucDigitLen=gaDspStateInfo[ucPortNum].ucDigitLen+1;
            gaDspStateInfo[ucPortNum].aucDigitStr[gaDspStateInfo[ucPortNum].ucDigitLen] = temp;
          }
        }
      }
      break;
    case TS_FXO2DECT :
    {
    	//printk("dspipcDSPConnection case TS_FXO2DECT portnum:%d\n",ucPortNum);
    	si3050PCMSlotChange(1);
    	dspipcStartDectFXO(ucPortNum,0);
    	dectCmd(DSP_ENDPOINT_Cmd_Start_FXO);
        aucToneGenOnFxoFlag[ucPortNum] = 0;

    	break;
    }	  
  }
}
/****************************************************************************
  Function to dis-connect DSP for FXS to FXO .
 ***************************************************************************/
void dspipcQuitConnection(pstnDspCmdInfo_t *pstnDspInfoPtr)
{
  UCHAR ucPortNum = pstnDspInfoPtr->ucPortNo;
  CommandQ  *commandBuf = NULL;
  switch(pstnDspInfoPtr->ConnectType)
  {
    case TIMESLOT:
    case TS_FXO2FXS_LB:
      commandBuf = dspipcGetCmdBuf(ucPortNum);
      commandBuf->command[0] = H2D_QUIT_TONEDTMF_FXSFXO;
      commandBuf->command[1] = 0;
      commandBuf->command[2] = 0;
      dspipcEnqCommand(ucPortNum);
      aucToneGenOnFxoFlag[ucPortNum] = 0;
      break;
    case TONE_DSP:
      dspipcQuitTone(ucPortNum,DIG_1_TONE);
      aucToneGenOnFxoFlag[ucPortNum] = 0;
      break;
    case DTMF_DSP:
      dspipcQuitTone(ucPortNum,pstnDspInfoPtr->uiCmdParams[0]);
      aucToneGenOnFxoFlag[ucPortNum] = 0;
      break;
     case TS_FXO2DECT :
     {
    	dspipcStopDectFXO(ucPortNum);
    	dectCmd(DSP_ENDPOINT_Cmd_Stop_FXO);

    	break;
     }	
  }
}

#endif


void dspipcInitPortDone(INT32 port,BOOL bVal)
{
  gaDspStateInfo[port].bInitDone = bVal;
}

BOOL dspipcIsInitPortDone(INT32 port)
{
  return gaDspStateInfo[port].bInitDone;
}

/*======================================================================
 * Function Name        : dspipcGenFarEndTone
 * Description          :   This commands send tone payload to Host after
 *  encoding it to specific codec type
 *====================================================================== */
/**********************************************************************************
 *  Function Name  : dspipcGenFarEndTone                                          *
 *  Description    : Function to generate Far end tone .                          *
 *  Input          : Port Number 		                                  *
 *  Output         : None.                                                        *
 *  Return Value   : None.                                                        *
 *********************************************************************************/
void dspipcGenFarEndTone(unsigned portNum)
{
  UINT16 tempWord;
  CommandQ  *commandBuf = dspipcGetCmdBuf(portNum);
  commandBuf->command[0] = H2D_FAR_END_TONE_START;
  tempWord = portNum % MAX_CHANNELS_ISR;
  tempWord = (tempWord << 8) | 0x1; /* 4 ??? */
  commandBuf->command[1] = tempWord;
  /* enque the command */
  dspipcEnqCommand(portNum);
}
/**********************************************************************************
 *  Function Name  : dspipcStopFarEndTone.                                        *
 *  Description    : Function to  Quit  Far end tone .                            *
 *  Input          : Port Number 		                                  *
 *  Output         : None.                                                        *
 *  Return Value   : None.                                                        *
 *********************************************************************************/
void dspipcStopFarEndTone(unsigned portNum)
{
  UINT16 tempWord;
  CommandQ  *commandBuf = dspipcGetCmdBuf(portNum);
  commandBuf->command[0] = H2D_FAR_END_TONE_STOP;
  tempWord = portNum % MAX_CHANNELS_ISR;
  tempWord = (tempWord << 8) | 0x1; /* 4 ??? */
  commandBuf->command[1] = tempWord;

  /* enque the command */
  dspipcEnqCommand(portNum);
}

/**********************************************************************************
 *  Function Name  : dspipcCidTxPlayDone.                                         *
 *  Description    : Function to stop FSK.                                        *
 *  Input          : Port Number                                                  *
 *  Output         : None.                                                        *
 *  Return Value   : None.                                                        *
 *********************************************************************************/

void dspipcCidTxPlayDone(unsigned short portNum)
{
#if KERNEL_RTP_INTERFACE /* { */
  if ( (pNWCallBack != (dsp_regNetwork_t *)0) && (pNWCallBack->evtFromDsp != (dsp_network_evtFromDsp_f)0) ) {
#ifdef VOICE_SYSCTL_STATS
    /* Stats */
    dsp_voiceSysCtl.ports[portNum].stats.network.rtp.snd.callerIdDone++;
#endif

    pNWCallBack->evtFromDsp(DSP_NETWORK_Evt_fromDsp_callerid_play_done, portNum, (void *)0);
  }
#endif /* } */

  dspipcReportIndication(portNum,DSPIPC_CALLERID_PLAY_DONE);
}
/*FCLUZEAU */
void dspipcVMWIPlayDone(unsigned short portNum)
{
  dspipcReportIndication(portNum,DSPIPC_VMWI_PLAY_DONE);
}

void dspipcToneCfg(Word16 portNum, FOURCADENCE_TONE_TYPE * pToneType)
{
  memset(&ToneParams[portNum],0,sizeof(FOURCADENCE_TONE_TYPE));
  memcpy(&ToneParams[portNum], pToneType, sizeof(FOURCADENCE_TONE_TYPE));
}

void dspipcGenToneSpec(Word16 CurChan,Word16 ToneType, INT32 uiTimeOut)
{
  UINT16 uiInterval;
  gaDspStateInfo[CurChan].ucToneType =  ToneType;
  /* Calculate this value based on  whehter interrupt is running at 5ms or 10ms */
  /* ulTimeOut value is in seconds */
  if(uiTimeOut == 0)
  {
     uiTimeOut = 60;
  }
  if(uiTimeOut)
  {
    uiInterval = 10;
    gaDspStateInfo[CurChan].ulToneTimeOut = (uiTimeOut * 1000)/uiInterval;
  }
   /* initcad function for testing of 4 cadences
   should be disabled when dspipcTonecfg is invoked*/
  //initCad(CurChan);//Gowri
  printk(" Four Cad init done here %d \r\n",CurChan);
  SMM_bUseGeneric[CurChan]=1;
  SMM_ToneInit_flag[CurChan]=1;

  SMM_CadPlayStopFlag[CurChan]=1;

  SMM_ToneDurationCntr[CurChan]=0;
  SMM_ToneType[CurChan] = ToneType;

  ToneInitGeneral(CurChan,ToneType);
  dspipcReportIndication(CurChan,DSPIPC_GEN_TONE_DONE);
  SMM_ToneGenEna[CurChan] = TONE_GEN_ACTIVE;

}



void dspipcSetDSPDataMode(UINT16 portNum,UCHAR dspMode)
{
  if(dspMode >= 1 && dspMode <= 4)
  dspDataMode[portNum] = dspMode;
}

__inline void dspipcSetDataMode(UCHAR bEnable)
{
  if(bEnable)
    gDataModeEnable = 1;
}

int dspipcMapDSPNum(int port)
{
  /* Look for the DSP Number for corresponding port number */
  if(port == 1)
  {
    if(MAX_CHANNELS_ISR == 1)
      return 1;
    else
      return 0;
  }
  else
    return 0;

}

#if DYNAMIC_CODEC_DOWNLOAD
int dspipcChangeDSPImage(UINT16 portNum,int codec)
{
  int dspNum;
  UINT16 tempWord;
  /* Look for the DSP Number for corresponding port number */
  dspNum = dspipcMapDSPNum(portNum);

#if THREEWAY_CONFERENCE
  if ((codec== DSP_G729) && (confGetConference(dspNum) == 1))
    codec = DSP_3WAY;
#endif
  if(codec == DSP_PCMA)
    codec = DSP_PCMU; /* For PCMU and PCMA , NO CHANGE */
  if(codec == confGetDSPDownloadOpt(dspNum))
    return 0; /* No Change */
  /* Disable DSP Interrupts */
  tempWord = dspReadDataMem(dspNum,0x3fb1);
  tempWord =  tempWord & 0xFFFE;
  dspWriteIntoDataMem(dspNum,0x3fb1,tempWord);
  /* Set the codec Type for the DSP */
  confSetDSPDownloadOpt(dspNum,codec);
  /* DO Dynamic Download Here */
  dsp_download_image(dspNum);
  /* Enable DSP Interrupts */
  tempWord = dspReadDataMem(dspNum,0x3fb1);
  tempWord =  tempWord | 0x1;
  dspWriteIntoDataMem(dspNum,0x3fb1,tempWord);
  return SUCCESS;
}
#endif

int  dspipcPollonDsp2completeIsr(int dspnumber)
{
  volatile UINT16 temp_data;
  UINT16 temp_addr;
  temp_addr = 0x3fb0;
  temp_data = 0x3333;
  while(temp_data != 0x1111)
  {
    temp_data = dspReadDataMem(dspnumber,temp_addr);
  }
  return SUCCESS;
}

int dspipcResetStateInfo(UINT16 portNum, UCHAR bOpen)
{
  /* Reset All Counters */
  setIntrFlag[portNum] = 0;
  pktCount[portNum] = 0;
  if(bOpen != 2)
  {
    gaDspStateInfo[portNum].ucState = CA_READY;
    gaDspStateInfo[portNum].toneState = CA_NOTONE;
    gaDspStateInfo[portNum].ucCallWtState = CA_READY;
    gaDspStateInfo[portNum].ulToneExpCntr = 0;
#if CALLER_IDTx
    SMM_CidTx[portNum].CidTxState = CID_TX_STATE0;
#endif
#if TONE_GEN
    SMM_ToneGenEna[portNum] = TONE_GEN_INACTIVE;
#endif
    slicResetRingDSPStateInfo(portNum);
    gaDspStateInfo[portNum].ucState = CA_READY;
  }
  gaDspStateInfo[portNum].ucExpSeqNo = 0;
  gaDspStateInfo[portNum].uiWaitCntr = 0;
  gaDspStateInfo[portNum].uiIntDigTimer = 0;
  gaDSPTimerInfo[portNum].uiInterDigTimer = 4;
  ucG7115msIntrFlag[portNum] = 0;
#if DTMFRX
  if(bOpen != 0)
    HDtmfrx_reset_on[portNum] = 1;
  else
    HDtmfrx_reset_on[portNum] = 0;
#endif
  if(bOpen == 0)
  {
    gaDspStateInfo[portNum].bInitDone = FALSE;
    dspDataMode[portNum] = DSP_DATA_INACTIVE;
#if VOX_DRIVERS_CONTROL
   // if(dspipcDriverControl)
    {
    //  if(dspipcDriverControl-- == 0)
        dspipcResetDrivers();
    }
#endif
  }
  else
  {
#if G711_PLC
    if(confGetPLC(portNum) )
      G711PlcInit(portNum);
#endif
    gaDspStateInfo[portNum].bInitDone = TRUE;
#if VOX_DRIVERS_CONTROL
    if(bOpen == 1)
    {
      dspipcDriverControl++;
      dspipcSetDrivers();
    }
#endif
  }
  gaDspStateInfo[portNum].toneState = CA_NOTONE;
#if T38
  dspipcResetT38Q(portNum);
  gSINreceived[portNum] = 0;
  gSINcntr[portNum] = 0;
  gbT38Negotiated[portNum] = 0;
#endif
  dspipcResetV21PreDet(portNum);
  return SUCCESS;
}

void dspipcResetV21PreDet(UINT16 portNum)
{
 gV21DetDone[portNum] = FALSE;
 gV21DetFlag[portNum] = FALSE;
 gV21IntrCntr[portNum] = 0;
 gV21DetCntr[portNum] = 0;

}

#if VOX_DRIVERS_CONTROL
/* This function is added to remove the busy-wait loops in network
                             drivers for data receive from AP. */
void dspipcSetDrivers(void)
{
  printk("dspipcSetDrivers Setting Counters : 1 \n");
  setMaxATMFrameReadCnt(1); /* For ATM */
  setMaxEthFrameReadCnt(1); /* For Ethernet */
  setMaxPeriApFrameReadCnt(1); /* For WIFI */
}
/* Reset them to their original values */
void dspipcResetDrivers(void)
{
  int index;
  for(index=0; index<MAX_VOICE_CHANNELS; index++)
  {
    if(gaDspStateInfo[index].bInitDone == 1)
    {
      printk("dspipcSetDrivers Resetting is not done \n");
      return;
    }
  }
  printk("dspipcResetDrivers Resetting Counters : 32 \n");
  resetMaxATMFrameReadCnt(); /* For ATM */
  resetMaxEthFrameReadCnt(); /* For Ethernet */
  resetMaxPeriApFrameReadCnt(); /* For WIFI */
}
#endif

void dspipcMemRead(VoiceMem_t *pMem)
{
  switch(pMem->type)
  {
    case 1:
      pMem->value = dspReadDataMem (pMem->dspNum, pMem->address);
      return;
    case 2:
      pMem->value = dspReadProgramMem(pMem->dspNum , pMem->address);
      return;
  }
}

void dspipcMemWrite(VoiceMem_t *pMem)
{
  switch(pMem->type)
  {
    case 1:
      dspWriteIntoDataMem(pMem->dspNum, pMem->address,pMem->value);
      return;
    case 2:
      dspWriteIntoProgramMem(pMem->dspNum , pMem->address , pMem->value);
      return;
  }

}

void dspipcReportIndication(UINT16 portNum, int indication)
{
  CmdDigitInfo_t *cmd;
  int index;
  index = (gaDsp2HostQ.writeIdx + 1) %  MAX_DSP2HOST_CMDQ_BUFFS;
  cmd = &gaDsp2HostCmdBuf[index];
  cmd->ucChannelNo = portNum;
  cmd->ConfirmCode = indication;
  gaDsp2HostQ.writeIdx = index;
  dspRegFunctions.regCmdDigit();
}

UINT32 dspipcGetTimeStamp(int port)
{
  return ulTimeStampCntA[port];
}

