/******************************************************************************

Ver       : 0.01
File Name : CIDRxMain.c
Purpose   : 
Status    :             
Complaint : Bellcore -TR TSY 30/31.
            ETSI-CID
			NTT -CID
******************************************************************************/
#include <oswrapper.h>
#include "G711PLCBasic_op.h"
#include "CidRxDataSt.h"
#include "CidRxCon.h"

#if CID_RX_DET
Word16 RxIndex[MAX_CHAN_CID];
extern Word16 RC_8000_9600[];
Word16 CidRxDelayBuff[MAX_CHAN_CID][RATE_LENGTH];
Word16 CidRxBuff[MAX_CHAN_CID][100];
Word16 CidRxIndex[MAX_CHAN_CID];
Word16 CidRxB[3] = { 3199,        6398,    3199   };
Word16 CidRxA[3] = { 32767,     -30893,    10922  };
Word16 cidrx_ip_samp_1[MAX_CHAN_CID];
Word16 cidrx_ip_samp_2[MAX_CHAN_CID];
Word16 cidrx_op_samp_1[MAX_CHAN_CID];
Word16 cidrx_op_samp_2[MAX_CHAN_CID];
Word16 cidrx_Mark[MAX_CHAN_CID];
Word16 cidrx_Space[MAX_CHAN_CID];
Word16 cidrx_symbolCnt[MAX_CHAN_CID];
Word16 cidrxDetSymbol[MAX_CHAN_CID][96];
Word16 CharWd[MAX_CHAN_CID][200];
Word16 ExtWd[MAX_CHAN_CID];
Word16 startBit[MAX_CHAN_CID];
Word16 stopBit[MAX_CHAN_CID];
Word16 CurLen[MAX_CHAN_CID];
Word16 CidRxState[MAX_CHAN_CID];
Word16 CidRxMarksCnt[MAX_CHAN_CID];
cidrx_st_ cidrxDec1[MAX_CHAN_CID];
UCHAR cid_array[20];
Word16 y2_hi[MAX_CHAN_CID];
Word16 y2_lo[MAX_CHAN_CID];

Word16 y1_hi[MAX_CHAN_CID];
Word16 y1_lo[MAX_CHAN_CID];

Word16 x0[MAX_CHAN_CID];
Word16 x1[MAX_CHAN_CID];



void CidRxMain(UINT16 *pCallerIdData, Word16 CurChanNumCid)
{
/*%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%%%%%%%%%%%%%%%%%   DETECTION   OF CPFSK PATTERNS
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%*/
  int i;
  int flag_end = 0;
  UpConvert_cid(pCallerIdData,CurChanNumCid);
  Lpf_QuadMod(CurChanNumCid);
	
  if(( cidrxDec1[CurChanNumCid].CidrxComplainVer == 2) && 
                 (cidrxDec1[CurChanNumCid].Done == 0))
  {
    cidrxBell_cw(CurChanNumCid);
    if( cidrxDec1[CurChanNumCid].Done == 1 )
    {
      //printk("CID_DETECTION DONE");
      cid_array[0]=cidrxDec1[CurChanNumCid].Month[0];
      cid_array[1]=cidrxDec1[CurChanNumCid].Month[1];
      cid_array[2]=cidrxDec1[CurChanNumCid].Day[0];
      cid_array[3]=cidrxDec1[CurChanNumCid].Day[1];
      cid_array[4]=cidrxDec1[CurChanNumCid].Hour[0];
      cid_array[5]=cidrxDec1[CurChanNumCid].Hour[1];
      cid_array[6]=cidrxDec1[CurChanNumCid].Minute[0];
      cid_array[7]=cidrxDec1[CurChanNumCid].Minute[1];
      cid_array[8]='\0';
      for(i=0; i<MAX_SLIC_CHANNELS; i++)
      {
        if(confGetFXSCallerIdEnabled(i))
        {
          cidrxDec1[CurChanNumCid].Number[cidrxDec1[CurChanNumCid].NumberLen] = '\0';
          cidrxDec1[CurChanNumCid].Name[cidrxDec1[CurChanNumCid].NameLen] = '\0';          
       confSetFXOCallerIdDetect(CurChanNumCid, 0);

          // if only Number aviable, flag = 1
          // if only Name aviable, flag = 2
          // if only Number and Name aviable, flag = 3
          if (cidrxDec1[CurChanNumCid].NumberFlag != -1)
                 flag_end += 1;
          if (cidrxDec1[CurChanNumCid].NameFlag != -1)
                 flag_end += 2;

          // test if unaviable number or name (only number in use)
          if (flag_end == 0)
                 {
                 if (cidrxDec1[CurChanNumCid].NumberFlagN != -1)
                       flag_end = cidrxDec1[CurChanNumCid].NumberFlagN;
                 }

          // only valid CallerID received
          if (flag_end != 0)
              {
              dspipcFXOCallerIdDetected(i,flag_end,(UCHAR*)cidrxDec1[CurChanNumCid].Number,
                    (UCHAR*)cidrxDec1[CurChanNumCid].Name,(UCHAR*)cid_array,1);
              }
        }
      }
    }
  }
}//--> end of CidRxMain function.


void UpConvert_cid(UINT16 *pCallerIdData,Word16 CurChanNumCid)
{
  Word16 i,k,CidRxInt = 0;
  Word16 *UpCoefPtr;
   
  UpCoefPtr = RC_8000_9600;
  k = 4;
     
  for(i = 0; i < 80; i++ )
  {
     
    CidRxDelayBuff[CurChanNumCid][CidRxIndex[CurChanNumCid]] = pCallerIdData[i];
    CidRxBuff[CurChanNumCid][k++] = FIR_cid(UpCoefPtr,CurChanNumCid);
    UpCoefPtr += RATE_LENGTH;
    CidRxInt++;
    if( CidRxInt ==  5 )
    {
      CidRxInt= 0;
      UpCoefPtr = RC_8000_9600;
      CidRxBuff[CurChanNumCid][k++] = FIR_cid(UpCoefPtr,CurChanNumCid);
      UpCoefPtr += RATE_LENGTH;
    }//---> End of CidRxInt;
     
    CidRxIndex[CurChanNumCid]++;
    CidRxIndex[CurChanNumCid]    = CidRxIndex[CurChanNumCid] % RATE_LENGTH;
   }   //--> end of for 80 Loop.
}//--> End of UpConvert().
/*****************************************************************************



*****************************************************************************/
Word16 FIR_cid(Word16 *UpCoefPtr, Word16 CurChanNumCid)
{
  Word16 fir_sum16 = 0,TempInd,i;
  Word32 fir_sum32 = 0;
     
  TempInd = CidRxIndex[CurChanNumCid]+1;
  TempInd = TempInd % RATE_LENGTH;
     
  for( i = 0; i < RATE_LENGTH; i++)
  {
    fir_sum32 = L_mac( fir_sum32, CidRxDelayBuff[CurChanNumCid][TempInd++], 
                            UpCoefPtr[i]);
    TempInd   = TempInd % RATE_LENGTH;
  }//--> End of for Loop.
     
     
  fir_sum16 = round(fir_sum32);
  return fir_sum16;
}//--> End of FIR()
/*****************************************************************************




********************************************************************************/
void Lpf_QuadMod(Word16 CurChanNumCid)
{
  Word16 i;
  Word32 Temp32;
  Word16 Tempval,Exp2,cidrx_ip_samp,cidrx_op_samp;
     
  cidrx_symbolCnt[CurChanNumCid] = 0;
  for( i =0 ; i < 96; i++)
  {
    cidrxDetSymbol[CurChanNumCid][i] = -1;
  }
     
  for( i = 0; i < 96; i++ )
  {
    Temp32 = 0;
    cidrx_ip_samp = mult( CidRxBuff[CurChanNumCid][i] , CidRxBuff[CurChanNumCid][i+4]);
    //cidrx_ip_samp   = CidRxBuff[i];
     
    //-->  b[2] * x(n-2)
    Temp32  = L_mac( Temp32, cidrx_ip_samp_2[CurChanNumCid], CidRxB[2]);
    cidrx_ip_samp_2[CurChanNumCid] = cidrx_ip_samp_1[CurChanNumCid];
     
    //-->  -a[2] * y(n-2)
    Temp32  = L_msu( Temp32, cidrx_op_samp_2[CurChanNumCid], CidRxA[2]);
    cidrx_op_samp_2[CurChanNumCid]  = cidrx_op_samp_1[CurChanNumCid];
     
     
    //-->  b[1] * x(n-1)
    Temp32  = L_mac( Temp32, cidrx_ip_samp_1[CurChanNumCid], CidRxB[1]);
    cidrx_ip_samp_1[CurChanNumCid] = cidrx_ip_samp;
     
    //-->  -a[1] * y(n-1)
    Temp32  = L_msu( Temp32, cidrx_op_samp_1[CurChanNumCid], CidRxA[1]);
     
    //-->  b[0] * x(n)
    Temp32  = L_mac( Temp32, cidrx_ip_samp, CidRxB[0]);
     
    //--> y(n)
    cidrx_op_samp    = round(Temp32);
    cidrx_op_samp_1[CurChanNumCid]  = cidrx_op_samp;
     
     
    CidRxExtBit(cidrx_op_samp,CurChanNumCid);
     
     
  }//--> end of BLOCK_LEN.
     
  CidRxBuff[CurChanNumCid][0] = CidRxBuff[CurChanNumCid][96];
  CidRxBuff[CurChanNumCid][1] = CidRxBuff[CurChanNumCid][97];
  CidRxBuff[CurChanNumCid][2] = CidRxBuff[CurChanNumCid][98];
  CidRxBuff[CurChanNumCid][3] = CidRxBuff[CurChanNumCid][99];
     
     
    
  Tempval = 0;
  Exp2    = 2;
    
  if( cidrxDetSymbol[CurChanNumCid][1]== 1 )
    Tempval = 1;
  else
    Tempval = 0;
   
  for( i = 2;i <= cidrx_symbolCnt[CurChanNumCid] ; i++ )
  {
    if( cidrxDetSymbol[CurChanNumCid][i]== 1 )
      Tempval = Tempval + Exp2;
    Exp2  *= 2;
  }//---> End of 12-Loop.
             
  //--> Get the CidRx Pattern.
  CidRxExtPattern(Tempval,CurChanNumCid);
}//---> End of Lpf_QuadMod function.
    

void CidRxExtPattern(Word16 Det12Bit,Word16 CurChanNumCid)
{
  Word16 i;
  Word16 TempWd;
  Word16 CurBit;
  Word16 CurWd;  

  if(CidRxState[CurChanNumCid] == 0 )
  {
    if( Det12Bit == 0x0FFF )
    {
      CidRxState[CurChanNumCid] = 1;
      CidRxMarksCnt[CurChanNumCid] += 12;
    }
     
  }
  else if(CidRxState[CurChanNumCid] == 1 )
  {
    if( Det12Bit == 0x0FFF )
      CidRxMarksCnt[CurChanNumCid] += 12;
    else
      CidRxState[CurChanNumCid] = 1;

    if( CidRxMarksCnt[CurChanNumCid] >= 50 )
      CidRxState[CurChanNumCid]  = 2; //---> Channel Seizure.180 Mark Bits.
    
  }
  else if (CidRxState[CurChanNumCid] == 2 )
  {
    CurWd = Det12Bit;
    for( i =0 ; i< cidrx_symbolCnt[CurChanNumCid]; i++ )
    {
      CurBit = CurWd & 0x0001;
      CurWd = CurWd >> 1;
     
      if((CurBit == 0)&&(startBit[CurChanNumCid] == 0 )&&(stopBit[CurChanNumCid] == 0 ))
      {
        startBit[CurChanNumCid] = 1;
        ExtWd[CurChanNumCid]    = 0;
        CurLen[CurChanNumCid]    = 0;
      }
      else if((startBit[CurChanNumCid]  == 1 )&&(stopBit[CurChanNumCid]  == 0)&&(CurLen[CurChanNumCid]  < 8))
      {
        TempWd  = CurBit << CurLen[CurChanNumCid];
        ExtWd[CurChanNumCid]   = ExtWd[CurChanNumCid]  | TempWd;
        CurLen[CurChanNumCid]  += 1;
      }
      else if((startBit[CurChanNumCid]  == 1 )&&(stopBit[CurChanNumCid]  == 0)&&(CurLen[CurChanNumCid]  == 8)&&(CurBit == 1))
      {
        CharWd[CurChanNumCid][RxIndex[CurChanNumCid]] =  ExtWd[CurChanNumCid] ;
        startBit[CurChanNumCid] = 0;
        stopBit[CurChanNumCid]  = 0;
        CurLen[CurChanNumCid]   = 0;
        if (RxIndex[CurChanNumCid] < 200)
	        RxIndex[CurChanNumCid] += 1;
    
      }
    }//--> End of parsing 12 -Bits.
  }//--> End of State = 2
}//--> End of CidRxPatt function.

void CidRxExtBit(Word16 cidrx_op_samp,Word16 CurChanNumCid)
{
        
  if( cidrx_op_samp < 0 )
  {
    if( cidrx_Mark[CurChanNumCid]  == 0)
    {  
      if( cidrx_Space[CurChanNumCid] > 4 )
      {  
        cidrx_symbolCnt[CurChanNumCid] = cidrx_symbolCnt[CurChanNumCid] + 1;
        cidrxDetSymbol[CurChanNumCid][cidrx_symbolCnt[CurChanNumCid]] = 0;
        cidrx_Space[CurChanNumCid] = 0;
      }//--->end %%%End of fisrt Mark under Space RemainderCnt.
      cidrx_Space[CurChanNumCid] = 0;
    }//--->%% End of first Mark detection case
     
    cidrx_Mark[CurChanNumCid]  = cidrx_Mark[CurChanNumCid] + 1;
    if( cidrx_Mark[CurChanNumCid] == 8 )
    {
      cidrx_symbolCnt[CurChanNumCid] = cidrx_symbolCnt[CurChanNumCid] + 1;
      cidrxDetSymbol[CurChanNumCid][cidrx_symbolCnt[CurChanNumCid]] = 1;
      cidrx_Mark[CurChanNumCid] = 0;
    }//-->end;%%% End of Mark detection CntThreshold.
     
    //--> End of cidrx_op_samp < 0 condition.
  }
  else
  {
    //--> cidrx_op_samp >= 0 condition.
    if( cidrx_Space[CurChanNumCid]  == 0)
    {
      if( cidrx_Mark[CurChanNumCid] > 4 )
      {
        cidrx_symbolCnt[CurChanNumCid] = cidrx_symbolCnt[CurChanNumCid] + 1;
        cidrxDetSymbol[CurChanNumCid][cidrx_symbolCnt[CurChanNumCid]] = 1;
        cidrx_Mark[CurChanNumCid] = 0;
      }//-->end %%%End of first Spce under Mark  RemainderCnt.
      cidrx_Mark[CurChanNumCid] = 0;
    }//-->end %% End of first Mark detection case
    cidrx_Space[CurChanNumCid]  = cidrx_Space[CurChanNumCid] + 1;
    if( cidrx_Space[CurChanNumCid] == 8 )
    {
      cidrx_symbolCnt[CurChanNumCid] = cidrx_symbolCnt[CurChanNumCid] + 1;
      cidrxDetSymbol[CurChanNumCid][cidrx_symbolCnt[CurChanNumCid]] = 0;
      cidrx_Space[CurChanNumCid] = 0;
    }//-->end;%%% End of Mark detection CntThreshold.
    //%%%%%%%END OF ELSE OF  Y(i) GT OR EQUAL TO ZERO DECISIONS.
  }//--> End of cidrx_op_samp >= 0 condition.
}//---> End of CidRxExtBit.

void cidrxBell_cw(Word16 CurChanNumCid)
{
     
   Word16 CurRdInd,Temp16;
   /***************************************************************************
         Bellcore  --> CW-CID
   ***************************************************************************/
   
   if( CidRxState[CurChanNumCid] != 2 )
       return;
     
     
   for( ; cidrxDec1[CurChanNumCid].PrevRdIndex < RxIndex[CurChanNumCid]; 
                (cidrxDec1[CurChanNumCid].PrevRdIndex) += 1)
   {
     
     CurRdInd = cidrxDec1[CurChanNumCid].PrevRdIndex;
     
     if (RxIndex[CurChanNumCid] >= 200)
     {
		// Bug !! oN n'arrete le DSP en disant 'done' !!!
	   printk("cidrxBell_cw:: FXO has received a Bad Caller ID !\n");
	   cidrxDec1[CurChanNumCid].Done  =  1;
     //  confSetFXOCallerIdDetect(CurChanNumCid, 0);
      break;
     }
     else if(( CharWd[CurChanNumCid][CurRdInd] == 0x80 ) && 
           (cidrxDec1[CurChanNumCid].MsgTypeFlag ==  -1))
     {
          /*
 
               Run Time Decoded Data layer parameter.
               -1. Not yet arrived this parameter.
                1. Mdmf
                2. Sdmf
               MsgLen :
                -1. Not yet arrived this parameter.
               > 0. is valid length.
     
          */
       cidrxDec1[CurChanNumCid].MsgTypeFlag =  1;
       cidrxDec1[CurChanNumCid].CheckSumRun = 
                             cidrxDec1[CurChanNumCid].CheckSumRun + 0x80;
     }
     else if((CharWd[CurChanNumCid][CurRdInd] == 0x4) && 
                            (cidrxDec1[CurChanNumCid].MsgTypeFlag == -1))
     {
      // cidrxDec1[CurChanNumCid].MsgTypeFlag =  2;
       cidrxDec1[CurChanNumCid].CheckSumRun = 
                                 cidrxDec1[CurChanNumCid].CheckSumRun + 0x4;
     }
     else if ( cidrxDec1[CurChanNumCid].MsgTypeFlag ==  1)
     {       //--> MDMF Data Layer
    
       if(cidrxDec1[CurChanNumCid].MsgLenFlag == -1)
       {
         cidrxDec1[CurChanNumCid].MsgLenFlag   = 1;
         cidrxDec1[CurChanNumCid].MsgLen = CharWd[CurChanNumCid][CurRdInd];
         cidrxDec1[CurChanNumCid].CheckSumRun  =  
            cidrxDec1[CurChanNumCid].CheckSumRun + CharWd[CurChanNumCid][CurRdInd];
         cidrxDec1[CurChanNumCid].MsgLenRun    =  0;
       }
       else if(( cidrxDec1[CurChanNumCid].TimeFlag == -1 ) && 
          (CharWd[CurChanNumCid][CurRdInd] == 1) && 
                                       (cidrxDec1[CurChanNumCid].MsgLenFlag == 1))
       {
         cidrxDec1[CurChanNumCid].TimeFlag      =   1;
         cidrxDec1[CurChanNumCid].CheckSumRun = 
              cidrxDec1[CurChanNumCid].CheckSumRun + CharWd[CurChanNumCid][CurRdInd];
         cidrxDec1[CurChanNumCid].MsgLenRun    +=   1;
         cidrxDec1[CurChanNumCid].TimeLen       =   0;
         continue;
       }
       else if( cidrxDec1[CurChanNumCid].TimeFlag == 1 )
       {
         cidrxDec1[CurChanNumCid].TimeFlag       =  2;
         cidrxDec1[CurChanNumCid].TimeRunLen     =  0;
         cidrxDec1[CurChanNumCid].TimeLen        =  CharWd[CurChanNumCid][CurRdInd];
         cidrxDec1[CurChanNumCid].CheckSumRun    =  cidrxDec1[CurChanNumCid].CheckSumRun
                                    + CharWd[CurChanNumCid][CurRdInd];
         cidrxDec1[CurChanNumCid].MsgLenRun     +=  1;
         continue;
    
       }
       else if((cidrxDec1[CurChanNumCid].TimeFlag == 2 ) && 
         (cidrxDec1[CurChanNumCid].TimeRunLen < cidrxDec1[CurChanNumCid].TimeLen))
       {
         cidrxDec1[CurChanNumCid].TimeRunLen     +=  1;
         switch(cidrxDec1[CurChanNumCid].TimeRunLen )
         {
           case 1 :
             cidrxDec1[CurChanNumCid].Month[0] = (CHAR) CharWd[CurChanNumCid][CurRdInd];
             break;
    
           case 2 :
             cidrxDec1[CurChanNumCid].Month[1] = (CHAR) CharWd[CurChanNumCid][CurRdInd];
             break;
    
           case 3 :
             cidrxDec1[CurChanNumCid].Day[0]  = (CHAR) CharWd[CurChanNumCid][CurRdInd];
             break;
    
           case 4 :
             cidrxDec1[CurChanNumCid].Day[1]  = (CHAR) CharWd[CurChanNumCid][CurRdInd];
             break;
    
           case 5 :
             cidrxDec1[CurChanNumCid].Hour[0] = (CHAR) CharWd[CurChanNumCid][CurRdInd];
             break;
    
           case 6 :
             cidrxDec1[CurChanNumCid].Hour[1] = (CHAR) CharWd[CurChanNumCid][CurRdInd];
             break;
 
           case 7 :
             cidrxDec1[CurChanNumCid].Minute[0] = (CHAR) CharWd[CurChanNumCid][CurRdInd];
             break;
    
           case 8 :
             cidrxDec1[CurChanNumCid].Minute[1] = (CHAR) CharWd[CurChanNumCid][CurRdInd];
             cidrxDec1[CurChanNumCid].TimeFlag = 3;
             break;
    
           default :
             break;
       }//--> End of Switch Statement.
       cidrxDec1[CurChanNumCid].CheckSumRun = cidrxDec1[CurChanNumCid].CheckSumRun +
                                  CharWd[CurChanNumCid][CurRdInd];
       cidrxDec1[CurChanNumCid].MsgLenRun     +=  1;
       continue;
    
     }
     else if(( cidrxDec1[CurChanNumCid].NumberFlag == -1 ) && 
                                  (CharWd[CurChanNumCid][CurRdInd] == 2))
     {
       cidrxDec1[CurChanNumCid].NumberFlag     =  0;
       cidrxDec1[CurChanNumCid].CheckSumRun    =  cidrxDec1[CurChanNumCid].CheckSumRun +
                              CharWd[CurChanNumCid][CurRdInd];
       cidrxDec1[CurChanNumCid].MsgLenRun     +=  1;
       continue;
       //--> End of Number
     }
     else if( cidrxDec1[CurChanNumCid].NumberFlag == 0 )
     {
       // lng of msg number
       cidrxDec1[CurChanNumCid].NumberFlag = 1;
       cidrxDec1[CurChanNumCid].NumberLen  = CharWd[CurChanNumCid][CurRdInd];
       cidrxDec1[CurChanNumCid].NumberRunLen = 0;
       cidrxDec1[CurChanNumCid].CheckSumRun    =  cidrxDec1[CurChanNumCid].CheckSumRun +
                     CharWd[CurChanNumCid][CurRdInd];
       cidrxDec1[CurChanNumCid].MsgLenRun     +=  1;
       continue;
   
     }
     else if((cidrxDec1[CurChanNumCid].NumberFlag == 1 ) && 
          (cidrxDec1[CurChanNumCid].NumberRunLen < cidrxDec1[CurChanNumCid].NumberLen))
     {
       cidrxDec1[CurChanNumCid].Number[cidrxDec1[CurChanNumCid].NumberRunLen] = 
                                            (CHAR) CharWd[CurChanNumCid][CurRdInd];
       cidrxDec1[CurChanNumCid].NumberRunLen  += 1;
       cidrxDec1[CurChanNumCid].CheckSumRun   =  cidrxDec1[CurChanNumCid].CheckSumRun +
                                       CharWd[CurChanNumCid][CurRdInd];
       cidrxDec1[CurChanNumCid].MsgLenRun     +=  1;
      if(cidrxDec1[CurChanNumCid].NumberRunLen == cidrxDec1[CurChanNumCid].NumberLen) 
        {  
	printk("cidrxBell_cw:: FXO has received a  Number Caller ID !\n");
        cidrxDec1[CurChanNumCid].Done  =  1;
           break;
         }
       continue;
    
     }

     //------------------ unaviable number
     else if(( cidrxDec1[CurChanNumCid].NumberFlagN == -1 ) && 
                                  (CharWd[CurChanNumCid][CurRdInd] == 4)) // Type of parameter "reason of non-availability for number"
     {
       cidrxDec1[CurChanNumCid].NumberFlagN     =  0;
       cidrxDec1[CurChanNumCid].CheckSumRun    =  cidrxDec1[CurChanNumCid].CheckSumRun +
                              CharWd[CurChanNumCid][CurRdInd];
       cidrxDec1[CurChanNumCid].MsgLenRun     +=  1;
       continue;
       //--> End of Number
     }
     else if( cidrxDec1[CurChanNumCid].NumberFlagN == 0 )
     {
       cidrxDec1[CurChanNumCid].NumberFlagN = 1;
       cidrxDec1[CurChanNumCid].NumberLen  = CharWd[CurChanNumCid][CurRdInd];
       cidrxDec1[CurChanNumCid].NumberRunLen = 0;
       cidrxDec1[CurChanNumCid].CheckSumRun    =  cidrxDec1[CurChanNumCid].CheckSumRun +
                     CharWd[CurChanNumCid][CurRdInd];
       cidrxDec1[CurChanNumCid].MsgLenRun     +=  1;
       continue;
   
     }
     else if((cidrxDec1[CurChanNumCid].NumberFlagN == 1 ) && 
          (cidrxDec1[CurChanNumCid].NumberRunLen < cidrxDec1[CurChanNumCid].NumberLen))
     {
       cidrxDec1[CurChanNumCid].Number[cidrxDec1[CurChanNumCid].NumberRunLen] = 
                                            (CHAR) CharWd[CurChanNumCid][CurRdInd];

       if ((CHAR) CharWd[CurChanNumCid][CurRdInd] == 'O')
             cidrxDec1[CurChanNumCid].NumberFlagN = 5;

       if ((CHAR) CharWd[CurChanNumCid][CurRdInd] == 'P')
             cidrxDec1[CurChanNumCid].NumberFlagN = 4;

       cidrxDec1[CurChanNumCid].NumberRunLen  += 1;
       cidrxDec1[CurChanNumCid].CheckSumRun   =  cidrxDec1[CurChanNumCid].CheckSumRun +
                                       CharWd[CurChanNumCid][CurRdInd];
       cidrxDec1[CurChanNumCid].MsgLenRun     +=  1;
      if(cidrxDec1[CurChanNumCid].NumberRunLen == cidrxDec1[CurChanNumCid].NumberLen) 
        {  
	printk("cidrxBell_cw:: FXO has received a  Private or Unaviable Number Caller ID !\n");
           cidrxDec1[CurChanNumCid].Done  =  1;
           break;
         }
       continue;
    
     }

//---------------------------- number detection end -------------------------------------------


//---------------------------- name detection begin -------------------------------------------
     // aviable name
     else if((cidrxDec1[CurChanNumCid].NameFlag == -1 ) && 
                    (CharWd[CurChanNumCid][CurRdInd] == 7))
     {
       cidrxDec1[CurChanNumCid].NameFlag =   0;
       cidrxDec1[CurChanNumCid].CheckSumRun =  cidrxDec1[CurChanNumCid].CheckSumRun + 
                                 CharWd[CurChanNumCid][CurRdInd];
       cidrxDec1[CurChanNumCid].MsgLenRun     +=  1;
       continue;
    
     }
     else if(cidrxDec1[CurChanNumCid].NameFlag == 0 )
     {
       cidrxDec1[CurChanNumCid].NameLen =  CharWd[CurChanNumCid][CurRdInd];
       cidrxDec1[CurChanNumCid].NameRunLen  =   0;
       cidrxDec1[CurChanNumCid].NameFlag    =   1;
       cidrxDec1[CurChanNumCid].CheckSumRun =   cidrxDec1[CurChanNumCid].CheckSumRun + 
                              CharWd[CurChanNumCid][CurRdInd];
       cidrxDec1[CurChanNumCid].MsgLenRun     +=  1;
       continue;
    
     }
     else if(( cidrxDec1[CurChanNumCid].NameFlag == 1 ) && 
           (cidrxDec1[CurChanNumCid].NameRunLen < cidrxDec1[CurChanNumCid].NameLen))
     {
       cidrxDec1[CurChanNumCid].Name[cidrxDec1[CurChanNumCid].NameRunLen] = 
                                               (CHAR)  CharWd[CurChanNumCid][CurRdInd];
       cidrxDec1[CurChanNumCid].NameRunLen  += 1;
       cidrxDec1[CurChanNumCid].CheckSumRun =  cidrxDec1[CurChanNumCid].CheckSumRun +
                              CharWd[CurChanNumCid][CurRdInd];
       cidrxDec1[CurChanNumCid].MsgLenRun     +=  1;
      if(cidrxDec1[CurChanNumCid].NameRunLen == cidrxDec1[CurChanNumCid].NameLen) 
        {  
	printk("cidrxBell_cw:: FXO has received a Name Caller ID !\n");
           cidrxDec1[CurChanNumCid].Done  =  1;
           break;
         }
       continue;
 
     }

     //-------------------- unaviable name
     else if((cidrxDec1[CurChanNumCid].NameFlagN == -1 ) && 
                    (CharWd[CurChanNumCid][CurRdInd] == 8)) // Type of parameter "reason of non-availability for name"
     {
       cidrxDec1[CurChanNumCid].NameFlagN =   0;
       cidrxDec1[CurChanNumCid].CheckSumRun =  cidrxDec1[CurChanNumCid].CheckSumRun + 
                                 CharWd[CurChanNumCid][CurRdInd];
       cidrxDec1[CurChanNumCid].MsgLenRun     +=  1;
       continue;
    
     }
     else if(cidrxDec1[CurChanNumCid].NameFlagN == 0 )
     {
       // lng of msg
       cidrxDec1[CurChanNumCid].NameLen =  CharWd[CurChanNumCid][CurRdInd];
       cidrxDec1[CurChanNumCid].NameRunLen  =   0;
       cidrxDec1[CurChanNumCid].NameFlagN    =   1;
       cidrxDec1[CurChanNumCid].CheckSumRun =   cidrxDec1[CurChanNumCid].CheckSumRun + 
                              CharWd[CurChanNumCid][CurRdInd];
       if ((CHAR) CharWd[CurChanNumCid][CurRdInd] == 'O')
             cidrxDec1[CurChanNumCid].NameFlag = 5;

       if ((CHAR) CharWd[CurChanNumCid][CurRdInd] == 'P')
             cidrxDec1[CurChanNumCid].NameFlag = 4;
                              
       cidrxDec1[CurChanNumCid].MsgLenRun     +=  1;
       continue;
    
     }
     else if(( cidrxDec1[CurChanNumCid].NameFlagN == 1 ) && 
           (cidrxDec1[CurChanNumCid].NameRunLen < cidrxDec1[CurChanNumCid].NameLen))
     {
     // msg for name
       cidrxDec1[CurChanNumCid].Name[cidrxDec1[CurChanNumCid].NameRunLen] = 
                                               (CHAR)  CharWd[CurChanNumCid][CurRdInd];
       cidrxDec1[CurChanNumCid].NameRunLen  += 1;
       cidrxDec1[CurChanNumCid].CheckSumRun =  cidrxDec1[CurChanNumCid].CheckSumRun +
                              CharWd[CurChanNumCid][CurRdInd];
       cidrxDec1[CurChanNumCid].MsgLenRun     +=  1;

      if(cidrxDec1[CurChanNumCid].NameRunLen == cidrxDec1[CurChanNumCid].NameLen) 
        {  
	printk("cidrxBell_cw:: FXO has received a  Private or Unaviable Name Caller ID !\n");
           cidrxDec1[CurChanNumCid].Done  =  1;
           break;
         }
       continue;
 
     }

//---------------------------- name detection end -------------------------------------------

     // test end of FSK msg, 
     else if(cidrxDec1[CurChanNumCid].MsgLenRun == cidrxDec1[CurChanNumCid].MsgLen )
     {
       cidrxDec1[CurChanNumCid].CheckSumRx =  (Word16) CharWd[CurChanNumCid][CurRdInd];
       Temp16 = cidrxDec1[CurChanNumCid].CheckSumRun & 0x00FF;
       Temp16 = ~Temp16;
       Temp16 += 1;
    
       cidrxDec1[CurChanNumCid].CheckSumExp  = Temp16&0x00FF;
    
       //if((Word16) (Temp16&0x00FF) ==(Word16) cidrxDec1[CurChanNumCid].CheckSumRx )
       //if( Temp16 == cidrxDec1[CurChanNumCid].CheckSumRx )
       if(cidrxDec1[CurChanNumCid].CheckSumRx ==cidrxDec1[CurChanNumCid].CheckSumExp)
         cidrxDec1[CurChanNumCid].CheckSumErrFlag  =  0;
       else
         cidrxDec1[CurChanNumCid].CheckSumErrFlag  =  -1;
       cidrxDec1[CurChanNumCid].Done  =  1;
       //confSetFXOCallerIdDetect(CurChanNumCid, 0);
       return;
     }
     //--> End of MDMF Data Layer
   }
   else if( cidrxDec1[CurChanNumCid].MsgTypeFlag ==  2)
   {
     //--> SDMF Data Layer.
     //printk("SDMF under progress\n");
     //return;
     //--> End of SDMF Data Layer.
   }
  //else
    // return;
  }//--> End of for Loop
}
    

/***********************************************************************************************
      Function : CidRxInit.

*******************************************************************************************/

void cidrxAppInit(Word16 CurChanNumCid)
{
     
      
  /***************************************************************************
                  CIDRX APPLICATION -DATA  STRUCTURE
  ***************************************************************************/
  /*
              User CLI Configuration for cidrx Complain.
                 1. Bellcore  --> Default.
                 2. Bellcore  CW--> Default.
                 3. ETSI
                 4. ETSI-CW
                 3. NTT
  */
  cidrxDec1[CurChanNumCid].PrevRdIndex      =  0;
  cidrxDec1[CurChanNumCid].CidrxComplainVer =  2;
    
     
  /*
                  Run Time Decoded Data layer parameter.
                 -1. Not yet arrived this parameter.
                  1. Mdmf
                  2. Sdmf
                  MsgLen :
                 -1. Not yet arrived this parameter.
                  > 0. is valid length.
  */
  cidrxDec1[CurChanNumCid].MsgTypeFlag =  -1;
  cidrxDec1[CurChanNumCid].MsgLenFlag  =  -1;
  cidrxDec1[CurChanNumCid].MsgLen      =  -1;
  cidrxDec1[CurChanNumCid].MsgLenRun   =  0;
   
    
  /*    Check Error Flag :
                -1. Not yet arrived
                 0. Calculated No Error
                 1. Calculated Error in CheckSum.
  */
  cidrxDec1[CurChanNumCid].CheckSumErrFlag  =  -1;
  cidrxDec1[CurChanNumCid].CheckSumRun      = 0;
    
  //---> TIME FIELD.
  cidrxDec1[CurChanNumCid].TimeFlag = -1;
  cidrxDec1[CurChanNumCid].Month[0]  = '1';
  cidrxDec1[CurChanNumCid].Month[1]  = '2';
  cidrxDec1[CurChanNumCid].Day[0]    = '3';
  cidrxDec1[CurChanNumCid].Day[1]    = '1';
  cidrxDec1[CurChanNumCid].Hour[0]   = '2';
  cidrxDec1[CurChanNumCid].Hour[1]   = '3';
  cidrxDec1[CurChanNumCid].Minute[0] = '5';
  cidrxDec1[CurChanNumCid].Minute[1] = '9';
    
    
  /*    Name Flag
                -1. Not yet arrived.
                 0. under detection.
                 1. name detection done.
                 Name Len : 0 Default
                 > 0
  */
  cidrxDec1[CurChanNumCid].NameFlagN =  -1;
  cidrxDec1[CurChanNumCid].NameFlag =  -1;
  cidrxDec1[CurChanNumCid].NameLen  =   0;
    
    
  /*    Number Flag
                 -1. Not yet arrived.
                  0. under detection.
                  1. number detection done.
                  Number Len : 0 Default
                  > 0
  */
  cidrxDec1[CurChanNumCid].NumberFlagN = -1;
  cidrxDec1[CurChanNumCid].NumberFlag = -1;
  cidrxDec1[CurChanNumCid].NumberLen  =  0;
  cidrxDec1[CurChanNumCid].Done  =  0;
    
}//---> End od APP Init function.

void CidRxInit(Word16 CurChanNumCid)
{
  short i;
  CidRxIndex[CurChanNumCid] = 0;
     
  for( i = 0; i < RATE_LENGTH; i++)
    CidRxDelayBuff[CurChanNumCid][i] = 0;
     
  for( i = 0; i < 100; i++)
     CidRxBuff[CurChanNumCid][i] = 0;
    
  cidrx_ip_samp_1[CurChanNumCid]  = 0;
  cidrx_ip_samp_2[CurChanNumCid]  = 0;
     
  cidrx_op_samp_1[CurChanNumCid]  = 0;
  cidrx_op_samp_2[CurChanNumCid]  = 0;
     
  cidrx_Mark[CurChanNumCid]  = 0;
  cidrx_Space[CurChanNumCid] = 0;
  cidrx_symbolCnt[CurChanNumCid] = 0;
     
     

  RxIndex[CurChanNumCid]  = 0;
  ExtWd[CurChanNumCid]    = 0;
  startBit[CurChanNumCid] = 0;
  stopBit[CurChanNumCid]  = 0;
  CurLen[CurChanNumCid]   = 0;
  CidRxState[CurChanNumCid]  = 0;
  CidRxMarksCnt[CurChanNumCid] = 0;
    
}//--> End of CidRxInit.

/***************************************************************************************************



***************************************************************************************************/

void Init_Pre_Process(Word16 CurChanNumCid)
{
  y2_hi[CurChanNumCid] = 0;
  y2_lo[CurChanNumCid] = 0;
  y1_hi[CurChanNumCid] = 0;
  y1_lo[CurChanNumCid] = 0;
  x0[CurChanNumCid]  =   0;
  x1[CurChanNumCid]  =   0;

}
void Pre_Process(
  Word16 *signal,    /* input/output signal */
  Word16 lg,         /* length of signal    */
  Word16 CurChanNumCid)   
{
  Word16 i, x2;
  Word32 L_tmp;
  Word16 b140[3] = {1899, -3798, 1899};
  Word16 a140[3] = {4096, 7807, -3733};

  for(i=0; i<lg; i++)
  {
     x2 = x1[CurChanNumCid];
     x1[CurChanNumCid] = x0[CurChanNumCid];
     x0[CurChanNumCid] = signal[i];

     /*  y[i] = b[0]*x[i]/2 + b[1]*x[i-1]/2 + b140[2]*x[i-2]/2  */
     /*                     + a[1]*y[i-1] + a[2] * y[i-2];      */

     L_tmp     = Mpy_32_16(y1_hi[CurChanNumCid], y1_lo[CurChanNumCid], a140[1]);
     L_tmp     = L_add(L_tmp, Mpy_32_16(y2_hi[CurChanNumCid], y2_lo[CurChanNumCid], a140[2]));
     L_tmp     = L_mac(L_tmp, x0[CurChanNumCid], b140[0]);
     L_tmp     = L_mac(L_tmp, x1[CurChanNumCid], b140[1]);
     L_tmp     = L_mac(L_tmp, x2, b140[2]);
     L_tmp     = L_shl(L_tmp, 3);      /* Q28 --> Q31 (Q12 --> Q15) */
     signal[i] = round(L_tmp);

     y2_hi[CurChanNumCid] = y1_hi[CurChanNumCid];
     y2_lo[CurChanNumCid] = y1_lo[CurChanNumCid];
     L_Extract(L_tmp, &y1_hi[CurChanNumCid], &y1_lo[CurChanNumCid]);
  }
  return;
}

void L_Extract(Word32 L_32, Word16 *hi, Word16 *lo)
{
  *hi  = extract_h(L_32);
  *lo  = extract_l( L_msu( L_shr(L_32, 1) , *hi, 16384));  /* lo = L_32>>1   */
  return;
}

Word32 Mpy_32_16(Word16 hi, Word16 lo, Word16 n)
{
  Word32 L_32;

  L_32 = L_mult(hi, n);
  L_32 = L_mac(L_32, mult(lo, n) , 1);

  return( L_32 );
}

#endif
