/*

  File Name: PLCCons.h
  Description: Constants for Packet Loss Concealment Algorithm
  Date: 13-07-2001

*/

/*****************************************************************
  		       SWITCH  TO ENABLE /DISABLE NORMALIZATION 
******************************************************************/
#define		MAX_CHAN	MAX_VOICE_CHANNELS  //2

/*****************************************************************
  		       SWITCH  TO ENABLE /DISABLE NORMALIZATION 
******************************************************************/
#define    	NORMALISATION

/*****************************************************************
			  SWITCH TO ENALBE / DISABLE SIMULATION
******************************************************************/
//#define		PLC_TESTING

/*****************************************************************
			  SWITCH TO ENALBE / DISABLE FILE I/O STREAMS
******************************************************************/
//#define	PLC_FILEIO

/*****************************************************************
                       SELECT FRMAE LEN
******************************************************************/
#define FRAME_MAX     8000 /FRAME_LEN

/*****************************************************************
                  PITCH BLOCK SELECTIONS
******************************************************************/
#define PITCH_MIN	  40					/* minimum allowed pitch, 200 Hz */
#define PITCH_MAX	  120					/* maximum allowed pitch, 66 Hz */
#define PITCHDIFF     	  (PITCH_MAX - PITCH_MIN)
#define POVERLAPMAX       (PITCH_MAX >> 2)		/* maximum pitch OLA window */
#define CORR_BUFF_LEN     280					 /* Normalisation vector length */
#define NDEC		  2						 /* 2:1 decimation */
#define CORRLEN		  160					 /* 20 ms correlation length */
#define CORRBUFLEN	  (CORRLEN + PITCH_MAX)  /* correlation buffer length */
#define CORRMINPOWER  	  0x00faffff //250					 /* minimum power */
#define SQRT_CORRMINPOWER 0xB2E

/*****************************************************************
                    HISTORY BUFFER
******************************************************************/
#define HISTORYLEN	   (PITCH_MAX * 3 + POVERLAPMAX) /* history buffer length*/

/*****************************************************************
                  GAIN SCALE SLOPE CONSTANTS
******************************************************************/
#define EOVERLAPINCR   	  32					 /* end OLA increment per frame, 4 ms */

//--> 20% per 10 ms frame --> 50ms --> 50* 8 = 400
#define ATTEN_INCR	   (32767 / 400)      /* attenuation per sample */
#define ATTENT_START   ATTEN_INCR * FRAME_LEN

/***************************************************************
			 PLC State Definitions.
*****************************************************************/
#define G711PLC_STATE1 1
#define G711PLC_STATE2 2
#define G711PLC_STATE3 3
#define G711PLC_STATE4 4

#define PACKET_LOSS 	    0
#define PACKET_RECEIVED	    1

/***************************************************************
			END OF PLC MODULE CONSTANTS
***************************************************************/


/***************************************************************
			----->>>>  TEST SET UP  <<<<------
             TO SELCET SPEECH AS INPUT ELSE COMMNET IT
****************************************************************/
#ifdef PLC_TESTING

//#define SPEECH


#ifdef SPEECH
    #define RATE_LOSS   (39 * 80/ FRAME_LEN)
    #define LOS_START    0
    #define LOS_END      5 
#else
    #define RATE_LOSS   (10 * 80/ FRAME_LEN)
    #define LOS_START    0
    #define LOS_END      6
#endif
#endif
/***************************************************************/

void G711PLC_addtohistory(void);
void G711PLC_dofe(void);
