
/**********************************************************************************
 	Function Name		:    G711PLC()										  
	Description		:    Depending on the type of the frame calls Addtohistory
			             or PLC
 	Input Parameters	:    NONE				   
	Return Values 		:    NONE												  
	Functions called	:
		receiveframe
		addtohistory
		dofe
		output
***********************************************************************************/
#include<oswrapper.h>
#include "G711PLCCons.h"
#include "G711pLcProto.h"
#include "G711PLCBasic_op.h"
#include "G711pLcVar.h"

#if G711_PLC

Word32 PLC_Frame;
Word16 sample;
Word16 RxPacketType;
//Word16 speech[FRAME_LEN];

uWord16 frameCntr;
//uWord16 ChanNum;
#if 0
/**************************************************************************
Word32 PLC_Frame;
Word16 sample;
Word16 RxPacketType;
Word16 speech[FRAME_LEN];
Word16 VENKAT;
uWord16 frameCntr;
//uWord16 ChanNum;

***********************************************************************
                          DM_OS   Global  Variables
************************************************************************/
//Word16 PlcGainTable[6]= { 0x7FFF, 0x6665, 0x4CCC, 0x3332, 0x1999 ,0 };

/***********************************************************************
                          SMM_DM_RAM  Global  Variables
************************************************************************/
#endif
uWord16 SMM_EraseCnt[MAX_CHAN];                   /* consecutive erased f
rames */

Word16 SMM_Pitch_overlap[MAX_CHAN];               /* overlap based on pit
ch */
Word16 SMM_Pitch_offset[MAX_CHAN];                /* offset into pitch pe
riod */

Word16 SMM_Pitch[MAX_CHAN];                               /* pitch estima
te */
Word16 SMM_PitchBuf[MAX_CHAN][HISTORYLEN]; /* buffer for cycles of speech
 */
Word16 SMM_PitchBlen[MAX_CHAN];                   /* current pitch buffer
 length */

Word16 SMM_LastQ[MAX_CHAN][POVERLAPMAX];  /* saved last quarter wavelengt
h */

Word16 SMM_History[MAX_CHAN][HISTORYLEN];  /* history buffer */
Word16 SMM_HistoryWtIndex[MAX_CHAN];
Word16 SMM_HistoryRdIndex[MAX_CHAN];


/*************************************************************************
                   Scratch variables for PLC State.
**************************************************************************/
//Word16 G711PlcState;

/*************************************************************************
                        Scratch variables.
**************************************************************************/
uWord16 EraseCnt;                         /* consecutive erased frames */
Word16 Pitch_overlap;             /* overlap based on pitch */
Word16 Pitch_offset;              /* offset into pitch period */
Word16 Pitch;                             /* pitch estimate */
Word16 PitchBlen;                         /* current pitch buffer length
*/

Word16  *HistoryBuffPtr;
Word16 HistoryWtIndex;
Word16 HistoryRdIndex;

Word16 *LastQBuffPtr;         /* saved last quarter wavelength */

Word16 *PitchBuffPtr;
Word16 *PitchBufEndPtr;           /* end of pitch buffer */
Word16 *PitchBufStartPtr;         /* start of pitch buffer */


Word16 temp[280];           //--> For Normalization
Word16 *tempend;

Word16 bestmatch;
Word16 bestcorr;
Word16 corr1;
Word16 scal16;
Word16 corr16;
Word16 max; // = 0;
Word16 normvalue;
Word32 corr;             /* correlation */
Word32 energy;         /* running energy */
Word32 scale;            /* scale correlation by average power */


/*************************************************************************
                        Scratch Variable for Add2History
**************************************************************************/
Word16 oLength;
/*************************************************************************
                        Scratch Variables for GetFespeech
**************************************************************************/
Word16 cnt;
/*************************************************************************
                        Scratch Variables for Scale Speech
**************************************************************************/
Word16 RampFact;

/*************************************************************************
                        Scratch Variables for OverLap AddEnd
**************************************************************************/
Word16 incr,lw,rw;
Word32 OLAdd;
Word16 gain;
Word32 OLAddAtEnd;
Word16 incrg;

/*************************************************************************
                        Scratch Variables for Add To History, for the Good first
 Frame.
**************************************************************************/
Word16 TempBuff[FRAME_LEN]; //--> 40 samples

/*************************************************************************
                        Scratch Variables used in dofe function during PLC state
 -2
**************************************************************************/
Word16 Temp1_plc;
Word16 saveoffset;

/*************************************************************************
                        Scratch Variables used for Pointers
**************************************************************************/
Word16 *BuffPtr1;
Word16 *BuffPtr2;
Word16 *BuffPtr3;

/*************************************************************************
                        Scratch Variables used for indexes
**************************************************************************/
//uWord16 i, j, k;
/*************************************************************************
                        End of Variables Declarations
**************************************************************************/




/**************************************************************************
Function Name:  G711PLC()
Description:   Generate the synthetic signal.
           At the beginning of an erasure determine the pitch, and extract
           one pitch period from the tail of the signal. Do an OLA for 1/4
           of the pitch to smooth the signal. Then repeat the extracted signal
           for the length of the erasure. If the erasure continues for more than
           10 ms, increase the number of periods in the pitchbuffer. At the end
           of an erasure, do an OLA with the start of the first good frame.
           The gain decays as the erasure gets longer.

Input   :
        - Pointer to Present Speech samples Buffer of length 40
        - Packet Type

Out Put :
        - Concealed samples during lost packet case (or) output samples from Updated
          History Buffer.

Functions called :
        - addtohistory()
        - dofe()
***************************************************************************/

Word16 PLC_FRAMECTR = 0;
void G711PLC(uWord16 CurChanNum , Word16 PktType)	//Integration call
{
#ifdef PLC_TESTING
/******************************************************************
              Getting the cases of  RxPacketType
                     --> PACKET_LOST / Bad frame
                     --> PACKET_RECEIVED/Good
*******************************************************************/
	  if(CurChanNum == 0x0)
		PLC_FRAMECTR++;

	  if(PLC_FRAMECTR >= (Word16) 32767)
		PLC_FRAMECTR = 1;

	  PktType = GetImpairment();
#endif

	  /***** Get Current Channel Instance *****/
          Get_G711PLcCurchanInst(CurChanNum);

	  
          if (PktType == JIT_SPEECH_PACKET)
              G711PLC_addtohistory();  //Add good packets to History Buffer
          else if(PktType == JIT_NO_PACKET)
              G711PLC_dofe();	       //For lost packet generate synthetic signal

	  /***** Update Channel Instance *******/
          Put_G711PLcCurchanInst(CurChanNum);
}  //end of G711PLC function call




/*****************************************************************************
 Function Purpose	:    This function will generate, Packet Loss  cases.
		             by using Uniform Random Number generator.

 Input  		:    PLC_Frame count Value        
 OutPut 		:    RxPacketType.

*****************************************************************************/				
#ifdef PLC_TESTING
Word16 GetImpairment(void)
{
  Word16 i,j; 
	      
	//--> Packet is getting lost in uniformly for every 10 -frames one.
	//if( (frame%10 == 0)||(frame%10 == 1)||(frame%10 == 2 ))  //--> For two frames lost case

	if(( PLC_FRAMECTR% RATE_LOSS >= LOS_START )&&( PLC_FRAMECTR% RATE_LOSS < LOS_END )&&( PLC_FRAMECTR > (RATE_LOSS -1)))
	{
	   j  = JIT_NO_PACKET; //PACKET_LOSS;     // bad frame

	   for (i=0; i<FRAME_LEN; i++)
	      speech[i] = 0;
	}
	else
	{
	   j  = JIT_SPEECH_PACKET; //PACKET_RECEIVED;   // good frame 	*/
	}

	return(j);
}
#endif

/***************************************************************************
                  GET CHANNEL INSTANCE
****************************************************************************/
void Get_G711PLcCurchanInst(uWord16 ChanNum)
{

    EraseCnt       = SMM_EraseCnt[ChanNum];		 /* consecutive erased frames */
    Pitch_overlap  = SMM_Pitch_overlap[ChanNum];	 /* overlap based on pitch */
    Pitch_offset   = SMM_Pitch_offset[ChanNum];		 /* offset into pitch period */
    Pitch          = SMM_Pitch[ChanNum];		 /* pitch estimate */
    PitchBlen      = SMM_PitchBlen[ChanNum];		 /* current pitch buffer length */

    PitchBuffPtr   = (Word16 * )SMM_PitchBuf[ChanNum];   /* buffer for cycles of speech */
    LastQBuffPtr   = (Word16 * ) SMM_LastQ[ChanNum];     /* saved last quarter wavelength */
    HistoryBuffPtr = (Word16 * ) SMM_History[ChanNum];   /* history buffer */

    HistoryWtIndex =   SMM_HistoryWtIndex[ChanNum];
    HistoryRdIndex =   SMM_HistoryRdIndex[ChanNum];

}

/***************************************************************************
                  UPDATE CHANNEL INSTANCE
****************************************************************************/
void Put_G711PLcCurchanInst(uWord16 ChanNum)
{

    SMM_EraseCnt[ChanNum]      = EraseCnt;	         /* consecutive erased frames */
    SMM_Pitch_overlap[ChanNum] = Pitch_overlap;		 /* overlap based on pitch */
    SMM_Pitch_offset[ChanNum]  = Pitch_offset;		 /* offset into pitch period */
    SMM_Pitch[ChanNum]         = Pitch;			 /* pitch estimate */
    SMM_PitchBlen[ChanNum]     = PitchBlen;		 /* current pitch buffer length */    

    SMM_HistoryWtIndex[ChanNum] = HistoryWtIndex;
    SMM_HistoryRdIndex[ChanNum] = HistoryRdIndex;

}

/*******************************************************************
		G711 PLC Module Initialization Routine
********************************************************************/

void G711PlcInit(uWord16 ChanNum)
{
     SMM_EraseCnt[ChanNum]       = 0;			 /* consecutive erased frames */
     SMM_Pitch_offset[ChanNum]   = 0;
     SMM_HistoryWtIndex[ChanNum] = 0;
     SMM_HistoryRdIndex[ChanNum] = HISTORYLEN - POVERLAPMAX; //--> 360
}

#endif

