
/**********************************************************************
   FileName : G711pLcVar.h
   Description :     G711 PLC Variable definitions

**********************************************************************/

#include "G711PLCCons.h"

#if G711_PLC

extern Word32 PLC_Frame;
extern Word16 sample;
extern Word16 RxPacketType;
extern Word16 speech[FRAME_LEN];
extern Word16 VENKAT;
extern uWord16 frameCntr;
//uWord16 ChanNum;

/***********************************************************************
			  DM_OS   Global  Variables 
************************************************************************/
//Word16 PlcGainTable[6]= { 0x7FFF, 0x6665, 0x4CCC, 0x3332, 0x1999 ,0 };

/***********************************************************************
			  SMM_DM_RAM  Global  Variables 
************************************************************************/
extern uWord16 SMM_EraseCnt[MAX_CHAN];			 /* consecutive erased frames */

extern Word16 SMM_Pitch_overlap[MAX_CHAN];		 /* overlap based on pitch */
extern Word16 SMM_Pitch_offset[MAX_CHAN];		 /* offset into pitch period */

extern Word16 SMM_Pitch[MAX_CHAN];				 /* pitch estimate */
extern Word16 SMM_PitchBuf[MAX_CHAN][HISTORYLEN]; /* buffer for cycles of speech */
extern Word16 SMM_PitchBlen[MAX_CHAN];			 /* current pitch buffer length */

extern Word16 SMM_LastQ[MAX_CHAN][POVERLAPMAX];	 /* saved last quarter wavelength */

extern Word16 SMM_History[MAX_CHAN][HISTORYLEN];  /* history buffer */
extern Word16 SMM_HistoryWtIndex[MAX_CHAN];
extern Word16 SMM_HistoryRdIndex[MAX_CHAN];


/*************************************************************************
 		   Scratch variables for PLC State.
**************************************************************************/
//Word16 G711PlcState;

/*************************************************************************
			Scratch variables.
**************************************************************************/
extern uWord16 EraseCnt;			 /* consecutive erased frames */
extern Word16 Pitch_overlap;		 /* overlap based on pitch */
extern Word16 Pitch_offset;		 /* offset into pitch period */
extern Word16 Pitch;				 /* pitch estimate */
extern Word16 PitchBlen;			 /* current pitch buffer length */

extern Word16  *HistoryBuffPtr;
extern Word16 HistoryWtIndex;
extern Word16 HistoryRdIndex;

extern Word16 *LastQBuffPtr;	     /* saved last quarter wavelength */

extern Word16 *PitchBuffPtr;
extern Word16 *PitchBufEndPtr;		 /* end of pitch buffer */
extern Word16 *PitchBufStartPtr;	 /* start of pitch buffer */


extern Word16 temp[280];           //--> For Normalization
extern Word16 *tempend;

extern Word16 bestmatch;
extern Word16 bestcorr;
extern Word16 corr1;
extern Word16 scal16;
extern Word16 corr16;
extern Word16 max; // = 0;
extern Word16 normvalue;
extern Word32 corr;		/* correlation */
extern Word32 energy;		/* running energy */
extern Word32 scale;		/* scale correlation by average power */


/*************************************************************************
			Scratch Variable for Add2History
**************************************************************************/
extern Word16 oLength;
/*************************************************************************
			Scratch Variables for GetFespeech
**************************************************************************/
extern Word16 cnt;

/*************************************************************************
			Scratch Variables for Scale Speech
**************************************************************************/
extern Word16 RampFact;

/*************************************************************************
			Scratch Variables for OverLap AddEnd
**************************************************************************/
extern Word16 incr,lw,rw;
extern Word32 OLAdd;
extern Word16 gain;
extern Word32 OLAddAtEnd;
extern Word16 incrg;	  

/*************************************************************************
			Scratch Variables for Add To History, for the Good first Frame.
**************************************************************************/
extern Word16 TempBuff[FRAME_LEN]; //--> 40 samples

/*************************************************************************
			Scratch Variables used in dofe function during PLC state -2
**************************************************************************/
extern Word16 Temp1_plc;
extern Word16 saveoffset;

/*************************************************************************
			Scratch Variables used for Pointers
**************************************************************************/
extern Word16 *BuffPtr1;
extern Word16 *BuffPtr2;
extern Word16 *BuffPtr3;

/*************************************************************************
			Scratch Variables used for indexes
**************************************************************************/
//uWord16 i, j, k;
/*************************************************************************
			End of Variables Declarations 
**************************************************************************/
#endif
