/*  
  FileName : ToneGenApi.c
*/

#include <oswrapper.h>
#include "ToneGenCons.h"

#if TONE_GEN

extern Word16 speech[BLOCK_LEN];
extern Word16 ToneSampCnt;
extern Word16 ToneGen_Phasetemp[];
extern Word16 ToneGen_Phasetemp1[];

extern Word16 ToneGen_Phase1;
extern Word16 ToneGen_Phase2;
extern Word16 ToneGen_Phase3;
extern Word16 ToneGen_Phase4;

extern Word16 ToneGen_Scale1;
extern Word16 ToneGen_Scale2;
extern Word16 ToneGen_Scale3;
extern Word16 ToneGen_Scale4;

extern Word16 Sample1;
extern Word16 Sample2;

extern Word16 countryType;
extern Word16 ToneVal;
extern Word16 SMM_bPha4[];
extern Word16 SMM_bPha3[];
extern Word16 CurChanNum;
extern Word16 ToneGenSin(Word16 x,Word16 tone_scale);

void ToneGeneration(Word16 ucToneLen)
{

    Word16 ii;
  	
  
    //Generate Tone Samples
    for( ii = 0; ii < ToneSampCnt; ii++)
    {    	
    
       Sample1 = ToneGenSin(ToneGen_Phasetemp[0],ToneGen_Scale1);       
       ToneGen_Phasetemp[0] += ToneGen_Phase1;   
       
       Sample2 = ToneGenSin(ToneGen_Phasetemp[1],ToneGen_Scale2);       
       ToneGen_Phasetemp[1] += ToneGen_Phase2;

       speech[ii] = Sample1+ Sample2;

       /*************************************************
        For KOREA Country, HOWLER TONE is a combination
        of FOUR Frequencies. So add remaining TWO 
        frequencies also.
       *************************************************/ 
       if(countryType == TONE_GEN_KOREA)
       {
          if(ToneVal == HOWLER_TONE)
	  {
             Sample1 = ToneGenSin(ToneGen_Phasetemp1[0],ToneGen_Scale3);
             ToneGen_Phasetemp1[0] += ToneGen_Phase3;

             Sample2 = ToneGenSin(ToneGen_Phasetemp1[1],ToneGen_Scale4);
             ToneGen_Phasetemp1[1] += ToneGen_Phase4;

	     speech[ii] += (Sample1+ Sample2);
	  }
       }

	if(countryType == TONE_GEN_ROMANIA)
       {
          if(ToneVal == SPL_INFO_TONE_ROMANIA)
	  {
             Sample1 = ToneGenSin(ToneGen_Phasetemp1[0],ToneGen_Scale3);
             ToneGen_Phasetemp1[0] += ToneGen_Phase3;

             
	     speech[ii] += (Sample1+ Sample2);
	  }
       }

      if(SMM_bPha3[CurChanNum]== 1)
       {
          
	  
             Sample1 = ToneGenSin(ToneGen_Phasetemp1[0],ToneGen_Scale3);
             ToneGen_Phasetemp1[0] += ToneGen_Phase3;

             
	     speech[ii] += (Sample1+ Sample2);
	  
       }

	if(SMM_bPha4[CurChanNum]== 1)
       {
          
	  
             Sample1 = ToneGenSin(ToneGen_Phasetemp1[0],ToneGen_Scale3);
             ToneGen_Phasetemp1[0] += ToneGen_Phase3;

             
	     speech[ii] += (Sample1+ Sample2);
	  
       }

    }

    //Generate Pause Samples
    for( ii = ToneSampCnt; ii < ucToneLen; ii++)
      speech[ii] = 0;
 }

#endif

