/******************************************************************************
	File Name		:   ToneGenCons.h
	Description     	:   This file contains constants definitions
	Version Number		:   1.0
******************************************************************************/

#if TONE_GEN
#define CA_NOTONE            255

#define DTMF_DIGIT_GENERATION

////////Country specific MACROS  /*later have to be changed to definitions in voicelif.h */
#define TONE_GEN_USA                    0
#define TONE_GEN_FRANCE                 1
#define TONE_GEN_KOREA                  2
#define TONE_GEN_JAPAN                  3
#define TONE_GEN_ROMANIA              4

#define MAX_NUM_COUNTRY                 NUM_COUNTRY //5 if Romania is included
#define MAX_NUM_TONES                   50

/** Maxmimum Number of Tones in each country **/
#define MAXTONES_USA                    0x1e
#define MAXTONES_FRANCE                 0x2d
#define MAXTONES_KOREA                  0x2c
#define MAXTONES_JAPAN                  0x30
#define MAXTONES_ROMANIA              0x1f  

#define BLOCK_LEN	                80
#define FRAME_LEN	                BLOCK_LEN

/*************************************************************
     MAX_CHAN number  for Each Module Memory Declarations.
*************************************************************/
#define  MAX_CHAN	      MAX_VOICE_CHANNELS

#define TEST_1K_TONE    0xFF

/////////////////// TONE MACROS //////////////////
#define DIAL_TONE  			0x0
#define RING_BACK_TONE			0x1
#define BUSY1_TONE			0x2
#define BUSY2_TONE			0x3
#define ERROR_TONE			BUSY2_TONE
#define CALL_WAITING_TONE1		0x4
#define CALL_WAITING_TONE2		CALL_WAITING_TONE1	//same as above but continuous
#define REORDER_TONE			0x5
#define STUTTER_TONE			0x6
#define OFFHOOK_WARNING_TONE		0x7
#define MELODY_TONE			0x8 //0x8 -0xd
#define DIG_0_TONE			0xe
#define DIG_1_TONE			0xf
#define DIG_2_TONE			0x10
#define DIG_3_TONE			0x11
#define DIG_4_TONE			0x12
#define DIG_5_TONE			0x13
#define DIG_6_TONE			0x14
#define DIG_7_TONE			0x15
#define DIG_8_TONE			0x16
#define DIG_9_TONE			0x17
#define DIG_A_TONE			0x18
#define DIG_B_TONE			0x19
#define DIG_C_TONE			0x1a
#define DIG_D_TONE			0x1b
#define DIG_STAR_TONE			0x1c
#define DIG_HASH_TONE			0x1d
#define CPE_ALERTING_TONE		0x1e	//for Off-Hook CallerID...

#define DIG_1_TONE_CONT		0x5

//////// France Tones ///////////////////////
//////// 0x8 - 0xd Melody Tones
//////// 0xe - 0x1f DTMF Tones, CPE Alerting Tone
//////// 0x5 - dummy for FRANCE

#define SPECIAL_DIAL_TONE		0x6
//////// SplInfoTone - 0x1f - 0x21
#define SPL_INFO_TONE			0x1f
//////// ROC Tone - 0x22 - 0x25
#define ROC_TONE			0x22
//////// MsgWaitIndTone - 0x28 - 0x2a
#define MESG_WAITING_INDICATOR_TONE     0x26
//////// LDCOM_DAIL_TONE - 0x2b - 2d
#define VOIP_DIAL_TONE			0x29 
#define TEST_TONE 0x2d
#define CALL_IN_PROGRESS_TONE           0x21
#define VOIP_MESG_WAITING_INDICATOR_TONE 0x2a
//////// end of France Tones ////////////////

//////// KOREA Tones /////////////////////////
#define BUSY_TONE			BUSY1_TONE	//0x2
#define CONGESTION_TONE			BUSY2_TONE  //0x3
//////// 0x4 Call waiting Tone
#define CALL_WAITING_TONE_2		0x5
#define INTERN_DIAL_TONE		0x6
#define IMM_RING_BACK_TONE		0x7
//////// 0x8 - 0xd Melody Tone
//////// 0xe - 0x1e DTME Tone, CPE Alerting Tone
#define CALL_HOLD_TONE1			0x1f
#define CALL_HOLD_TONE2			0x20
#define INTERCEPT_TONE1			0x21
#define INTERCEPT_TONE2			0x22
#define BIT_TONE			0x23
#define RESERVE_TONE	        	0x24
#define FAILURE_TONE			0x25
#define HOLD_RELEASE_TONE		0x26
#define HOWLER_TONE			0x27

//-->   Yet to be implemented
#define COFIRM_TONE1			0x29
#define COFIRM_TONE2	        	0x2a
#define COFIRM_TONE3			0x2b
#define AUTO_ANSWER_TONE		0x2c
//////// end of KOREA Tones ///////////////////

//////// JAPAN Tones //////////////////////////
////////0x4-0x6 CallWaiting1-3,DialBuffPABX
#define DIAL_TONE_PABX			0x7

//////// 0x8 - 0xd Melody Tone
//////// 0xe - 0x1e DTME Tone, CPE Alerting Tone
#define SECOND_DIAL_TONE_I		0x1f
#define SECOND_DIAL_TONE_II		0x20
#define SECOND_DIAL_TONE_III    	0x21
#define RECALL_DIAL_TONE 		0x22
#define RINGING_TONE_PABX		0x23
#define SPECIAL_INFO_TONE		0x24
/////// 0x25-0x26 - Waiting_Tone_I
#define WAITING_TONE_I			0x25
/////// 0x27-0x28 - Waiting_Tone_II
#define WAITING_TONE_II	        	0x27
/////// 0x2a-0x2b - Waiting_Tone_II_1
#define WAITING_TONE_II_1		0x29
#define CALL_WAITING_TONE3		0x2b
//#define CALL_WAITING_TONE4		0x2a	//Same as Call_waiting_Tone3 but continuous
#define PAY_TONE_I			0x2e
#define PAY_TONE_II			0x2f
/////// 0x30 - 0x31 - POSITIVE_INDI_TONE
#define POSITIVE_INDI_TONE		0x30
//////// end of JAPAN Tones //////////////////////////////

///ROMANIA TONES/////
  #define SPL_DIAL_TONE  0x6
  #define SPL_CNF_TONE   0xa
  #define SPL_INFO_TONE_ROMANIA 0xb

//////// end of TONE MACRO DEFINITIONS ///////////////////


#define TONE_GEN_ACTIVE			2
#define TONE_GEN_INACTIVE		1


/*******************************
     Tone Generation States
********************************/
#define INACTIVE                       0 
#define TONE		               1
#define TONE2PAUSE                     2
#define PAUSE		               3
#define TONE_CYCLE_END                 4
#define TONE2DECODER                   5

/** No. of Samples per milli Second **/
#define MS_PER_SAMPLES                 8


/** Counter for DTMF Tone Generation **/
#define DIG_GEN_IPC_CNTR               25

#endif
