
/*
          sivan.nagireddi@analog.com
          Dtmf constants
*/

/*********************************************************/
#define DTMFRX_TEST_HARNESS            0x07FF


#define DTMFRX_TONE_ON_THR                    1   //--> > 2 * 400  = 800
#define DTMFRX_TONE_OFF_THR                   1   //--> < 3 * 400  = 800

#define DTMFRX_TONE_ON_ABS_THR                4   //--> > 5 * 400  = 2000
#define DTMFRX_TONE_END_PAUSE_CNT           0x2   //--> 4 * 10   = 40ms 
#define DTMFRX_MAX_DIFFERENT_DIGIT_DET_CNT  0x4
/*********************************************************/
#define DTMFRX_PROBE_FAIL_CONDITION    0x0000

/*********************************************************
				  TEST -1
*********************************************************/
#define DTMFRX_MIN_DETECTIONS_CNT                0x4
#define DTMFRX_MIN_DETECTIONS_CNT_PASS_BIT    0x0001


/*********************************************************
				  TEST -2
*********************************************************/
#define DTMF_DIG_ABS_CNT                         0x3
#define DTMF_DIG_ABS_CNT_PASS_BIT             0x0002

/*********************************************************
				  TEST -3
*********************************************************/
#define DTMFRX_DIG_PROBABLITY_PASS_BIT        0x0004


/*********************************************************
				  TEST -4
*********************************************************/
#define DTMFRX_MAX_ALLOWABLE_DIP_CNT              0x4
#define DTMFRX_MAX_ALLOWABLE_DIP_CNT_PASS_BIT  0x0008



/*********************************************************
				  TEST -5
*********************************************************/
#define DTMFRX_MAX_TONE_ON_OFF_SWITCHING               0x3
#define DTMFRX_MAX_TONE_ON_OFF_SWITCHING_PASS_BIT   0x0010



/*********************************************************
				  TEST -6
*********************************************************/
#define DTMFRX_MAX_TONE_OFF_ON_SWITCHING                0x3
#define DTMFRX_MAX_TONE_OFF_ON_SWITCHING_PASS_BIT    0x0020



/******************************************************************************
TEST -7 : REV_TWI : COL < ROW BY 6dB :: Column freq cannot be less than 6dB 
******************************************************************************/
#define DTMFRX_REV_TWIST_TEST            0x0040
#define DTMFRX_REV_TWI                     -8  //-8dB


/******************************************************************************
TEST -8  FOR_TWI : COL > ROW BY -8.0dB :: Column freq cannot be 
greater than 8dB.
******************************************************************************/
#define DTMFRX_FAR_TWIST_TEST          0x0080
#define DTMFRX_FOR_TWI                     +8 //Generally spec : +4dB.


/******************************************************************************
TEST -9 &10   4096-side lobe must be 10 dBdown peak lobe 
Rectangular window : 12dB.
******************************************************************************/
#define DTMFRX_COL_SIDELOBE_TEST       0x0100
#define DTMFRX_ROW_SIDELOBE_TEST       0x0200
#define DTMFRX_ROW_REL_RATIO               9//10dB
#define DTMFRX_COL_REL_RATIO               9//10dB
#define DTMFRX_REL_RATIO                   10//10dB


/*********************************************************
TEST -11
*********************************************************/
#define DTMFRX_TALK_OFF_TEST           0x0400  //---> Test Bit.
//---> 3 = 30 ms, There should be minimum Loss.
#define DTMFRX_TALK_OFF_THR            0x2 


/*********************************************************
END of TEST CONFIGURATIONS
*********************************************************/

/*********************************************************
        Digit Test Summary Array
*********************************************************
0. Digit
1. No of Digit Detections
2. Total Digit Energy
3. Null detections Cnt
4. Just Tone On Cnt
5. Absoulte Digit Cnt
6. Tone_switch_on_cnt
7. Tone_switch_off_cnt
8. Reverse_Twist_PassCnt
9. Reverse Twist_FailCnt
10.Farward_Twist_PassCnt
11.Farward_Twist_FailCnt
12.Col_Rel_RatioPassCnt
13.Col_Rel_RatioFailCnt
14.Row_Rel_RatioPassCnt
15.Row_Rel_RatioFailCnt
16.Talk_off_PassCnt
17.Talk_off_FailCnt
18.Test Summary-Bits on This Digit.
*********************************************************
        End of Digit Test Summary Array
*********************************************************/

#define DTMFRX_TONE_ON_TOT_SIG_THR   8 //-24dBm.
//#define DTMFRX_TONE_ON_TOT_SIG_THR   10 //-30dBm.
#define DTMFRX_MAX_ALLOWED_DIFFERENT_DIGITS  2
