
/**********************************************************************
File Name		:	JitCons.h
Description     :   This file contains the Constants used in the
    			  		Jitter Buffer module 	
Authors         : sivan.nagireddi@analog.com
                                     &rajakumar.kulakarni@analog.com.
Version Number	:	2.0
Date            : 29Aug2004. 
Company Name	:  	Analog Devices India (P) Ltd
**********************************************************************/
#ifndef __JIT_CONS_H
#define __JIT_CONS_H

//---------------------------------------------------------------------
//#define SIMULATOR
//---------------------------------------------------------------------
//#include <ipvoice/include/dspipc.h>
//---------------------------------------------------------------------
#define JIT_DELAY_ESTIMATION
//---------------------------------------------------------------------
/*********************/
#define FIXED_JITTER
/*********************/

#ifndef AJB_SIMULATOR
   
/**************************************************/
//---> To make active all CiTx code.
/**************************************************/
  // #define  CALLER_IDTx
#endif



#define AJB_MAX_PAYLOAD_CELL_LEN  80


#define AJB_READ_RATE_5MS    5
#define AJB_READ_RATE_10MS  10


#define AJB_PLC_ENA 1
#define AJB_PLC_DIS 0

#define AJB_PLC_ENA_DIS_FLAG AJB_PLC_DIS 
//#define AJB_PLC_ENA_DIS_FLAG AJB_PLC_ENA 




//#define AJB_READ_RATE_MS  AJB_READ_RATE_5MS
#define AJB_READ_RATE_MS  AJB_READ_RATE_10MS

#define AJB_MIN_PAYLOAD_CELL_LEN  (AJB_READ_RATE_MS * 8)


#define AJB_DELAY_CONTROL_ACTIVE           0
#define AJB_DELAY_CONTROL_IN_ACTIVE        1


/*---------------------------------------------------------------------
   ----------------   AJB BUFFER  LENGTH CONSTANTS   ------------------
---------------------------------------------------------------------*/
#define JIT_MAX_FRAMES          10
#define JIT_HIST_BUFF_MAX_LEN   200  //---> 2 -Seconds of HistoryBuffer.
#define JIT_NORM_BUFF_MAX_LEN    80 //--->400ms of Normal Buffer.
#define JIT_OF_MAX_CELL_MARK     80 //--->400ms-second OverFlow Buffer.

#define JITBUFF_LEN1        ( JIT_NORM_BUFF_MAX_LEN +  JIT_OF_MAX_CELL_MARK )
#define JITBUFF_MAX_LEN     ( JITBUFF_LEN1 + JIT_MAX_FRAMES )
#define JIT_QUE_MAX_LEN      JIT_NORM_BUFF_MAX_LEN
/*---------------------------------------------------------------------
   ----------------   AJB BUFFER  LENGTH CONSTANTS   ------------------
---------------------------------------------------------------------*/




/*---------------------------------------------------------------------
//--> Property of PayLoad 
---------------------------------------------------------------------*/
#define JIT_SPEECH_PACKET      2
#define JIT_VAD_PACKET         1
#define CONTINUE_SILENCE       0
#define JIT_NO_PACKET          0
/*---------------------------------------------------------------------
//--> Property of PayLoad 
---------------------------------------------------------------------*/




/*---------------------------------------------------------------------
//---------->  JITTER BUFFER MEMORY OPERATION CONSTANTS
---------------------------------------------------------------------*/
#define JIT_IND_NULL         0xFFFF
/*---------------------------------------------------------------------
//---------->  JITTER BUFFER MEMORY OPERATION CONSTANTS
---------------------------------------------------------------------*/


//---> Codec FrameLengthAttributes.
#define AJB_CODEC_NULL_INSTANCE          0x0000
#define AJB_G723_CODEC_INSTANCE          0xFF00

#define AJB_PCM_NO_OF_SAMPLES_PER_1MS    8 

#define G711_BASIC_SPEECH_FRAME_MS       AJB_READ_RATE_MS
#define G711_BASIC_SPEECH_FRAME_LEN      AJB_MIN_PAYLOAD_CELL_LEN
#define G711_ANNEX1_SILENCE_FRAME_LEN    1 
#define G711_ANNEX2_SILENCE_FRAME_LEN   11

#define G726_BASIC_SPEECH_FRAME_MS       5
#define G726_16_BASIC_SPEECH_FRAME_LEN  10
#define G726_24_BASIC_SPEECH_FRAME_LEN  15
#define G726_32_BASIC_SPEECH_FRAME_LEN  20
#define G726_40_BASIC_SPEECH_FRAME_LEN  25

#define G729_BASIC_SPEECH_FRAME_MS      10
#define G729_BASIC_SPEECH_FRAME_LEN     10
#define G729_SILENCE_FRAME_LEN           2

#define G723_BASIC_SPEECH_FRAME_MS      30
#define G723H_BASIC_SPEECH_FRAME_LEN    24
#define G723L_BASIC_SPEECH_FRAME_LEN    20
#define G723_SILENCE_FRAME_LEN           4


//-----> 5ms Isr -Codec Attributes
#define G711_READ_SKIP_CNTR_5MS_ISR   0
#define G729_READ_SKIP_CNTR_5MS_ISR   1
#define G723_READ_SKIP_CNTR_5MS_ISR   5

#define G711_READ_REP_CNTR_5MS_ISR    1
#define G729_READ_REP_CNTR_5MS_ISR    1
#define G723_READ_REP_CNTR_5MS_ISR    1


//-----> 10ms Isr-Codec Attributes
#define G711_READ_SKIP_CNTR_10MS_ISR  0
#define G729_READ_SKIP_CNTR_10MS_ISR  0
#define G723_READ_SKIP_CNTR_10MS_ISR  2

#define G711_READ_REP_CNTR_10MS_ISR   (10 / AJB_READ_RATE_MS)
#define G729_READ_REP_CNTR_10MS_ISR   1
#define G723_READ_REP_CNTR_10MS_ISR   1


/*********************************************************************
				DEFAULT THRESHOLDS CONFIGURATION
*********************************************************************/

//------------Allowed Max No of   Packet drops per one entry-----------
#define DEF_AJB_MODE                       AJB //--> Default is AJB Mode
//#define DEF_AJB_MODE                     FJB //--> Default is FJB Mode

//#define AJB_HISTORY_LEN                   24 // 1 Minute-
#define AJB_HISTORY_LEN                     36 // 1.5 Minute
#define DEF_AJB_ALLOW_NULL_PLAY_PASS_FAIL_CNT_THR  2//Allow for 5Seconds
#define DEF_AJB_ALLOW_PKT_DROP_PER_SLOT    0
#define AJB_MAX_NO_OF_DELAY_LEVELS         9
//percent of Allowed Drop Strategies.
#define DEF_AJB_ALLOW_NULLS_PER_SLOT_LEVEL1_DELAY  1
#define DEF_AJB_ALLOW_NULLS_PER_SLOT_LEVEL2_DELAY  1
#define DEF_AJB_ALLOW_NULLS_PER_SLOT_LEVEL3_DELAY  2
#define DEF_AJB_ALLOW_NULLS_PER_SLOT_LEVEL4_DELAY  2
#define DEF_AJB_ALLOW_NULLS_PER_SLOT_LEVEL5_DELAY  3
#define DEF_AJB_ALLOW_NULLS_PER_SLOT_LEVEL6_DELAY  3
#define DEF_AJB_ALLOW_NULLS_PER_SLOT_LEVEL7_DELAY  4
#define DEF_AJB_ALLOW_NULLS_PER_SLOT_LEVEL8_DELAY  4
#define DEF_AJB_ALLOW_NULLS_PER_SLOT_LEVEL9_DELAY  5
//---------------------------------------------------------------------

//------------------Delay Estimation Module Limits---------------------
#define DEF_AJB_MIN_DELAY_MS    0 // in ms
#define DEF_AJB_MAX_DELAY_MS  500 // in ms
#define DEF_AJB_DEL_OFFSET_MS  27 // in ms
//------------------Delay Estimation Module Limits---------------------


//------------------Timers---------------------------------------------
#define DEF_AJB_DELAY_EST_TIMER             10  // in ms
#define DEF_AJB_DELAY_DROP_TIMER          1000 //5000  // in ms
#define DEF_AJB_STASTICS_RESET_TIMER      2500  // in ms
//---------------------------------------------------------------------

//-----------AJB RESET FOR WORST SITUATIONS----------------------------
#define DEF_AJB_RESET_ON_MAX_LATE_PKT_DROP_TIME     1000 //--> 1 Sec.
#define DEF_AJB_RESET_ON_MAX_NULL_PLAY_OUT_TIME   180000 //-->3Minutes.
#define DEF_AJB_RESET_DELAY_EST_MODULE_TIME        30000 //-->0.5Minutes.:191
//-----------AJB RESET FOR WORST SITUATIONS----------------------------


/*---------------------------------------------------------------------
                   WORST DELAY HITS
---------------------------------------------------------------------*/
#define DEF_AJB_WORST_DELAY_THRESHOLD           10000 //-->in ms
#define DEF_AJB_WORST_DELAY_HIT_RECOVERY_TIMER  10000 //-->in ms
#define DEF_AJB_WORST_DELAY_HIT_TIMER           10000 //-->in ms
/*---------------------------------------------------------------------
                   WORST DELAY HITS
---------------------------------------------------------------------*/

/*---------------------------------------------------------------------
      PLAY-OUT-QUALITY-VVVVVS-DELAY-TRADE-OFF-TUNING-PARAMETERS
---------------------------------------------------------------------*/
#define DEF_AJB_DELAY_EST_SIGMA_FACTOR                0 //Percent. :208
#define DEF_AJB_DELAY_TRACK_SIGMA_FACTOR             30 //Percent.
#define DEF_AJB_GAP_DELAY_EST_SIGMA_FACTOR           30 //Percent.
/*---------------------------------------------------------------------
      PLAY-OUT-QUALITY-VVVVVS-DELAY-TRADE-OFF-TUNING-PARAMETERS
---------------------------------------------------------------------*/
/*********************************************************************
			END OF DEFAULT THRESHOLDS CONFIGURATION
*********************************************************************/

/*******************************************************************
                   -----AJB READ STATES------
*******************************************************************/
#define JIT_RD_STATE_PLAY   0
#define JIT_RD_STATE_UND    1

/*******************************************************************
               -----END OF AJB READ STATES------
*******************************************************************/


/*******************************************************************
                   AJB CONFIGURATION SWITCHES
*******************************************************************/
//---> JitDelayEstimation Ena/Dis----------------------------------
#define AJB_DEBUG_LOGGER_LEN   20

//---> To Enable Delay Estimation----------------------------------
#define JIT_DELAY_ESTIMATION
//---> JitDelayTrackEna/Dis----------------------------------------
#define JIT_SPIKE_DETECTION
#define AJB_COUNTERS_SET_AND_RESET
#define JIT_DELAY_TRACK
//----------AJB-RD-SWH---------------------------------------------
#define  JIT_RD_DELAY_TRACK
#define  AJB_LATE_PKT_DROP
//---> ToEnable DebugLogger----------------------------------------
//#define  AJB_DEBUG
#define    AJB_RESET
//---> Auto Reset Feature------------------------------------------
#define    JIT_VAD_ENABLED
//---> GAP-Estimation EnableFeature--------------------------------
#define AJB_GAP_OFFSET_ENABLE
/*******************************************************************
                   AJB CONFIGURATION SWITCHES
*******************************************************************/


/******************************************************************
                 LOOP -SAFE SWITCHES
******************************************************************/
#define JIT_WT_INF_LOOP_NOT_SAFE1
#define JIT_WT_INF_LOOP_NOT_SAFE2
#define JIT_PUT_INF_LOOP_NOT_SAFE1
#define JIT_PUT_INF_LOOP_NOT_SAFE2
#define JIT_RD_INF_LOOP_NOT_SAFE1
/******************************************************************
             END OF LOOP -SAFE SWITCHES
******************************************************************/






/*********************************************************************/
#ifdef AJB_SIMULATOR
/*********************************************************************/



//#define G723_ENA
//#define G711_ENA
#define G729_ENA
//#define  JIT_VAD_ENABLED

//--------------------------------->  RTP PAY LOAD FORMATS
#define JIT_G711MU_CODEC       0 
#define JIT_G729_CODEC        18
#define JIT_G723_CODEC         4
#define MAX_VOICE_CHANNELS     1
#define MAX_CHAN               1
#define READ	               1
#define WRITE	               2


#define MULTI_FRAME_LEN          1
#define G711_SPEECH_FRAME_LEN    (80 * MULTI_FRAME_LEN )
#define G729_SPEECH_FRAME_LEN    (10 * MULTI_FRAME_LEN )
#define G723H_SPEECH_FRAME_LEN   (24 * MULTI_FRAME_LEN )
#define G723L_SPEECH_FRAME_LEN   (20 * MULTI_FRAME_LEN )
#define G711_SID_FRAME_LEN       ( 1 * MULTI_FRAME_LEN )
#define G711A_SID_FRAME_LEN      (11 * MULTI_FRAME_LEN )
#define G729AB_SID_FRAME_LEN     ( 2 * MULTI_FRAME_LEN )
#define G723_SID_FRAME_LEN       ( 4 * MULTI_FRAME_LEN )
/*********************************************************************/
#endif  //---> End of Simulator.
/*********************************************************************/


/*********************************************************************/
#ifndef AJB_SIMULATOR
/*********************************************************************/
typedef struct 
{
  BOOL  bJBType;
  INT16 uiDepth;
  INT16 uiThreshold;
  INT16 uiPassThrThreshold;
}JitterParams_t;
/*********************************************************************/
#endif //#ifndef AJB_SIMULATOR
/*********************************************************************/


/*********************************************************************
                        MARKOV-4STATE MODEL
*********************************************************************/
#define MARKOV4_EXCITATION_CNTR_LIM  32768
#define MARKOV4_PROB_NORM_MAX        32767

//#define MARKOV4_PLC_TYPE    0  //--> unspecified.
//#define MARKOV4_PLC_TYPE    1 //--> Disable PLC
//#define MARKOV4_PLC_TYPE    2 //--> Enhanced PLC
#define MARKOV4_PLC_TYPE    3 //--> Standard PLC

//#define MARKOV4_JB_TYPE     0  //--> unspecified.
//#define MARKOV4_JB_TYPE     1  //--> Reserved
#define MARKOV4_JB_TYPE       2  //--> FJB
//#define MARKOV4_JB_TYPE     3  //--> AJB

#define MARKOV4STATE1   1
#define MARKOV4STATE2   2
#define MARKOV4STATE3   3
#define MARKOV4STATE4   4
#define R_MODEL_IE_G711_OFFSET       6630
#define R_MODEL_IE_G726_40_OFFSET   20000
#define R_MODEL_IE_G726_32_OFFSET   70000
#define R_MODEL_IE_G726_24_OFFSET  250000
#define R_MODEL_IE_G726_16_OFFSET  500000
#define R_MODEL_IE_G729_OFFSET     107880
#define R_MODEL_IE_G723_H_OFFSET   145982
#define R_MODEL_IE_G723_L_OFFSET   190000

#define R_MODEL_IE_DIV_FACTOR       10000

#define R_MODEL_R_TO_MOS_DIV_FACTOR      100000
#define R_MODEL_R_TO_MOS_OFFSET         1000000
#define R_MODEL_R_TO_MOS_COEF1            35000
#define R_MODEL_R_TO_MOS_COEF2                7

#define IMPAIRMENT_DELAY_A2D_AND_D2A_OFFSET_MS    10 //ms
//-------------VQMON-rtcpXr Packet building Constants.
#define VQ_MON_RTCP_XR_BLOCK_LEN   9
#define VQMON_RTCP_XR_BLOCK_TYPE     7
#define VQMON_RTCP_XR_BLOCK_LEN      8
/*********************************************************************
                      END OF MARKOV-4STATE MODEL
*********************************************************************/
#endif
