#include <oswrapper.h>
#include "legerityrw.h"

int write2codec1word(int codecNo, unsigned char data)
{
  unsigned char dummy;
  DEASSERT_CHIPSELECT(codecNo);
  ASSERT_CHIPSELECT(codecNo);
  spiInitOperation(data,&dummy);
  DEASSERT_CHIPSELECT(codecNo);
  return 0;
}
void write2codec2word(int codecNo, unsigned char addr, unsigned char data)
{
  unsigned char dummy;
  DEASSERT_CHIPSELECT(codecNo);
  ASSERT_CHIPSELECT(codecNo);
  spiInitOperation(addr,&dummy);
  DEASSERT_CHIPSELECT(codecNo);
  ASSERT_CHIPSELECT(codecNo);
  spiInitOperation(data,&dummy);
  DEASSERT_CHIPSELECT(codecNo);
}

int write2codecArray(int codecNo, unsigned char addr, unsigned char *dataptr, int size_of_arr)
{
  int i;
  unsigned char dummy, data;
  DEASSERT_CHIPSELECT(codecNo);
  ASSERT_CHIPSELECT(codecNo);
  spiInitOperation(addr,&dummy);
  DEASSERT_CHIPSELECT(codecNo);

  for(i=0;i<size_of_arr;i++)
  {
    data= dataptr[i];
    DEASSERT_CHIPSELECT(codecNo);
    ASSERT_CHIPSELECT(codecNo);
    spiInitOperation(data,&dummy);
    DEASSERT_CHIPSELECT(codecNo);
  }
  DEASSERT_CHIPSELECT(codecNo);
  return 0;
}

void read2codecArray(int codecNo, unsigned char addr,unsigned char *data, int count)
{
  unsigned char dummy, dummy00, value;
  int i;
  dummy00 = 0xFF;
  DEASSERT_CHIPSELECT(codecNo);
  ASSERT_CHIPSELECT(codecNo);
  spiInitOperation(addr,&dummy);
  DEASSERT_CHIPSELECT(codecNo);
  for(i=0; i<count; i++)
  {
    DEASSERT_CHIPSELECT(codecNo);
    ASSERT_CHIPSELECT(codecNo);
    spiInitOperation(dummy00,&value);
    DEASSERT_CHIPSELECT(codecNo);
    *data++ = value; 
  }
  DEASSERT_CHIPSELECT(codecNo);
}

unsigned char read2codecArrayPrintf(int codecNo, unsigned char addr, int count)
{
  unsigned char dummy, dummy00, value;
  int i;
  dummy00 = 0xFF;
  DEASSERT_CHIPSELECT(codecNo);
  ASSERT_CHIPSELECT(codecNo);
  spiInitOperation(addr,&dummy);
  DEASSERT_CHIPSELECT(codecNo);
  printk("\r\n Array of %2X\n\r",addr);
  for(i=0; i<count; i++)
  {
    DEASSERT_CHIPSELECT(codecNo);
    ASSERT_CHIPSELECT(codecNo);
    spiInitOperation(dummy00,&value);
    DEASSERT_CHIPSELECT(codecNo);
    printk("%2X",value);
  }
  printk("\r\n");
  DEASSERT_CHIPSELECT(codecNo);
  return(value);
}

unsigned char read2codec2wordprintf(int codecNo, unsigned char addr)
{
  unsigned char dummy00, value, dummy1;
  dummy00 = 0xFF;
  DEASSERT_CHIPSELECT(codecNo);
  ASSERT_CHIPSELECT(codecNo);
  spiInitOperation(addr,&dummy1);
  DEASSERT_CHIPSELECT(codecNo);
  ASSERT_CHIPSELECT(codecNo);
  spiInitOperation(dummy00,&value);
  DEASSERT_CHIPSELECT(codecNo);
  printk("\r\n Read[%2X] = %2X\n\r",addr, value);
  return(value);

}

unsigned char read2codec2word(int codecNo, unsigned char addr)
{
  unsigned char dummy,value;
  DEASSERT_CHIPSELECT(codecNo);
  ASSERT_CHIPSELECT(codecNo);
  spiInitOperation(addr,&dummy);
  DEASSERT_CHIPSELECT(codecNo);
  ASSERT_CHIPSELECT(codecNo);
  spiInitOperation(0xFF,&value);
  DEASSERT_CHIPSELECT(codecNo);
  return(value);
}

int pollOnReg(int codecNo, unsigned char addr, unsigned char close_value,int  bitposition)
{
  unsigned char value, data;
  int flag_val;

  flag_val = 1;
  while(flag_val)
  {
        data = read2codec2word(codecNo, addr);
        value = 1 << bitposition;
        value = data & value;
        if (value == close_value) flag_val = 0;
  }
  return 0;
}

