/******************************************************************************
*
*   Copyright (C) 2002 Analog Devices India (P) Ltd. All rights are reserved.
*
*   The information and source code contained herein is the exclusive
*   property of Analog Devices India (P) Ltd. and may not be disclosed,
*   examined or reproduced in whole or in part without explicit written
*   authorization from the compnay.
*
******************************************************************************/

#ifndef __SPAIN_CONF_H
#define __SPAIN_CONF_H

//PGn/Boxer/OSP: pour l'instant, faute d'infos, les valeurs adoptees sont inspirees de FRANCE et POLAND

//****************************************************************************
//		Plan de transmission du FXS SPAIN : CPLX +2.5dBIn/-6.5dBout
//****************************************************************************
// SAGEM CFe : changement du plan de transmission du FXS : +2.5dBIn/-6.5dBout (au lieu de +3dBIn/-7dBout) 
// attnuation FXS totale en transmission de 2,5 dB avec les attnuations de 3.5 dB d'ATX, de 1.63 dB du mode linaire et gain ADCG de 2.63dB
// attnuation FXS totale en rception de 6,5 dB avec les attnuations de 3.5 dB d'ARX, de 0.15 dB intrinsque et 2.85dB de DACG 

// Transmit Path Digital To Analog Converter Gain/Attenuation = +2.63dB.
#define SP_XMIT_DIGITAL_GAIN_CPLX_IR14 		0x56A2
// Receive Path Digital To Analog Converter Gain/Attenuation = -2.85dB.
#define SP_RECV_DIGITAL_GAIN_CPLX_IR13 		0x2E19

//****************************************************************************
//		SPAIN Ring specifications : Ring 25Hz 35V 1s On 4s Off
//****************************************************************************
// Ringing Active Timer = 125uS * 0x2EE0 = 1,5S.
#define SP_RING_ON_1S5_LSB_DR48 			0xE0
#define SP_RING_ON_1S5_MSB_DR49 			0x2E
// Ringing Inactive Timer = 125uS * 0x5DC0 = 3S
#define SP_RING_OFF_3S_LSB_DR50 			0xC0
#define SP_RING_OFF_3S_MSB_DR51 			0x5D

// Ring Oscillator Frequency Coefficient for 25Hz.
#define SP_RING_OSC_FREQ_25HZ_IR7 			0x7E6C
// Ring Oscillator Amplitude Register for 50Hz and 35V.
#define SP_RING_OSC_AMP_25HZ_IR8 			0x0185
// Ring Oscillator Initial Phase Register for 50Hz and 35V.
#define SP_RING_OSC_INITPHASE_25HZ_IR9 		0x0000
// Data sheet SI3216.
#define SP_RING_TRIP_THRESH_25HZ_IR16 		0x3600
#define SP_RING_TRIP_FILTER_25HZ_IR23 		0x0350
// Ring Trip Detect Debounce Interval = 1.25mS * 0x0A = 12,5mS.
#define SP_RT_DEBOUNCE_25HZ_DR70 			0x0A


//****************************************************************************
//		SPAIN Tones specifications
//****************************************************************************
#define	SP_FREQ_425Hz 				0x7E39
#define	SP_F425Hz_AMP_M10dBm05 		0x008F
#define	SP_F425Hz_AMP_M14dBm05 		0x005A

#define	SP_FREQ_2130Hz 			0x55C6
#define	SP_F2130Hz_AMP_M9dBm0 		0x0386

#define	SP_FREQ_2750Hz 			0x3C57
#define	SP_F2750Hz_AMP_M9dBm0 		0x04C0

// OSC1	425Hz -6dBm0 continuous
#define	SP_DIAL_IR0 				SP_FREQ_425Hz
#define	SP_DIAL_IR1 				SP_F425Hz_AMP_M10dBm05

// OSC1	425Hz -6dBm0 50ms On 50ms Off. Pas d'infos -> par defaut = poland !
#define	SP_CALL_IN_PROGRESS_C0_IR0 	SP_FREQ_425Hz
#define	SP_CALL_IN_PROGRESS_C0_IR1 	SP_F425Hz_AMP_M10dBm05
#define	SP_CALL_IN_PROGRESS_C0_DR36 	0x90
#define	SP_CALL_IN_PROGRESS_C0_DR37 	0x01
#define	SP_CALL_IN_PROGRESS_C0_DR38 	0x90
#define	SP_CALL_IN_PROGRESS_C0_DR39 	0x01

// OSC1	425Hz -6dBm0 1,5s On 3s Off
#define	SP_RINGBACK_IR0 			SP_FREQ_425Hz
#define	SP_RINGBACK_IR1 			SP_F425Hz_AMP_M10dBm05
#define	SP_RINGBACK_DR36 			0xE0
#define	SP_RINGBACK_DR37 			0x2E
#define	SP_RINGBACK_DR38 			0XC0
#define	SP_RINGBACK_DR39 			0X5D

// OSC1	425Hz -6dBm0 0.2s On 0.2s Off
#define	SP_BUSY_IR0 				SP_FREQ_425Hz
#define	SP_BUSY_IR1 				SP_F425Hz_AMP_M10dBm05
#define	SP_BUSY_DR36 				0x40
#define	SP_BUSY_DR37 				0x06
#define	SP_BUSY_DR38 				0x40
#define	SP_BUSY_DR39 				0x06

// OSC1	425Hz -6dBm0 1s On 0.1s Off	
#define	SP_MSG_WAITING_C013_IR0 		SP_FREQ_425Hz
#define	SP_MSG_WAITING_C013_IR1 		SP_F425Hz_AMP_M10dBm05
#define	SP_MSG_WAITING_C013_DR36 	0x40
#define	SP_MSG_WAITING_C013_DR37 	0x1F
#define	SP_MSG_WAITING_C013_DR38 	0x20
#define	SP_MSG_WAITING_C013_DR39 	0x03

// OSC1	425Hz -6dBm0 0.175s On 0.175s Off
#define	SP_CALL_WAIT_C0_IR0 		SP_FREQ_425Hz
#define	SP_CALL_WAIT_C0_IR1 		SP_F425Hz_AMP_M14dBm05
#define	SP_CALL_WAIT_C0_DR36 		0x78
#define	SP_CALL_WAIT_C0_DR37 		0x05
#define	SP_CALL_WAIT_C0_DR38 		0x78
#define	SP_CALL_WAIT_C0_DR39 		0x05
// OSC1	425Hz -6dBm0 0.175s On 3.5s Off
#define	SP_CALL_WAIT_C1_IR0 		SP_FREQ_425Hz
#define	SP_CALL_WAIT_C1_IR1 		SP_F425Hz_AMP_M14dBm05
#define	SP_CALL_WAIT_C1_DR36 		0x78	
#define	SP_CALL_WAIT_C1_DR37 		0x05
#define	SP_CALL_WAIT_C1_DR38 		0x60
#define	SP_CALL_WAIT_C1_DR39 		0x6D

// OSC1	2130Hz -9dBm0 80ms On
#define	SP_ALERTING_IR0 			SP_FREQ_2130Hz
#define	SP_ALERTING_IR1 			SP_F2130Hz_AMP_M9dBm0
#define	SP_ALERTING_DR36 			0x80
#define	SP_ALERTING_DR37 			0x02
#define	SP_ALERTING_DR38 			0x00
#define	SP_ALERTING_DR39 			0x00
// OSC2	2750Hz -9dBm0 80ms On
#define	SP_ALERTING_IR3 			SP_FREQ_2750Hz
#define	SP_ALERTING_IR4 			SP_F2750Hz_AMP_M9dBm0
#define	SP_ALERTING_DR40 			0x80
#define	SP_ALERTING_DR41 			0x02
#define	SP_ALERTING_DR42 			0x00
#define	SP_ALERTING_DR43 			0x00

// OSC1	425Hz -6dBm0 continuous
#define	SP_VOIP_DIAL_IR0 			SP_FREQ_425Hz
#define	SP_VOIP_DIAL_IR1 			SP_F425Hz_AMP_M10dBm05


//****************************************************************************
//		SPAIN Dtmf specifications
//****************************************************************************
#define	SP_DTMF_FREQ_697Hz 			0x7b3c 
#define	SP_DTMF_F697Hz_AMP_M11dBm0 	0xdd

#define	SP_DTMF_FREQ_770Hz 			0x7a31 
#define	SP_DTMF_F770Hz_AMP_M11dBm0 	0xf5

#define	SP_DTMF_FREQ_852Hz 			0x78e6 
#define	SP_DTMF_F852Hz_AMP_M11dBm0 	0x110

#define	SP_DTMF_FREQ_941Hz 			0x775c 
#define	SP_DTMF_F941Hz_AMP_M11dBm0 	0x12d

#define	SP_DTMF_FREQ_1209Hz 		0x71d7 
#define	SP_DTMF_F1209Hz_AMP_M9dBm0 	0x1ea

#define	SP_DTMF_FREQ_1336Hz 		0x6ec8 
#define	SP_DTMF_F1336Hz_AMP_M9dBm0 	0x220

#define	SP_DTMF_FREQ_1477Hz 		0x6b10 
#define	SP_DTMF_F1477Hz_AMP_M9dBm0 	0x25d

#define	SP_DTMF_FREQ_1633Hz 		0x6692 
#define	SP_DTMF_F1633Hz_AMP_M9dBm0 	0x2a1

// OSC1	80ms On
#define	SP_DTMF_DR36 				0x80
#define	SP_DTMF_DR37 				0x02
// OSC2	80ms On
#define	SP_DTMF_DR40 				0x80
#define	SP_DTMF_DR41 				0x02

typedef enum
{
	SP_NULL_TONE 					= 0,
	SP_DIAL_TONE 					= 1,
	SP_CALL_IN_PROGRESS 			= 2,
	SP_RING_BACK_TONE 				= 3,
	SP_BUSY_TONE 					= 4,
	SP_MSG_WAITING_TONE 			= 5,
	SP_CALL_WAITING_TONE 			= 6,
	SP_ALERTING_TONE 				= 7,                                                                                
	SP_VOIP_DIAL_TONE 				= 8,
	SP_VOIP_MWI_TONE         	     = 9,
	SP_DTMF_DIG_0_TONE_LOCAL 		= 10,
	SP_DTMF_DIG_1_TONE_LOCAL 		= 11,
	SP_DTMF_DIG_2_TONE_LOCAL 		= 12,
	SP_DTMF_DIG_3_TONE_LOCAL 		= 13,
	SP_DTMF_DIG_4_TONE_LOCAL 		= 14,
	SP_DTMF_DIG_5_TONE_LOCAL 		= 15,
	SP_DTMF_DIG_6_TONE_LOCAL 		= 16,
	SP_DTMF_DIG_7_TONE_LOCAL 		= 17,
	SP_DTMF_DIG_8_TONE_LOCAL 		= 18,
	SP_DTMF_DIG_9_TONE_LOCAL 		= 19,
	SP_DTMF_DIG_A_TONE_LOCAL 		= 20,
	SP_DTMF_DIG_B_TONE_LOCAL 		= 21,
	SP_DTMF_DIG_C_TONE_LOCAL 		= 22,
	SP_DTMF_DIG_D_TONE_LOCAL 		= 23,
	SP_DTMF_DIG_STAR_TONE_LOCAL 		= 24,
	SP_DTMF_DIG_HASH_TONE_LOCAL 		= 25,
	SP_TONE_END 					= 26
} enumSpainTone;

#define	SP_MAX_NUM_CADENCE 			5


extern const ringStruct  spainRingTable;
extern const toneCadenceTables  spainToneCadenceTables [SP_TONE_END][SP_MAX_NUM_CADENCE];

#endif
