/******************************************************************************
*
*   Copyright (C) 2002 Analog Devices India (P) Ltd. All rights are reserved.
*
*   The information and source code contained herein is the exclusive
*   property of Analog Devices India (P) Ltd. and may not be disclosed, 
*   examined or reproduced in whole or in part without explicit written 
*   authorization from the compnay.
*
******************************************************************************/
#include<oswrapper.h>
#if FXO_MODULE
#include"include/si3050.h"

#include<slicapi.h>
extern SLICInfo_t gaSlicInfo[MAX_SLIC_CHANNELS];

//FCLUZEAU
#if EXT_MODULE
extern dsp_regExtModForRelay_str *relay;
#endif
// LCe OpenRG Hollande
UCHAR fxoState;
#define SI3050_ARRAY_SIZE (2*(NBE_ECHANT+RETARD_MESURE))
int si3050_volt[SI3050_ARRAY_SIZE];
int si3050_vmax = 0, si3050_ech_valid, si3050_pola_pos;
int si3050_OPE_cntr;
int si3050_volt_indice;
int si3050_5S;
int si3050_500ms;
UINT16 si3050_Cptr_time;
UINT16 si3050CurrentTimeSlot = 0;
UINT16 si3050_country[NUM_COUNTRY] =
{
  0x00c1, /* 0, 0, 0, 0, 0, 1,1, 0,0, 0,0,0,0 => USA */
  0x09c2,  /* 0, 1, 0, 0, 1, 1,1, 0,0, 0,0,1,0 => FRANCE */
  0x09c2,  /* 0, 1, 0, 0, 1, 1,1, 0,0, 0,0,1,0 => NETHERLANDS */
  0x09c2,  /* 0, 1, 0, 0, 1, 1,1, 0,0, 0,0,1,0 => POLAND */
  0x09c2,	/* 0, 1, 0, 0, 1, 1,1, 0,0, 0,0,1,0 	=> SPAIN		*/
  0x09c2 	/* 0, 1, 0, 0, 1, 1,1, 0,0, 0,0,1,0 	=> BELGIUM 		*/
};
unsigned char Flash_cptr;

#ifdef EPLD
#include <epld.h>
#endif

/***************************************************************************
 Function to write si3050 Direct Register.                            
***************************************************************************/
void si3050_writeReg(UCHAR address,UCHAR data)
{
  unsigned char dummy=0;

/* SAGEM -> [Hard V2] { */
  if( *(volatile UINT32*)0xb900003c == 0x6836) {
/* } */
    //Step 1: write the write-control word
    ASSERT_CHIPSELECT(2);
    spiInitOperation(0x20,&dummy);
    DEASSERT_CHIPSELECT(2);
    //Step 2: select the address of the register
    ASSERT_CHIPSELECT(2);
    spiInitOperation(address,&dummy);
    DEASSERT_CHIPSELECT(2);
    //Step 3: Write the value
    ASSERT_CHIPSELECT(2);
    spiInitOperation(data,&dummy);
    DEASSERT_CHIPSELECT(2);
  }
/* SAGEM -> [Hard V1] { */
  // For VOX150 and VOX200, FXO chip sel is made with EPLD, For Vox160 these function are redefined.
  else {
#ifdef EPLD
	//Step 1: write the write-control word
	epld_reg_flags_reset(EPLD_REG3, EPLD_SPI_CS_FXO_N);
	spiInitOperation(0x20,&dummy);
	epld_reg_flags_set(EPLD_REG3, EPLD_SPI_CS_FXO_N);

	//Step 2: select the address of the register
	epld_reg_flags_reset(EPLD_REG3, EPLD_SPI_CS_FXO_N);
	spiInitOperation(address,&dummy);
	epld_reg_flags_set(EPLD_REG3, EPLD_SPI_CS_FXO_N);

	//Step 3: Write the value
	epld_reg_flags_reset(EPLD_REG3, EPLD_SPI_CS_FXO_N);
	spiInitOperation(data,&dummy);
	epld_reg_flags_set(EPLD_REG3, EPLD_SPI_CS_FXO_N);
#else
	printk(	"%s: Bad Makefile configuration -> Missing EPLD define\n",
			__FUNCTION__);
#endif
  }
/* } */
}
/***************************************************************************
 Function to write si3050 Direct Register.                            
***************************************************************************/
UCHAR si3050_readReg(UCHAR address)
{
  unsigned char dummy=0,data;

/* SAGEM -> [Hard V2] { */
  if( *(volatile UINT32*)0xb900003c == 0x6836) {
/* } */
    //Step 1: write the read-control word
    ASSERT_CHIPSELECT(2);
    spiInitOperation(0x60,&dummy);
    DEASSERT_CHIPSELECT(2);
    //Step 2: select the address of the register
    ASSERT_CHIPSELECT(2);
    spiInitOperation(address,&dummy);
    DEASSERT_CHIPSELECT(2);
    //Step 3: Write the value
    ASSERT_CHIPSELECT(2);
    dummy = 0;
    spiInitOperation(dummy,&data);
    DEASSERT_CHIPSELECT(2);
  }
/* SAGEM -> [Hard V1] { */
  // For VOX150 and VOX200, FXO chip sel is made with EPLD
  else {
#ifdef EPLD
	//Step 1: write the read-control word
	epld_reg_flags_reset(EPLD_REG3, EPLD_SPI_CS_FXO_N);
	spiInitOperation(0x60,&dummy);
	epld_reg_flags_set(EPLD_REG3, EPLD_SPI_CS_FXO_N);

	//Step 2: select the address of the register
	epld_reg_flags_reset(EPLD_REG3, EPLD_SPI_CS_FXO_N);
	spiInitOperation(address,&dummy);
	epld_reg_flags_set(EPLD_REG3, EPLD_SPI_CS_FXO_N);

	//Step 3: Write the value
	epld_reg_flags_reset(EPLD_REG3, EPLD_SPI_CS_FXO_N);
	dummy = 0;
	spiInitOperation(dummy,&data);
	epld_reg_flags_set(EPLD_REG3, EPLD_SPI_CS_FXO_N);
#else
	printk(	"%s: Bad Makefile configuration -> Missing EPLD define\n",
			__FUNCTION__);
#endif
  }
/* } */
  return data;
}
/******************************************************************************
 *  Function to initialize SILAB FXO .                                        *
 ******************************************************************************/
int si3050_initialize(void)
{
  UINT16 country,i;
  UCHAR reg16, reg25, reg26, reg30;
/*
  UCHAR reg31;
*/
  confGetCountryOpts(&country);  
  /* Initialization of the codec as per 5.3 si3050 */
  /* Set all the registers to their reset value */
  si3050_writeReg(0,0x80);
  /* Give 1 ms delay */
  mdelay(2); 
  /* Write Register 26 */
  if(country != USA && country != FRANCE && country != NETHERLANDS && country != POLAND && country != SPAIN && country != BELGIUM)
  {
    DEBUG(PRINT("si3050 => Not configured for counteries other then FRANCE/USE\n"),
            DEBUG_EXCEPTION);
    return FAILURE;
  }
  /* By Default Connect FXO to 2nd FXS */
  si3050PCMSlotChange(1);
  /* PCM / SPI Mode Select */
  if(confGetPCMMode(0) == A_LAW)
    si3050_writeReg(33,0x20);
  else if(confGetPCMMode(0) == MU_LAW)
    si3050_writeReg(33,0x28);
  else 
    si3050_writeReg(33,0x38);
  /* Enable ISOcap */
  si3050_writeReg(6,0x00);
  mdelay(20);
  /* Sagem 20060120 - reg16, reg26, reg30, reg31 values fixed. */
  reg16 = 0x10;
  reg16 |= ( ( ( (1 << OHS_R16_6) & si3050_country[country]) >> OHS_R16_6) << 6);
  reg16 |= ( ( ( (1 << RZ_R16_1) & si3050_country[country]) >> RZ_R16_1 ) << 1);
  reg16 |= ( ( ( (1 << RT_R16_0) & si3050_country[country]) >> RT_R16_0 ) );

  reg26 =  ( ( ( (1 << ILIM_R26_1) & si3050_country[country]) >> ILIM_R26_1) << 1);
  reg26 |= ( ( ( (1 << DCV_R26_7) & si3050_country[country]) >> DCV_R26_7 ) << 7);
  reg26 |= ( ( ( (1 << DCV_R26_6) & si3050_country[country]) >> DCV_R26_6 ) << 6);
  reg26 |= ( ( ( (1 << DCV_R26_5) & si3050_country[country]) >> DCV_R26_5 ) << 5);
  reg26 |= ( ( ( (1 << DCV_R26_4) & si3050_country[country]) >> DCV_R26_4 ) << 4);

  reg30 =  ( ( ( (1 << DCV_R30_3) & si3050_country[country]) >> DCV_R30_3 ) << 3);
  reg30 |= ( ( ( (1 << DCV_R30_2) & si3050_country[country]) >> DCV_R30_2 ) << 2);
  reg30 |= ( ( ( (1 << DCV_R30_1) & si3050_country[country]) >> DCV_R30_1 ) << 1);
  reg30 |= ( ( ( (1 << DCV_R30_0) & si3050_country[country]) >> DCV_R30_0 ) );

/*  
  reg31 = 0xB2;  // Modified to +3.2dBm full scale
  reg31 |= ( ( ( (1 << OHS2_R31_3) & si3050_country[country]) >> OHS2_R31_3 ) << 3);
*/
// LCe OpenRG Hollande
#ifdef FIRMWARE_CONF_COUNTRY_NL
  si3050_writeReg(26,0xC0);
#else
  si3050_writeReg(26,reg26);
#endif
// LCe OpenRG Hollande

  si3050_writeReg(31,0xAA);
  si3050_writeReg(16,reg16);

// LCe OpenRG Hollande
#ifdef FIRMWARE_CONF_COUNTRY_NL
  // in case of HOLLANDE, set bit3 register 17 (OPE)
  si3050_writeReg(17,0x08);
#endif
// LCe OpenRG Hollande

  reg25 = si3050_readReg(25);
  /* Write the 3:0 value back, mask other bits. */
  si3050_writeReg(25,reg25 & 0xF);

  si3050_writeReg(30,reg30);

  /* Ring Validation Control */
  si3050_writeReg(22, 0x16);
  si3050_writeReg(23, 0x08);
  si3050_writeReg(24, 0x99);
  si3050_5S = DELAY_MESURE;
  si3050_500ms = DELAY_MESURE1;
  si3050_vmax = 0;
  for (i=0 ; i<SI3050_ARRAY_SIZE ; i++)
    si3050_volt[i++] = 0;
  si3050_volt_indice = 0;
  si3050_ech_valid = NO;
  si3050_pola_pos = 0;
  si3050_OPE_cntr = 0xFF;
  Flash_cptr = 0;

  /* Gain Control *
  si3050_writeReg(38,0x00); // Tx GAIN in dB
  si3050_writeReg(40,0x11); // Tx Gain in .1 dB
  si3050_writeReg(39,0x01); // Rx Gain in dB
  si3050_writeReg(41,0x07); // Rx Gain in .1 dB
*/



// LCe OpenRG Hollande
#ifdef FIRMWARE_CONF_COUNTRY_NL
  /* Gain Control  plan +5.5/-3.5 */
  si3050_writeReg(38,0x03);
  si3050_writeReg(40,0x05);
  si3050_writeReg(39,0x03);
  si3050_writeReg(41,0x02);
#else
  /* Gain Control - Sagem 20060120 */
  si3050_writeReg(38,0x00); // Tx GAIN in dB
  si3050_writeReg(40,0x05); // Tx Gain in .1 dB
  si3050_writeReg(39,0x06); // Rx Gain in dB
  si3050_writeReg(41,0x02); // Rx Gain in .1 dB
#endif
// LCe OpenRG Hollande

  /* Spark Quenching Control */ 
  si3050_writeReg(59, 0x00);
  fxoState = 0xFF;		/* no initial state */
  DEBUG(PRINT("FXO Initialized Successfully \n"), DEBUG_INFO);
  return SUCCESS;
}

/******************************************************************************
   Function to write the command to FXO.
 *****************************************************************************/ 
void si3050_cmd(int cmd)
{
  UCHAR value = si3050_readReg(5);
  switch(cmd)
  {
    case FXO_ONHOOK: /* ON HOOK FXO */
      value &= 0xfe;   
// LCe OpenRG Hollande
#ifdef FIRMWARE_CONF_COUNTRY_NL
      si3050_writeReg(17,0x08); // Disable Overload Proctect if is set before going off-hook
#endif
// LCe OpenRG Hollande
      break;

    case FXO_OFFHOOK: /* OFF HOOK FXO */
      value |= 0x01;
// LCe OpenRG Hollande
#ifdef FIRMWARE_CONF_COUNTRY_NL
      si3050_OPE_cntr = 4; // bit3 register 17 (OPE) should be set 30 ms later going on-hook
#endif
// LCe OpenRG Hollande
      break;

    case FXO_ONHM_ENA:
      value |= 0x08;  
      break;

    case FXO_ONHM_DIS:
      value  &= 0xF7; 
      break;
  }
  si3050_writeReg(5,value);

}

/****************************************************************************
   Poll si3050 for the FXO events.
****************************************************************************/

void si3050_isr(void)
{
  int value, i, no_voltage;
  int voltage, polarite;
  int somme;
  BOOL pola_echant_valid;
  
  /* cptr for dating FXO event and change state */
  si3050_Cptr_time++;


  /* test for flash hook */
  if (Flash_cptr != 0)
	{
	if (Flash_cptr == 1)
		{
		/* end of Flash hook */
		si3050_cmd (FXO_OFFHOOK);
		}
	Flash_cptr --;
	}

// LCe OpenRG Hollande
#ifdef FIRMWARE_CONF_COUNTRY_NL
switch (si3050_OPE_cntr)
	{
	case 0:
		si3050_writeReg(17,0x08);
		si3050_OPE_cntr = 0xFF;
		break;

	case 0xFF:
		break;

	default:
		si3050_OPE_cntr--;
		break;
	}
#endif
// LCe OpenRG Hollande

  /* Read DAA Control 1 register */
  value = si3050_readReg(5);
  /* Look for Ring Detect Signal */
  if( value & 0x4)
  {
    /* Start the counter for ring validation */
    /* 5.20 Ring Validation */
    si3050_5S = DELAY_MESURE;
    si3050_500ms = DELAY_MESURE1;
    switch(fxoState)
    {
      case FXO_LINE_FREE: 
      case FXO_LINE_BUSY:
      case FXO_LINE_INVERSE_POLARITY:
      case FXO_LINE_INVERSE_POLARITY_BUSY:
        /* RING valid signal Detected */
        dspipcReportFXOIndication(0,FXO_RING_1_ON_DETECT,si3050_Cptr_time);
	   DEBUG(PRINT("FXO state: FXO_RING_1_ON_DETECT\n"), DEBUG_SLIC);
        fxoState = FXO_RING_1_ON_DETECT;
        si3050_volt_indice = 0;
        si3050_ech_valid = NO;
        break;
      case FXO_RING_1_OFF_DETECT:
        dspipcReportFXOIndication(0,FXO_RING_2_ON_DETECT,si3050_Cptr_time);
	   DEBUG(PRINT("FXO state: FXO_RING_2_ON_DETECT\n"), DEBUG_SLIC);
        fxoState = FXO_RING_2_ON_DETECT;
        break;
      case FXO_RING_OFF_DETECT:
        dspipcReportFXOIndication(0,FXO_RING_ON_DETECT,si3050_Cptr_time);
	   DEBUG(PRINT("FXO state: FXO_RING_ON_DETECT\n"), DEBUG_SLIC);
        fxoState = FXO_RING_ON_DETECT;
        break;
    }
  }
  else 
  {
    switch(fxoState)
    {
      case FXO_RING_1_ON_DETECT:
        dspipcReportFXOIndication(0,FXO_RING_1_OFF_DETECT,si3050_Cptr_time);
	   DEBUG(PRINT("FXO state: FXO_RING_1_OFF_DETECT\n"), DEBUG_SLIC);
        fxoState = FXO_RING_1_OFF_DETECT;
        break;
      case FXO_RING_2_ON_DETECT:
      case FXO_RING_ON_DETECT:
        dspipcReportFXOIndication(0,FXO_RING_OFF_DETECT,si3050_Cptr_time);
	   DEBUG(PRINT("FXO state: FXO_RING_OFF_DETECT\n"), DEBUG_SLIC);
        fxoState = FXO_RING_OFF_DETECT;
        break; 
    }

    if (si3050_5S != 0)
	{
    	si3050_5S--;
	}
    else
    {
    /* Read Line Voltage only when no Ring signal */
    si3050_volt[si3050_volt_indice++] = (char)si3050_readReg(29);

    if(si3050_volt_indice == 2*(NBE_ECHANT+RETARD_MESURE))
	{
	si3050_volt_indice = 0;
	si3050_ech_valid = YES;
	}

	/* Find the line voltage polarity: bit seven of line voltage status */
	pola_echant_valid = NO;
	value = 0;
	if (si3050_volt_indice < 4)
		{
		for (i=(2*(NBE_ECHANT+RETARD_MESURE))-4 ; i<(2*(NBE_ECHANT+RETARD_MESURE)) ; i++)
			{
			if ((si3050_volt[i] & 0x80) != 0)
				value ++;
			if (si3050_volt[i] != 0)
				pola_echant_valid = TRUE;
			}
		}
	else
		{
		for (i=si3050_volt_indice-4 ; i<si3050_volt_indice ; i++)
			{
			if ((si3050_volt[i] & 0x80) != 0)
				value ++;
			if (si3050_volt[i] != 0)
				pola_echant_valid = TRUE;
			}
		}

	switch (value)
		{
		case 0: 		polarite =  1;  break;	/* positiv ligne status */
		case 4: 		polarite = -1;  break;	/* negativ ligne status */
		default: 		polarite =  0;  break;	/* no ligne status      */
		}
	if (pola_echant_valid == NO)
		polarite =  0;

	/* reference polarity */
	if ((si3050_ech_valid == YES) && (si3050_vmax > MIN_VOLTAGE_DROP) && (si3050_pola_pos == 0))
		si3050_pola_pos = polarite;

	/* filtered measurements of line voltage for parallel handset detection */
      somme = 0;
      no_voltage = YES;
      if (si3050_volt_indice < (NBE_ECHANT+RETARD_MESURE))
      {
        for (i=(NBE_ECHANT+RETARD_MESURE); i< (NBE_ECHANT+NBE_ECHANT+RETARD_MESURE) ; i++)
		{
		if (si3050_volt[i] != 0)
			no_voltage = NO;
		if ((si3050_volt[i] & 0x80) == 0)
			somme += si3050_volt[i];
		else
			somme += ~si3050_volt[i]+1;
		}
	}
	else
	{
	  for (i=0  ; i< NBE_ECHANT ; i++)
		{
		if (si3050_volt[i] != 0)
			no_voltage = NO;
		if ((si3050_volt[i] & 0x80) == 0)
			somme += si3050_volt[i];
		else
			somme += ~si3050_volt[i]+1;
		}
      }
	somme = somme / NBE_ECHANT;
	voltage = (char) somme;

	// so ...
	if (si3050_ech_valid == YES)
	{
	/* max voltage */
	if ( si3050_vmax < voltage)
		si3050_vmax = voltage;

	if ((no_voltage == YES) && (fxoState != FXO_LINE_OUT))
		{
          dspipcReportFXOIndication(0,FXO_LINE_OUT,si3050_Cptr_time);
		DEBUG(PRINT("FXO state: FXO_LINE_OUT\n"), DEBUG_SLIC);
          fxoState = FXO_LINE_OUT;
          si3050_vmax = 0;
		si3050_pola_pos = 0;
		}

	if ((no_voltage == NO) && (polarite != 0) && (si3050_pola_pos != 0))
        {
/* in case of troubleshooting with BUSY state, fix voltage value to maximum */
/*
#ifdef FIRMWARE_CONF_COUNTRY_SP
	si3050_vmax = voltage = 48; 
#endif
*/
	if ((fxoState != FXO_LINE_BUSY) && (si3050_pola_pos == polarite) && (voltage < (si3050_vmax - MIN_VOLTAGE_DROP)))
		{
		dspipcReportFXOIndication(0,FXO_LINE_BUSY,si3050_Cptr_time);
		fxoState = FXO_LINE_BUSY;
		DEBUG(PRINT("FXO state: FXO_LINE_BUSY\n"), DEBUG_SLIC);
		}

	if ((fxoState != FXO_LINE_FREE) && (si3050_pola_pos == polarite) && (voltage >= (si3050_vmax - MIN_VOLTAGE_DROP)))
		{
		dspipcReportFXOIndication(0,FXO_LINE_FREE,si3050_Cptr_time);
		fxoState = FXO_LINE_FREE;
		DEBUG(PRINT("FXO state: FXO_LINE_FREE\n"), DEBUG_SLIC);
		}

	if ((fxoState != FXO_LINE_INVERSE_POLARITY) && (si3050_pola_pos != polarite)&& (voltage >= (si3050_vmax - MIN_VOLTAGE_DROP)))
		{
				dspipcReportFXOIndication(0,FXO_LINE_INVERSE_POLARITY,si3050_Cptr_time);
// LCe OpenRG Hollande
#ifdef FIRMWARE_CONF_COUNTRY_NL
		if (fxoState == FXO_LINE_FREE)
			{ // FXS must be free state 
			if ((gaSlicInfo[0].slicOffTheHook == SLIC_ONHOOK) &&
			    (gaSlicInfo[0].ucSlicState == SLIC_NORING_ONHOOK))

				{
//FCLUZEAU
				//relay_cmd(RELAY_PSTN);
				if(relay)
					{
					relay->cb(RELAY_PSTN);
					DEBUG(PRINT("---FXO_Q23_INCALL---\n"), DEBUG_SLIC);
					// Q23 incoming call
					dspipcReportFXOIndication(0,FXO_Q23_INCALL,si3050_Cptr_time);
					}
				}
			else
				{
				dspipcReportFXOIndication(0,FXO_LINE_INVERSE_POLARITY,si3050_Cptr_time);
				DEBUG(PRINT("---FXO_LINE_INVERSE_POLARITY---\n"), DEBUG_SLIC);
				}
			}
#endif
// LCe OpenRG Hollande
		fxoState = FXO_LINE_INVERSE_POLARITY;
		DEBUG(PRINT("FXO state: FXO_LINE_INVERSE_POLARITY\n"), DEBUG_SLIC);
		}

	if ((fxoState != FXO_LINE_INVERSE_POLARITY_BUSY) && (si3050_pola_pos != polarite)&& (voltage < (si3050_vmax - MIN_VOLTAGE_DROP)))
		{
		fxoState = FXO_LINE_INVERSE_POLARITY_BUSY;
		dspipcReportFXOIndication (0,FXO_LINE_INVERSE_POLARITY_BUSY,si3050_Cptr_time);
		DEBUG(PRINT("FXO state: FXO_LINE_INVERSE_POLARITY_BUSY\n"), DEBUG_SLIC);
          	}
        }
      }
    }
  }
}

/************************************************************************************
  Function to program time slots. It is required when we have 2 FXSs and we want to
  connect FXO to any of the FXS.
 ***********************************************************************************/ 
void si3050PCMSlotChange(UCHAR ucFXSPort)
{
  UINT16 timeSlot = 40;
  /* Program Time Slots DSP Time Slot ==> 104/18 */
  if(ucFXSPort == 0)
  {
    if(confGetPCMMode(0) == LINEAR)
      timeSlot = 128;
    else
      timeSlot = 64;
  }
  else if(ucFXSPort == 1)
  {
    if(confGetPCMMode(0) == LINEAR)
      timeSlot = 80;
    else
      timeSlot = 40;
  }
  if(si3050CurrentTimeSlot != timeSlot)
    si3050CurrentTimeSlot = timeSlot;
  else 
    return;
  si3050_writeReg(34,timeSlot);
  si3050_writeReg(35,0);
  si3050_writeReg(36,timeSlot);
  si3050_writeReg(37,0);
}

int si3050_getFXOState(void)
{
  return fxoState;
}


void si3050_reset_polarity(void)
{
printk("si3050_reset_polarity\n");
si3050_pola_pos = 0;
}

/* command for generate flash hook on FXO */
void si3050_FlashHook(unsigned char delay)
{
if (delay == 0xFF)
	delay -= 1;
si3050_cmd (FXO_ONHOOK);
Flash_cptr = delay + 1;
}

#endif
