#include <linux/module.h>
#include <linux/tty.h>
#include <linux/proc_fs.h>
#include <asm/uaccess.h>
#include <oswrapper.h>

#include "include/slic_proc.h"
#include "../../include/voicelib.h"

// name for the file;
#define tone_proc_filename "tone"

unsigned char tone_val;

static struct proc_dir_entry * tone_dir_entry; // procfs filename 

extern void writeDirectReg(unsigned char codecNo, unsigned char address, unsigned char data);

//***********************************************************************
static int tone_procfs_write (struct file * file, const char * buffer, unsigned long count, void * data)
{
	char * offset;
	int r, n, i, port;
	char cmdbuf [40];  // this is too much, but that's ok at least
	VoiceOptions voiceOpts;
	unsigned char play_tone;


    // warning data comes from userland !
    for (i=0 ; i>40 ; i++) 
		cmdbuf[i] = 0;
    
    if ( count > 39 ) return -EFAULT;

    if (copy_from_user (cmdbuf, buffer, count))
    {
	printk("SLIC: tone can't get copy_from_user !!\n");
	return -EFAULT;
    }

	offset = strstr(cmdbuf, "tone");
	if (offset)
	{

	n = sscanf(offset+4, "%d", &port);
	if ((port!= 0) && (port!=1) )
		{
	printk ("# Use 'echo tone x N > tone' where x is the port number and N is the number of the tone\n");
	printk ("# Use 'echo tone x > tone' for quit tone, where x is the port number\n");
		return -EFAULT;
		}

	n = sscanf(offset+6, "%d", &r);
	if (n != 1) 
		{
		/* stop tone or ringing */
		if (tone_val != 0xFF)
			{
			slicRingOff(port);
//  			osLockInterrupts();
//        		writeDirectReg(port, 50, 0x60); // Ringing Inactive Timer = 125uS * 0x6D60 = 3.5S
//        		writeDirectReg(port, 51, 0x6D);
//  			osUnlockInterrupts();

			dspipcQuitTone(port,r);
			tone_val = 0xFF;
			return count;
			}
		return -EFAULT;
		}

play_tone = YES;
switch (r)
	{
	default: play_tone = NO; printk("Unknow TONE %d \n",r); break;

	case DIAL_TONE : 					printk (" Play DIAL_TONE\n"); break;
	case CALL_IN_PROGRESS_TONE : 			printk (" Play CALL_IN_PROGRESS_TONE\n"); break;
	case RING_BACK_TONE : 				printk (" Play RING_BACK_TONE\n"); break;
	case BUSY1_TONE : 					printk (" Play BUSY1_TONE\n"); break;
	case ERROR_TONE : 					printk (" Play ERROR_TONE\n"); break;
	case OFFHOOK_WARNING_TONE : 			printk (" Play OFFHOOK_WARNING_TONE\n"); break;
	case MESG_WAITING_INDICATOR_TONE : 	printk (" Play MESG_WAITING_INDICATOR_TONE\n"); break;
	case CALL_WAITING_TONE1 : 			printk (" Play CALL_WAITING_TONE1\n"); break;
	case CPE_ALERTING_TONE : 			printk (" Play CPE_ALERTING_TONE\n"); break;
	case VOIP_DIAL_TONE : 				printk (" Play VOIP_DIAL_TONE\n"); break;
	case VOIP_MESG_WAITING_INDICATOR_TONE : printk (" Play VOIP_MESG_WAITING_INDICATOR_TONE\n"); break;

	case DIG_0_TONE : 		printk (" Play DIG_0_TONE\n"); break;
	case DIG_1_TONE : 		printk (" Play DIG_1_TONE\n"); break;
	case DIG_2_TONE : 		printk (" Play DIG_2_TONE\n"); break;
	case DIG_3_TONE : 		printk (" Play DIG_3_TONE\n"); break;
	case DIG_4_TONE : 		printk (" Play DIG_4_TONE\n"); break;
	case DIG_5_TONE : 		printk (" Play DIG_5_TONE\n"); break;
	case DIG_6_TONE : 		printk (" Play DIG_6_TONE\n"); break;
	case DIG_7_TONE : 		printk (" Play DIG_7_TONE\n"); break;
	case DIG_8_TONE : 		printk (" Play DIG_8_TONE\n"); break;
	case DIG_9_TONE : 		printk (" Play DIG_9_TONE\n"); break;
	case DIG_A_TONE : 		printk (" Play DIG_A_TONE\n"); break;
	case DIG_B_TONE : 		printk (" Play DIG_B_TONE\n"); break;
	case DIG_C_TONE : 		printk (" Play DIG_C_TONE\n"); break;
	case DIG_D_TONE : 		printk (" Play DIG_D_TONE\n"); break;
	case DIG_STAR_TONE : 	printk (" Play DIG_STAR_TONE\n"); break;
	case DIG_HASH_TONE : 	printk (" Play DIG_HASH_TONE\n"); break;

	case 46 : 			printk (" Ringing Phone\n"); break;
	}

if (play_tone == YES)
	{
	if (r != 46 )
		{
		/* apply tone */
		tone_val = r;
//		memset(&voiceOpts,0,sizeof(voiceOpts));
//		voiceOpts.encoder_opt[0] = 0x8d00;
//		voiceOpts.decoder_opt[0] = 0x8c80;
//		dspipcInitPort(port,&voiceOpts);
		dspipcGenTone (port, r, 0);
		}
	else
		{
		/* apply ringing */
		tone_val = r;
//		osLockInterrupts();
//		writeDirectReg(port, 50, 0); // Ringing Inactive Timer = 0S
//		writeDirectReg(port, 51, 0);
//		osUnlockInterrupts();

		slicRing (port);
		}
	}
	else
		{
		printk ("# Use 'echo tone x N > tone' where x is the port number and N is the number of the tone\n");
		printk ("# Use 'echo tone x > tone' for quit tone, where x is the port number\n");
		printk ("#  0: DIAL_TONE\n");
		printk ("#  1: RING_BACK_TONE\n");
		printk ("#  2: BUSY1_TONE\n");
		printk ("#  3: ERROR_TONE\n");
		printk ("#  4: CALL_WAITING_TONE1\n");
		printk ("#  7: OFFHOOK_WARNING_TONE\n");
		printk ("# 14: DIG_0_TONE\n");
		printk ("# 15: DIG_1_TONE\n");
		printk ("# 16: DIG_2_TONE\n");
		printk ("# 17: DIG_3_TONE\n");
		printk ("# 18: DIG_4_TONE\n");
		printk ("# 19: DIG_5_TONE\n");
		printk ("# 20: DIG_6_TONE\n");
		printk ("# 21: DIG_7_TONE\n");
		printk ("# 22: DIG_8_TONE\n");
		printk ("# 23: DIG_9_TONE\n");
		printk ("# 24: DIG_A_TONE\n");
		printk ("# 25: DIG_B_TONE\n");
		printk ("# 26: DIG_C_TONE\n");
		printk ("# 27: DIG_D_TONE\n");
		printk ("# 28: DIG_STAR_TONE\n");
		printk ("# 29: DIG_HASH_TONE\n");
		printk ("# 30: CPE_ALERTING_TONE\n");
		printk ("# 33: CALL_IN_PROGRESS_TONE\n");
		printk ("# 38: MESG_WAITING_INDICATOR_TONE\n");
		printk ("# 41: VOIP_DIAL_TONE\n");
		printk ("# 42: VOIP_MESG_WAITING_INDICATOR_TONE\n");
		printk ("# 46: RINGING \n");
		}
	return count;
	}
else 
	{
	offset = strstr(cmdbuf, "gain");
	if (offset)
		{
		n = sscanf(offset+4, "%d", &port);
		if ((port!= 0) && (port!=1) )
			{
			printk ("# Use 'echo gain x N > gain' where x is the port number and N is the level\n");
			printk ("# Level: 0 (very soft), 1 (soft), 2 (no change) 3 (loud), 4 (very loud)\n");
			return -EFAULT;
			}

		n = sscanf(offset+6, "%d", &r);
		if (n == 1)
			{
			switch(r)
				{
				case 0:
				case 1:
				case 2:
				case 3:
				case 4:
					si3216_gain_ctrl(port,r);
					break;
				default:
					return -EFAULT;
					break;
				}
			}
		return count;
		}
	else
		{
		printk ("# Use 'echo tone x N > tone' where x is the port number and N is the number of the tone\n");
		printk ("# Use 'echo tone x > tone' for quit tone, where x is the port number\n");

		printk ("# \n  or\n \n");

		printk ("# Use 'echo gain x N > gain' where x is the port number and N is the level\n");
		printk ("# Level: 0 (very soft), 1 (soft), 2 (no change) 3 (loud), 4 (very loud)\n");
		return -EFAULT;
		}
	}
}
//***********************************************************************
int tone_procfs_read(char * buff, char **buffchar, off_t offset, int buffer_length, int * eof, void * data)
{
return -EFAULT;
}



//***********************************************************************
// Called to init the procfs ( to create a file ... in the proc) 
int tone_proc_init(void)
{
    tone_dir_entry = create_proc_entry(tone_proc_filename, 0644, proc_bus_spi_slic);
    if (!tone_dir_entry)
    {
	printk("SLIC : can't create tone proc entry\n");
	return 1;
    }

    tone_dir_entry->read_proc = tone_procfs_read;
    tone_dir_entry->write_proc = tone_procfs_write;
    tone_dir_entry->owner = THIS_MODULE;
    tone_dir_entry->mode = S_IFREG | 0644;
    tone_dir_entry->uid = 0;
    tone_dir_entry->gid = 0;
    tone_dir_entry->size = 2305; // change the file size !! 
    
	tone_val = 0xFF;
    return 0;
}

// Called to cleanup the module procfs entry
void slic_tone_proc_cleanup(void)
{
    remove_proc_entry(tone_proc_filename, proc_bus_spi_slic);
}
